/* -*- Mode: C -*-
 * mail sorter check program 
 * starts the by_sort1 program
 * and checks if it satisfies some properties
 *
 */

load "../library/conversion".
load "../library/exprog".
load "../library/tcl".

/* tcl by_sort1 */
/* prog by_sort1 0 */

set print_states = false.

define dtype=["delay0","delay1","delay2","delay3","delay4"].

define dname=["delay0","Delay4","Delay3A","Delay3B","DelayF"].

define check_solenoid(X,Y,Z) = {
   get(X) and 
   if avar(X)="solon" then {
    if  strint(aval(X))=Y and Z=1 then
     format("!%d:: Solenoid %d ON: Pass\n", atime(X), Y)
    else
     format("!%d:: Solenoid %d: Fail Prog %d and Real %d\n",atime(X), Y, strint(aval(X)), Z)
   }
   else {
    if avar(X)="soloff" then {
     if  strint(aval(X))=Y and Z=0 then 
      format("!%d:: Solenoid %d OFF: Pass\n",atime(X), Y)
     else 
      format("!%d:: Solenoid %d: Fail Prog %d and Real %d\n",atime(X), Y, strint(aval(X)), Z) 
    }
    else 
     format("!%d:: Solenoid %d: Wrong input received %s\n",atime(X), Y, aval(X))
  }
}.

define check_class_sensor(X,Y) = {
   get(X) and 
   if avar(X)="class" then {
    if strint(aval(X))=Y then
     format("!%d:: Class sensor %d: Pass\n",atime(X), Y)
    else
     format("!%d:: Class sensor: Fail Prog %d and Real %d\n",atime(X), strint(aval(X)), Y)
   }
   else format("!%d:: Class sensor: %d Wrong input received %s\n",atime(X), Y, aval(X))
}.

define check_letter_sensor(X,Y) = {
   get(X) and 
   if avar(X)="lsens" then {
    if strint(aval(X))=Y then
     format("!%d:: Letter sensor %d: Pass\n",atime(X), Y)
    else
     format("!%d:: Letter sensor: Fail Prog %d and Real %d\n",atime(X), strint(aval(X)), Y)
   }
   else
    format("!%d:: Letter sensor: %d Wrong input received %s\n",atime(X), Y, aval(X))
}.

define check_delay(X,Y,Z) = {
   get(X) and 
   if avar(X)=dtype[Z] then {
    if strint(aval(X))=Y then {
     if Y=0 then
      format("!%d:: %s: Start\n",atime(X), dname[Z])
     else
      format("!%d:: %s: End\n",atime(X), dname[Z])
    }
    else
     format("!%d:: %s: Prog %d and Real %d\n",atime(X), dname[Z], strint(aval(X)), Y)
   }
   else
    format("!%d:: %s: Wrong input received %s\n",atime(X), dtype[Z], aval(X))
}.

define check_delay_time(X,Y,Z,D) = {
    if X=Y-Z then
     format("!%d:: %s %d: Pass\n",Y, dname[D],X)
    else
     format("!%d:: %s: Fail Prog %d and Real %d\n",Y, dname[D], Y-Z, X)
}.
        
define check_class(X,Time,Letter,Class,Z,C) = {
     no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showclasssensor",[Class,atime(X)]) and check_class_sensor(X,Class)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}  
}.

define check_solenoidfour(X,Time,Letter,Class,Z,C,sol) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showsolefour",[sol,atime(X)]) and check_solenoid(X,4,sol)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.

define check_delayfour(X,Time,Letter,Class,Z,C) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelayfour",[0,atime(X)]) and check_delay(X,0,1)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)};
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelayfour",[1,atime(X)]) and check_delay(X,1,1) and
          check_delay_time(delay4,atime(X),Time,1)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.

define check_delayF(X,Time,Letter,Class,Z,C) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelayF",[0,atime(X)]) and check_delay(X,0,4)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)};
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelayF",[1,atime(X)]) and check_delay(X,1,4) and
          check_delay_time(delayF,atime(X),Time,4)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.

define check_delaythreeA(X,Time,Letter,Class,Z,C) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelaythreeA",[0,atime(X)]) and check_delay(X,0,2)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)};
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelaythreeA",[1,atime(X)]) and check_delay(X,1,2) and
          check_delay_time(delay3A,atime(X),Time,2)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.

define check_solenoidthree(X,Time,Letter,Class,Z,C,sol) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showsolethree",[sol,atime(X)]) and check_solenoid(X,3,sol)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.

define check_delaythreeB(X,Time,Letter,Class,Z,C) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelaythreeB",[0,Z,atime(X)]) and check_delay(X,0,3)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)};
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showdelaythreeB",[1,Z,atime(X)]) and check_delay(X,1,3) and
          check_delay_time(delay3B,atime(X),Time,3)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.
define check_letter_1(C,Time,Letter,Class,Z) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showlettersensor",[Letter,atime(X)]) and
         check_letter_sensor(X,Letter)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)}
}.
define check_letter(C,Time,Letter,Class,Z) = {
    no_ch_5(Time,Letter,Class,Z,C);
    {tcl("showlettersensor",[Letter,atime(X)]) and
         check_letter_sensor(X,Letter)};
    {Time:=atime(X) and no_ch_4(Letter,Class,Z,C)};
    {no_ch_4(Time,Letter,Class,Z) and C:=C+if Letter=0 then 1 else 0 }
}.

define on  = 1.
define off = 0.
define delay4  = 70.
define delay3A = 70.
define delay3B = 80.
define delayF  = 250.

/* run */ define test() = {
  exists X,Time,Letter,Class,Z,C : {
    
    tcl("init", [1,2,3]) and
    always tclbreak() and
    { prog_send(  1); 
      prog_send( delay4);
      prog_send( delay3A); 
      prog_send( delay3B);
      prog_send( delayF);
      { tcl("showsolethree",[off,atime(X)]) and
        tcl("showsolefour",[on,atime(X)]) and check_solenoid(X,4,on)};
      { skip and Z:=1 and C:=1 and Time:=0 and Class:=0 and Letter:=2};
      while C<3 do {
       { Class:=0 and Letter:=2 and no_ch_3(Time,Z,C) };
       check_class(X,Time,Letter,Class,Z,C);   
       check_letter_1(C,Time,Letter,Class,Z);
       { Class:=(1 + (random mod 2)) and no_ch_4(Time,Letter,Z,C)};
       { /*tcl("showclasssensor",[0]) and
           tcl("showlettersensor",[2]) and*/
         prog_send(Class)};
       check_class(X,Time,Letter,Class,Z,C);
       check_solenoidfour(X,Time,Letter,Class,Z,C,off);
       check_delayfour(X,Time,Letter,Class,Z,C);
       check_solenoidfour(X,Time,Letter,Class,Z,C,on);
       check_delayF(X,Time,Letter,Class,Z,C);
       {(Letter:=random mod 2) and no_ch_4(C,Time,Class,Z)};
       {prog_send(Letter)};
       check_letter(C,Time,Letter,Class,Z);
       if Class=1 then {
           if Z=0 then {
             check_delaythreeA(X,Time,Letter,Class,Z,C);
             check_solenoidthree(X,Time,Letter,Class,Z,C,off);
             check_delaythreeB(X,Time,Letter,Class,Z,C);
             {no_ch_4(C,Time,Letter,Class) and Z:=1} 
           } else {
             {tcl("showdelay",[Z]) and no_ch_5(Time,Letter,Class,Z,C)};
             {tcl("noshowdelay",[Z]) and no_ch_5(Time,Letter,Class,Z,C)} 
           }
       } else {
           if Z=1 then {
             check_delaythreeA(X,Time,Letter,Class,Z,C);
             check_solenoidthree(X,Time,Letter,Class,Z,C,on);
             check_delaythreeB(X,Time,Letter,Class,Z,C);
             {no_ch_4(C,Time,Letter,Class) and Z:=0}
           } else {
             {tcl("showdelay",[Z]) and no_ch_5(Time,Letter,Class,Z,C)};
             {tcl("noshowdelay",[Z]) and no_ch_5(Time,Letter,Class,Z,C)} 
           }
       }
      }
    }  
  }
}.





