/* -*- Mode: C -*-
 * extended mail sorter check program 
 * starts the by_sort1a program
 * and checks if it satisfies some properties
 *
 */

load "../library/conversion".
load "../library/exprog".
load "../library/tcl".

/* tcl by_sort1a */
/* prog by_sort1a 0 */

set print_states = false.
define dtype=["delay0","delay1","delay2","delay3","delay4","delay5","delay6","delay7","delay8"].

define dname=["delay0","Delay4","Delay3A","Delay3B","DelayF","Delay6","Delay5A","Delay5B","DelayFa"].

define check_solenoid(X,Y,Z) = {
   get(X) and 
   if avar(X)="solon" then {
    if  strint(aval(X))=Y and Z=1 then
     format("!%d:: Solenoid %d ON: Pass\n", atime(X), Y)
    else
     format("!%d:: Solenoid %d: Fail Prog %d and Real %d\n",atime(X), Y, strint(aval(X)), Z)
   }
   else {
    if avar(X)="soloff" then {
     if  strint(aval(X))=Y and Z=0 then 
      format("!%d:: Solenoid %d OFF: Pass\n",atime(X), Y)
     else 
      format("!%d:: Solenoid %d: Fail Prog %d and Real %d\n",atime(X), Y, strint(aval(X)), Z) 
    }
    else 
     format("!%d:: Solenoid %d: Wrong input received %s\n",atime(X), Y, aval(X))
  }
}.


define check_air_sensor(X,Y) = {
   get(X) and
   if avar(X)="air" then {
    if strint(aval(X))=Y then 
     format("!%d:: Air sensor %d: Pass\n",atime(X), Y)
    else 
     format("!%d:: Air sensor: Fail Prog %d and Real %d\n",atime(X), strint(aval(X)),Y)
   }
   else 
    format("!%d:: Air sensor: %d Wrong input received %s\n",atime(X), Y, aval(X))
}.

define check_class_sensor(X,Y) = {
   get(X) and 
   if avar(X)="class" then {
    if strint(aval(X))=Y then
     format("!%d:: Class sensor %d: Pass\n",atime(X), Y)
    else
     format("!%d:: Class sensor: Fail Prog %d and Real %d\n",atime(X), strint(aval(X)), Y)
   }
   else format("!%d:: Class sensor: %d Wrong input received %s\n",atime(X), Y, aval(X))
}.

define check_letter_sensor(X,Y) = {
   get(X) and 
   if avar(X)="lsens" then {
    if strint(aval(X))=Y then
     format("!%d:: Letter sensor %d: Pass\n",atime(X), Y)
    else
     format("!%d:: Letter sensor: Fail Prog %d and Real %d\n",atime(X), strint(aval(X)), Y)
   }
   else
    format("!%d:: Letter sensor: %d Wrong input received %s\n",atime(X), Y, aval(X))
}.

define check_delay(X,Y,Z) = {
   get(X) and 
   if avar(X)=dtype[Z] then {
    if strint(aval(X))=Y then {
     if Y=0 then
      format("!%d:: %s: Start\n",atime(X), dname[Z])
     else
      format("!%d:: %s: End\n",atime(X), dname[Z])
    }
    else
     format("!%d:: %s: Prog %d and Real %d\n",atime(X), dname[Z], strint(aval(X)), Y)
   }
   else
    format("!%d:: %s: Wrong input received %s\n",atime(X), dtype[Z], aval(X))
}.


define check_delay_time(X,Y,Z,D) = {
    if X=Y-Z then
     format("!%d:: %s %d: Pass\n",Y, dname[D],X)
    else
     format("!%d:: %s: Fail Prog %d and Real %d\n",Y, dname[D], Y-Z, X)
}.

define check_air(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showairsensor",[Air,atime(X)]) and check_air_sensor(X,Air)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_class(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showclasssensor",[Class,atime(X)]) and check_class_sensor(X,Class)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}  
}.

define check_solenoidfour(X,Time,Air,Letter,Class,Z,W,C,sol) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showsolefour",[sol,atime(X)]) and check_solenoid(X,4,sol)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delayfour(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelayfour",[0,atime(X)]) and check_delay(X,0,1)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelayfour",[1,atime(X)]) and check_delay(X,1,1) and
          check_delay_time(delay4,atime(X),Time,1)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delayF(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelayF",[0,atime(X)]) and check_delay(X,0,4)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelayF",[1,atime(X)]) and check_delay(X,1,4) and
          check_delay_time(delayF,atime(X),Time,4)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delaythreeA(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelaythreeA",[0,atime(X)]) and check_delay(X,0,2)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelaythreeA",[1,atime(X)]) and check_delay(X,1,2) and
          check_delay_time(delay3A,atime(X),Time,2)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_solenoidthree(X,Time,Air,Letter,Class,Z,W,C,sol) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showsolethree",[sol,atime(X)]) and check_solenoid(X,3,sol)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delaythreeB(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelaythreeB",[0,Z,atime(X)]) and check_delay(X,0,3)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showdelaythreeB",[1,Z,atime(X)]) and check_delay(X,1,3) and
          check_delay_time(delay3B,atime(X),Time,3)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delayfiveA(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayfiveA",[0,atime(X)]) and check_delay(X,0,6)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayfiveA",[1,atime(X)]) and check_delay(X,1,6) and
          check_delay_time(delay5A,atime(X),Time,6)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.


define check_solenoidfive(X,Time,Air,Letter,Class,Z,W,C,sol) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showsolefive",[sol,atime(X)]) and check_solenoid(X,5,sol)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_solenoidsix(X,Time,Air,Letter,Class,Z,W,C,sol) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
         {tcl("showsolesix",[sol,atime(X)]) and check_solenoid(X,6,sol)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delaysix(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelaysix",[0,atime(X)]) and check_delay(X,0,5)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelaysix",[1,atime(X)]) and check_delay(X,1,5) and
          check_delay_time(delay6,atime(X),Time,5)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_delayFa(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayFa",[0,atime(X)]) and check_delay(X,0,8)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayFa",[1,atime(X)]) and check_delay(X,1,8) and
          check_delay_time(delayFa,atime(X),Time,8)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.


define check_delayfiveB(X,Time,Air,Letter,Class,Z,W,C) = {
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayfiveB",[0,W,atime(X)]) and check_delay(X,0,7)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    no_ch_7(Time,Air,Class,Letter,Z,W,C);
    {tcl("showdelayfiveB",[1,W,atime(X)]) and check_delay(X,1,7) and
          check_delay_time(delay5B,atime(X),Time,7)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_letter_1(C,Time,Air,Letter,Class,Z,W) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showlettersensor",[Letter,atime(X)]) and
         check_letter_sensor(X,Letter)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)}
}.

define check_letter(C,Time,Air,Letter,Class,Z,W) = {
    no_ch_7(Time,Air,Letter,Class,Z,W,C);
    {tcl("showlettersensor",[Letter,atime(X)]) and
         check_letter_sensor(X,Letter)};
    {Time:=atime(X) and no_ch_6(Air,Letter,Class,Z,W,C)};
    {no_ch_6(Time,Air,Letter,Class,Z,W) and C:=C+if Letter=0 then 1 else 0 }
}.

define on  = 1.
define off = 0.
define delay4  = 50.
define delay3A = 50.
define delay3B = 60.
define delayF  = 90.
define delay6  = 50.
define delay5A = 50.
define delay5B = 60.
define delayFa = 50.


/* run */ define test() = {
  exists X,Time,Letter,Air,Class,Z,W,C : {

    tcl("init", [1,2,3]) and
    always tclbreak() and
    { prog_send(  1);
      prog_send( delay4);
      prog_send( delay3A); 
      prog_send( delay3B);
      prog_send( delayF);
      prog_send( delay6);
      prog_send( delay5A); 
      prog_send( delay5B);
      prog_send( delayFa);
     { tcl("showsolefive",[off,atime(X)]) and
       tcl("showsolefour",[on,atime(X)]) and check_solenoid(X,4,on)};
     skip;
     { tcl("showsolethree",[off,atime(X)]) and
       tcl("showsolesix",[on,atime(X)]) and check_solenoid(X,6,on)};
     { skip and Z:=1 and W:=1 and C:=1 and Time:=0 and Air:=2 and
         Class:=0 and Letter:=2};
    while C<3 do {
     { Air:=2 and Class:=0 and Letter:=2 and no_ch_4(Time,Z,W,C) };
     check_air(X,Time,Air,Letter,Class,Z,W,C);
     check_letter_1(C,Time,Air,Letter,Class,Z,W);
     check_class(X,Time,Air,Letter,Class,Z,W,C);
     { Air:=(random mod 2) and no_ch_6(Time,Class,Letter,Z,W,C)};
     { /*tcl("showairsensor",[2]) and
       tcl("showlettersensor",[2]) and
       tcl("showclasssensor",[0]) and*/
       prog_send(Air)};
     check_air(X,Time,Air,Letter,Class,Z,W,C);
     check_solenoidfour(X,Time,Air,Letter,Class,Z,W,C,off);
     check_delayfour(X,Time,Air,Letter,Class,Z,W,C);
     check_solenoidfour(X,Time,Air,Letter,Class,Z,W,C,on);
     check_delayF(X,Time,Air,Letter,Class,Z,W,C);
     {(Letter:=random mod 2) and no_ch_6(Time,Air,Class,Z,W,C)};
     {prog_send(Letter)};
     check_letter(C,Time,Air,Letter,Class,Z,W);
     if Air=1 then {
      if W=0 then {
       check_delayfiveA(X,Time,Air,Letter,Class,Z,W,C);
       check_solenoidfive(X,Time,Air,Letter,Class,Z,W,C,off);
       check_delayfiveB(X,Time,Air,Letter,Class,Z,W,C);        
       {no_ch_6(Time,Air,Class,Letter,Z,C) and W:=1}
      } else {
        {tcl("showdelay",[W]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)};
        {tcl("noshowdelay",[W]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)}
      }
     } else {
      if W=1 then {
       check_delayfiveA(X,Time,Air,Letter,Class,Z,W,C);
       check_solenoidfive(X,Time,Air,Letter,Class,Z,W,C,on);
       check_delayfiveB(X,Time,Air,Letter,Class,Z,W,C); 
       {no_ch_6(Time,Air,Class,Letter,Z,C) and W:=0}
      } else {
        check_delayfiveA(X,Time,Air,Letter,Class,Z,W,C);
        check_delayfiveB(X,Time,Air,Letter,Class,Z,W,C)   
      };
      {Class:=(1 + (random mod 2)) and no_ch_6(Time,Air,Letter,Z,W,C)};
      {prog_send(Class)};
      check_class(X,Time,Air,Letter,Class,Z,W,C);
      check_solenoidsix(X,Time,Air,Letter,Class,Z,W,C,off);
      check_delaysix(X,Time,Air,Letter,Class,Z,W,C);
      check_solenoidsix(X,Time,Air,Letter,Class,Z,W,C,on);
      check_delayFa(X,Time,Air,Letter,Class,Z,W,C);
      if Class=1 then {
       if Z=0 then {
        check_delaythreeA(X,Time,Air,Letter,Class,Z,W,C);
        check_solenoidthree(X,Time,Air,Letter,Class,Z,W,C,off);
        check_delaythreeB(X,Time,Air,Letter,Class,Z,W,C);
        {no_ch_6(Time,Air,Class,Letter,W,C) and Z:=1}
       } else {
        {tcl("cshowdelay",[Z]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)};
        {tcl("cnoshowdelay",[Z]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)} 
       }
      } else {
       if Z=1 then {   
        check_delaythreeA(X,Time,Air,Letter,Class,Z,W,C);
        check_solenoidthree(X,Time,Air,Letter,Class,Z,W,C,on);
        check_delaythreeB(X,Time,Air,Letter,Class,Z,W,C);
        {no_ch_6(Time,Air,Class,Letter,W,C) and Z:=0}
       } else {
         {tcl("cshowdelay",[Z]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)};
         {tcl("cnoshowdelay",[Z]) and no_ch_7(Time,Air,Class,Letter,Z,W,C)} 
       }
     }
    }
    }
  }    
 }
}.
