/* -*- Mode: C -*-                              
 * ep3-L.t --- 3-stage tree algorithm with STACK
 *                                modelled after ep3.
 */

load "mcache".

define dest(N) = {
  if N=[] then 0
  else if |N|=1 then 1
  else 2
}.

define inst1(N) = { N }.

define inst2l(N) = { [N[0]] }.

define inst2r(N) = { [N[1]] }.

define pr2(L) =
{
  if L=[] then []
  else [L[0][0]]+pr2(L[1..|L|])
}.

define prb(L) = 
{
  if L=[] then "bubble"
  else L
}.

define pipe_0(Py,Zilock,Iy,Stop) = {
  always( 
   if Stop then {Zilock=0 and empty} else
   if Zilock=1 then Iy:=Iy
        else Iy:= mcache(Py)  )
}.

define pipe_1(Iy,Zilock,Index,My,Stop) = {
  always( 
    if Stop then empty else 
    if dest(Iy) = 0 then 
       { Zilock = 0 and
         My:=[] and
         Index:=0
       }
       else if dest(Iy)=1 then
       { Zilock = 0 and
         My:=inst1(Iy) and
         Index:=0
       }
       else if Index = 0 then
       { Zilock=1 and
         My:=inst2l(Iy) and
         Index:=1
       }
       else
       { Zilock = 0 and
         My:=inst2r(Iy) and
         Index:=0
       }
    )
}.

define pipe_s(My,Zilock,L,Py,Stop) = {
  always( 
   if Stop then empty else 
   if Zilock=0 then  
    if My=[] then 
     if L=[] then { Py:=[]  and L:= L }
     else { Py:=L[0] and L:= L[1..|L|] }
    else { Py:=My and L:=L }
   else if My=[] then { Py:=Py and L:=L }
        else { Py:=Py and L:=[My]+L }
   )    
}.

define pipe_q(My,Zilock,L,Py,Stop) = {
  always( 
   if Stop then empty else 
   if Zilock=0 then  
    if My=[] then 
     if L=[] then { Py:=[]  and L:= L }
     else { Py:=L[|L|-1] and L:= L[0..|L|-1] }
    else { Py:=My and L:=L }
   else if My=[] then { Py:=Py and L:=L }
        else { Py:=Py and L:=[My]+L }
   )    
}.

define pipe_p(My,Zilock,L,Py,Stop) = {
  always( if Stop then empty else
   if Zilock=0 then  
    if My=[] then 
     if L=[] then { Py:=[]  and L:= L }
     else { Py:=L[|L|-1] and L:= L[0..|L|-1] }
    else { if L=[] then { Py:=My and L:=L }
           else { Py:=L[|L|-1] and L:=[My]+L[0..|L|-1] }
         }
   else if My=[] then { Py:=Py and L:=L }
        else { Py:=Py and L:=[My]+L }
   )    
}.

/* run */ define pipe(s) = {
  exists L,Py,Iy,My,Zilock,Index,Stop: {
    L=[] and Index=0 and My=[0] and Py=[] and Iy=[]
    and always format("Py=%8t  Iy=%8t  My=%8t  L=%12t  Zilock=%1t\n",
		      prb(Py),prb(Iy),prb(My),pr2(L),Zilock)
    and always (Stop={Py=[] and Iy=[] and My=[] and L=[]}) 
    and pipe_0(Py,Zilock,Iy,Stop)
    and pipe_1(Iy,Zilock,Index,My,Stop)
    and if s=0 then pipe_s(My,Zilock,L,Py,Stop)
        else if s=1 then pipe_q(My,Zilock,L,Py,Stop)
             else pipe_p(My,Zilock,L,Py,Stop)
  }
}.
