/* -*- Mode: C -*-                                                  */
/* $Id: epsimold1-tcl.t,v 2.10 2001/09/11 09:28:32 acau Exp $   */
/********************************************************************/
/*       v000: started 13/3/95 the translation of Pascal program    */
/*             into Tempura                                         */
/*                                                                  */
/*       v001: started 31/3/95 the debugging of the Tempura program */
/*       v002: started 23/9/96 the abstract ep/3                    */
/********************************************************************/

define version = "010V0032". 
define bits=[1,2,4,8,16,32,64,128].
define hex="0123456789ABCDEF".
define cgran = 3.
define hwordlen = 1.  /* halfword length in bytes */
define fwordlen = 3.  /* fullword length in bytes */
define dwordlen = 7.  /* doubleword length in bytes */
define qwordlen = 15. /* quadrupleword length in bytes */
define flowlength = 15.  /* Total size of flow operands in bytes */
                          /* N.B. all the above start numbering at 0 */
define cyctime = 150.  /* cycle time, 1/us */
define iorate = 25.    /* number of processor cycles per I/O operation */
define proctrace = true.  /* trace to include processor units */ 
define ptstart = 00.      /* start cycle for trace */
define ptstop = 7000.     /* stop cycle for trace */
define ioptrace = false.   /* trace to include iop cycles */
define memprn = false.      /* trace to include memory dump */  


define hword(X) = { list(X, hwordlen+1) and stable(struct(X)) }.
define fword(X) = { list(X, fwordlen+1) and stable(struct(X)) }.
define dword(X) = { list(X, dwordlen+1) and stable(struct(X)) }.
define qword(X) = { list(X, qwordlen+1) and stable(struct(X)) }.
define hexbinnib (X) = {
  if ((ascii(X) >= 48) and (ascii(X) <= 57)) then {ascii(X) - 48}
  else {
   if ((ascii(X) >= 65) and (ascii(X) <= 70)) then {ascii (X) - 55}
   else {format("*** Format Error in Input ***")}}
}.
define hexbinbyte (X,Y) = {hexbinnib (Y) + 16 * hexbinnib (X) }.
define  bit (Bitno, Number)= {( (Number div bits[Bitno]) mod 2 = 1)}.
define  prnbyte (R) = {
  format("%s", hex[R div 16]+ hex[R mod 16])
}.
define prnhword (R) = {
  forall i< hwordlen+1 : {prnbyte (R[hwordlen-i])}
}.
define prnword (R) = {
  forall i< fwordlen+1 : {prnbyte (R[fwordlen-i])}
}.
define prndword (R) = {
  forall i< dwordlen+1 : {prnbyte (R[dwordlen-i])}
}.
define prnqword (R) = {
  forall i< qwordlen+1 : {prnbyte (R[qwordlen-i])}
}.
define prnqword1 (R) = {
  forall i< qwordlen+1 : {
   if i mod 4 = 0 then {format(" ") and prnbyte (R[qwordlen-i])}
   else {prnbyte (R[qwordlen-i]) } }
}.
define prnbool (R) = {
  if R then format("T") else format(".")
}.
define  haltproc(X) = {
  format(X) and format("Program Halted ") and empty
}.
define inttobits(X) = {
  [bit(7,X),bit(6,X),bit(5,X),bit(4,X),
   bit(3,X),bit(2,X),bit(1,X),bit(0,X)]
}.
define band1(X,Y) = {
  [X[7] and Y[7], X[6] and Y[6], X[5] and Y[5], X[4] and Y[4],
   X[3] and Y[3], X[2] and Y[2], X[1] and Y[1], X[0] and Y[0]]
}.
define bor1(X,Y) = {
  [X[7] or Y[7], X[6] or Y[6], X[5] or Y[5], X[4] or Y[4],
   X[3] or Y[3], X[2] or Y[2], X[1] or Y[1], X[0] or Y[0]]
}.
define bxor1(X,Y) = {
  [(~X[7] and Y[7]) or (~Y[7] and X[7]), 
   (~X[6] and Y[6]) or (~Y[6] and X[6]),
   (~X[5] and Y[5]) or (~Y[5] and X[5]),
   (~X[4] and Y[4]) or (~Y[4] and X[4]),
   (~X[3] and Y[3]) or (~Y[3] and X[3]),
   (~X[2] and Y[2]) or (~Y[2] and X[2]),
   (~X[1] and Y[1]) or (~Y[1] and X[1]),
   (~X[0] and Y[0]) or (~Y[0] and X[0])
  ]
}.
define bitstoint(X) = {
  {if X[7] then 128 else 0} +
  {if X[6] then 64 else 0} +
  {if X[5] then 32 else 0} +
  {if X[4] then 16 else 0} +
  {if X[3] then 8 else 0} +
  {if X[2] then 4 else 0} +
  {if X[1] then 2 else 0} +
  {if X[0] then 1 else 0}
}.
define bandi(X,Y) = {bitstoint(band1(inttobits(X),inttobits(Y)))}.
define bori(X,Y) =  {bitstoint(bor1(inttobits(X),inttobits(Y)))}.
define bxori(X,Y) = {bitstoint(bxor1(inttobits(X),inttobits(Y)))}.
define bplus(Z,X,Y) = {
  exists ca0,ca1,ca2,ca3 : {
/*   list(ca, fwordlen+2) and */
   ca0 = 0 and
   Z[0] = (X[0] + Y[0] + ca0) mod 256 and
   ca1  = (X[0] + Y[0] + ca0) div 256 and
   Z[1] = (X[1] + Y[1] + ca1) mod 256 and
   ca2  = (X[1] + Y[1] + ca1) div 256 and
   Z[2] = (X[2] + Y[2] + ca2) mod 256 and
   ca3  = (X[2] + Y[2] + ca2) div 256 and
   Z[3] = (X[3] + Y[3] + ca3) mod 256 
  }
}.
define bmin(Z,X,Y) = {
  exists bo0,bo1,bo2,bo3 : {
/*   list(bo, fwordlen+2) and */
   bo0 = 0 and
   Z[0] = {if X[0] - Y[0] - bo0 < 0 then {
            (X[0] - Y[0] - bo0) + 256} else {
             X[0] - Y[0] - bo0}} and
   bo1  = {if X[0] - Y[0] - bo0 < 0 then {1} else {0} } and
   Z[1] = {if X[1] - Y[1] - bo1 < 0 then {
            (X[1] - Y[1] - bo1) + 256} else {
             X[1] - Y[1] - bo1}} and
   bo2  = {if X[1] - Y[1] - bo1 < 0 then {1} else {0} } and
   Z[2] = {if X[2] - Y[2] - bo2 < 0 then {
            (X[2] - Y[2] - bo2) + 256} else {
             X[2] - Y[2] - bo2}} and
   bo3  = {if X[2] - Y[2] - bo2 < 0 then {1} else {0} } and
   Z[3] = {if X[3] - Y[3] - bo3 < 0 then {
            (X[3] - Y[3] - bo3) + 256} else {
             X[3] - Y[3] - bo3}} 
  }
}.
define band(Z,X,Y) = {forall i<fwordlen+1 : { Z[i]= bandi(X[i],Y[i]) } }.
define bor(Z,X,Y) =  {forall i<fwordlen+1 : { Z[i]= bori(X[i],Y[i])  } }. 
define bxor(Z,X,Y) = {forall i<fwordlen+1 : { Z[i]= bxori(X[i],Y[i]) } }.
define evintsrlogical (Z,X) = {
/*  exists temph : {*/
/*   list(temph, fwordlen+2) and */
   Z[3] = {if false then bori(128,X[3] div 2)
                     else bandi(X[3] div 2, 127)} and
   Z[2] = {if bit (0, X[3]) then bori(128,X[2] div 2)
                     else bandi(X[2] div 2, 127)} and
   Z[1] = {if bit (0, X[2]) then bori(128,X[1] div 2)
                     else bandi(X[1] div 2, 127)} and
   Z[0] = {if bit (0, X[1]) then bori(128,X[1] div 2)
                     else bandi(X[1] div 2, 127)} 
/*  } */
}.
define evintsrarith (Z,X) = {
/*  exists temph : {*/
/*   list(temph, fwordlen+2) and */
   Z[3] = {if bit(0,X[0]) then bori(128,X[3] div 2)
                     else bandi(X[3] div 2, 127)} and
   Z[2] = {if bit(0,X[2]) then bori(128,X[2] div 2)
                     else bandi(X[2] div 2, 127)} and
   Z[1] = {if bit(0,X[1]) then bori(128,X[1] div 2)
                     else bandi(X[1] div 2, 127)} and
   Z[0] = {if bit(0,X[0]) then bori(128,X[0] div 2)
                     else bandi(X[0] div 2, 127)} 
/*  }*/
}.
define evintslarith(Z,X) = {
  exists temp0 : {
/*   list(templ, fwordlen+2) and */
/*   templ[0] = false and temp = bit(7,X[fwordlen]) and*/
   temp0 = {if false then bori((X[0] * 2) mod 256, 1)
            else bandi((X[0] * 2) mod 256, 254) } and
   Z[0] = {if bit(7,X[3]) then bori(temp0, 1)
           else bandi(temp0, 254) }  and
   Z[1] = {if bit (7, X[0]) then bori((X[1] * 2) mod 256, 1)
           else bandi((X[1] * 2) mod 256, 254) } and
   Z[2] = {if bit (7, X[1]) then bori((X[2] * 2) mod 256, 1)
           else bandi((X[2] * 2) mod 256, 254) } and
   Z[3] = {if bit (7, X[2]) then bori((X[3] * 2) mod 256, 1)
           else bandi((X[3] * 2) mod 256, 254) } 
  } 
}.
define evintsllogical(Z,X) = {
  exists temp0 : {
/*   list(templ, fwordlen+2) and */
/*   templ[0] = false and temp = false and*/
   temp0 = {if false then bori((X[0] * 2) mod 256, 1)
            else bandi((X[0] * 2) mod 256, 254) } and
   Z[0] =  bandi(temp0, 254)  and
   Z[1] = {if bit (7, X[0]) then bori((X[1] * 2) mod 256, 1)
           else bandi((X[1] * 2) mod 256, 254) }  and
   Z[2] = {if bit (7, X[1]) then bori((X[2] * 2) mod 256, 1)
           else bandi((X[2] * 2) mod 256, 254) }  and
   Z[3] = {if bit (7, X[2]) then bori((X[3] * 2) mod 256, 1)
           else bandi((X[3] * 2) mod 256, 254) } 
  }
}.
define punchbyte (X) = {
  format ("%s", hex[X div 16]+hex[X mod 16]) 
}.
define punchword (R) = {
  format("punching ") and 
  forall i< fwordlen+1 : {punchbyte(R[fwordlen-i]) } and 
  format("\n")
}.
define initbyte() = {0}.
define inithword (X) = {forall i< hwordlen+1 : {X[i]=initbyte()}}.
define ginithword (X) = {forall i< hwordlen+1 : {X[i]:=initbyte()}}.
define initword (X) = {forall i< fwordlen+1 : {X[i]=initbyte()}}.
define ginitword (X) = {forall i< fwordlen+1 : {X[i]:=initbyte()}}.
define initdword (X) = {forall i< dwordlen+1 : {X[i]=initbyte()}}. 
define ginitdword (X) = {forall i< dwordlen+1 : {X[i]:=initbyte()}}. 
define initqword (X) = {forall i< qwordlen+1 : {X[i]=initbyte()}}. 
define ginitqword (X) = {forall i< qwordlen+1 : {X[i] := initbyte()}}. 
define initbool (X) = {X = false}. 
define ginitbool (X) = {X := false}. 



/* msize: 16382 no of fwords of memory */ /*1279*/
/* csize: 1023 no of rows (dword) of cache */
/* noslots: 512 no of slots of stack */

define epsim3(Io, Io1, msize, csize, noslots) = {  
  exists 
   Cycle, Proccycle,  Usecnt, Instcnt,   

   Zilocka, Zilockb, Zvalid, Ziopreq, 
   Minst, Mda, Mstrb, Mmem2, Mmem2b, Mmem2in, Mmem2s,
   Sinst, Sda, Sdb, Sstrb, 
   Pinst, Pda, Pdb, Pstrb, 
   Iinst, Istrb, Ialu2in, Ialu2c, Ialu2, Ialu2z, Ialu2s,
     
   Iflag,  Oflag, Iopobuff, Iopcaddr, Intaddr, 
   Riopsta, Riopi,  Riops, Riopd, Fiop, Booting,
   Cache, Cachetag, 
       
   Ralu1s,  Ralu1a,  Ralu1b, Ralu1in,  
         
   Rii2seg,  Rii1dest, Rii1s,  Rii1, Rii1seg, Stopped,
   Ralu2,  Ralu2c,  Ralu2z,  Ralu2in,  Ralu2s,   
          
   Rsp, Rmem1, Rmem1s, Rmem1in,

   Rmem2b, Rmem2s, Rmem2in, Rmem2, Memory,   
            
   Rstktop, Rstkbot, Rstk1, Rstk1b, Rstk1in, Rstk1s, Stack : { 
            
   
   define memtype(X) = {
     list( X, msize+1) and stable(struct(X))
     and forall i<msize+1: {fword(X[i])}
   } and
   define stkrec(X) = {
     list( X,3) and  stable(struct(X))
     and dword(X[0])
     and qword(X[1])
     and fword(X[2])
   }
   and 
   define type_declaration () = {
     qword(Ralu2) and qword(Ralu1a) and fword(Ralu2z)  and 
     fword(Ralu1b) and dword(Ralu2in) and  dword(Ralu1in) and 
     dword(Riopi) and qword(Riopd) and qword(Iopobuff) and   
     list( Rsp, 3) and stable(struct(Rsp)) and
     forall i<3 : { list(Rsp[i], 2) and stable(struct(Rsp[i]))} and
     dword(Rmem2in) and qword(Rmem2) and qword(Rmem1) and 
     dword(Rmem1in) and  fword(Rmem2b) and fword(Rii2seg) and 
     dword(Rii1) and fword(Rii1seg) and qword(Rstk1) and 
     fword(Rstk1b) and dword(Rstk1in) and dword(Minst) and 
     qword(Mmem2) and fword(Mmem2b) and dword(Mmem2in) and
     qword(Mda) and dword(Sinst) and qword(Sda) and fword(Sdb) and
     dword(Pinst) and qword(Pda) and fword(Pdb) and dword(Iinst) and 
     dword(Ialu2in) and qword(Ialu2) and fword(Ialu2z) and   
     memtype(Memory) and
     list( Cache, (csize+1)) and stable(struct(Cache)) and
     forall i<(csize+1) : { qword(Cache[i])  } and
     list( Cachetag, (csize+1)) and stable(struct(Cachetag)) and
     list(Stack,(noslots+1)) and  stable(struct(Stack)) and
      forall j<(noslots+1): { stkrec(Stack[j]) } 
   }
   and   
   define prnmem() = {
     format ("State of Memory\n") and
     forall i< (msize div 8) +1 : {
       prnbyte ((i * 8 * 4) div 256) and
       prnbyte ((i * 8 * 4) mod 256) and
       forall j<8 : {
         format (" ") and  prnword (Memory[(i * 8)+j])} and
       format("\n") } and
     format("\n")
   }
   and
   define prncache() = {
     format("State of Cache\n") and
     format("\n") and
     forall i<csize+1: {
       prnbyte ((i * 8) div 256) and
       prnbyte ((i * 8) mod 256) and
       format(" ") and
       prnbyte (Cachetag[i] div 256) and
       prnbyte (Cachetag[i] mod 256) and
       forall j<4 : {
         format (" ") and 
         prnbyte(Cache[i][j * 4]) and prnbyte(Cache[i][j * 4 + 1]) and
         prnbyte(Cache[i][j * 4 + 2]) and prnbyte(Cache[i][j * 4 + 3])
       } and
       format("\n") } and
     format("\n")
   }
   and   
   define initvar() = { 
     Instcnt = 0 and Usecnt = 0 and Fiop = 0 and Ralu2c = 0 and 
     forall j<(noslots+1): {
      initdword(Stack[j][0]) and initqword(Stack[j][1]) and
      initword(Stack[j][2]) } and
     initdword(Ralu2in) and initqword(Iopobuff) and Iopcaddr = 0 and 
     initqword (Ralu2) and initword (Ralu2z) and initbool (Ralu2s) and
     initbool (Ralu1s) and initqword (Ralu1a) and initword (Ralu1b) and
     initdword (Ralu1in) and initdword (Riopi) and initbool (Riops) and
     initqword (Riopd) and initword (Rmem2b) and
     forall j < 3 : { inithword (Rsp[j]) } and
     initbool (Rmem2s) and initdword (Rmem2in) and initqword (Rmem2) and
     initqword (Rmem1) and initbool (Rmem1s) and initdword (Rmem1in) and
     initword (Rii2seg) and Rii1dest = 0 and initbool (Rii1s) and
     initdword (Rii1) and  initword (Rii1seg) and
     Rstktop = 0 and Rstkbot = 0 and initqword (Rstk1) and
     initword (Rstk1b) and initdword (Rstk1in) and initbool (Rstk1s) and
     forall i < (msize+1) : {
       /* initword (Memory[i]) */
       if i<|Io1| then {
        Memory[i][3] = hexbinbyte (Io1[i][0],Io1[i][1]) and
        Memory[i][2] = hexbinbyte (Io1[i][2],Io1[i][3]) and
        Memory[i][1] = hexbinbyte (Io1[i][4],Io1[i][5]) and
        Memory[i][0] = hexbinbyte (Io1[i][6],Io1[i][7])
       }
       else initword (Memory[i]) 
     } and
     forall i< (csize+1) : {Cachetag[i] = -1 and initqword(Cache[i]) } and
     Iflag = false and Oflag = false and Riopsta = 0 and Intaddr = 0 and
     Stopped = false and Booting = true and Cycle = 0 and Proccycle = 0 
   } and


   define pipe0(Pinst0, Pda0, Pdb0, Pstrb0, Zilock0, 
     Iinst0, Istrb0, Ialu2in0, Ialu2c0, Ialu20, Ialu2z0, Ialu2s0) = {
     exists flow1, opa, ralu2z00, addressc, row, col : {
      fword(opa) and  fword(ralu2z00) and     
      Ialu20 = Ralu1a and
      flow1 = (Ralu1in[6] div 16) mod 4 and
      opa[3] = Ralu1a[(flow1 * 4) + 3] and
      opa[2] = Ralu1a[(flow1 * 4) + 2] and
      opa[1] = Ralu1a[(flow1 * 4) + 1] and
      opa[0] = Ralu1a[(flow1 * 4) + 0] and
      if (Ralu1in[7] div 32) mod 4 = 0 then { 
      if Ralu1in[7] mod 32 = 0 then { ralu2z00 = opa } else {
      if Ralu1in[7] mod 32 = 1 then { ralu2z00 =  Ralu1b } else {
      if Ralu1in[7] mod 32 = 2 then { bplus(ralu2z00,opa,Ralu1b) } else {
      if Ralu1in[7] mod 32 = 3 then { bmin(ralu2z00,opa,Ralu1b) } else {
      if Ralu1in[7] mod 32 = 4 then { band(ralu2z00,opa,Ralu1b) } else {
      if Ralu1in[7] mod 32 = 5 then { bor(ralu2z00,opa,Ralu1b) }  else {
      if Ralu1in[7] mod 32 = 6 then { bxor(ralu2z00,opa,Ralu1b) } else {
      if Ralu1in[7] mod 32 = 8 then { ralu2z00 = opa } else {
      if Ralu1in[7] mod 32 = 9 then { ralu2z00 = opa } else {
      if Ralu1in[7] mod 32 = 10 then {ralu2z00 = opa } else {
      if Ralu1in[7] mod 32 = 11 then {ralu2z00 = opa } else {
      if Ralu1in[7] mod 32 = 12 then {ralu2z00 = Ralu1b } else {
      if Ralu1in[7] mod 32 = 13 then {ralu2z00 = Ralu1b } else {
      if Ralu1in[7] mod 32 = 15 then {ralu2z00 = opa }}}}}}}}}}}}}} and
      if {exists i< fwordlen + 1 : ralu2z00[i] ~= 0} then {
      if ~bit(7, ralu2z00[3]) then {Ialu2c0 = 3} else {Ialu2c0 = 1}}
      else {if ~bit(7, ralu2z00[3]) then {Ialu2c0 = 2} else {Ialu2c0=0}}}  
      and Ialu2in0 = Ralu1in and Ialu2s0 = Ralu1s and 
      Ialu2z0 = ralu2z00 and
      if ~Zilock0 then { Ralu1a := Pda0 and Ralu1b := Pdb0 and
       Ralu1in := Pinst0 and Ralu1s := Pstrb0 }
      else {Ralu1a := Ralu1a and Ralu1b := Ralu1b and
       Ralu1in := Ralu1in and Ralu1s := Ralu1s }  and
      /* cache */        
      if ~Zilock0 then { Rii1seg[3] := 0 and Rii1seg[2] := Pinst0[2] and 
        Rii1seg[1] := Pinst0[1] and Rii1seg[0] := Pinst0[0] }
      else { Rii1seg := Rii1seg } and       
      addressc =  (Ralu1in[1] * 256 + Ralu1in[0]) and
      if ((Ralu1s) and (Ralu1in[2] div 16 = 0)) then { Istrb0 = true }
      else { Istrb0=false } and
      if (( addressc mod 2 = 1) or (addressc >  msize * 4)) then {
       haltproc("*** Inst. Address Overflow or Misalignment***") } and
      row = (addressc div 8) mod (csize + 1) and
      col = (addressc div 2) mod 4 and
      forall i<4 : {
       Iinst0[7 - i * 2] = Cache[row][(col + i)*2 +1] /*[1]*/ and
       Iinst0[6 - i * 2] = Cache[row][(col + i)*2] /*[0]*/ }
     }
   }

   and 
   
   define pipe1(Iinst0, Istrb0, Zilocka0,  Ziopreq0, Ialu2in0, 
     Ialu2c0, Ialu20, Ialu2z0, Ialu2s0,
     Minst0, Mda0, Mstrb0, Zvalid0, Zilockb0) = {   
     exists buff, flow1, ralu2o : {
     fword(ralu2o) and qword(buff) and
     /* Instiss */    
     if (Rii1s and ~Ziopreq0) then {
      if Rii1dest = 0 then {
       if bit (7, Rii1[7]) then {
        if bit (0, Rii1[3]) then { Rii1dest := 0 and Zilockb0 = false }
        else { Rii1dest := 1 and Zilockb0 = true } }
       else {
        if bit (0, Rii1[5]) then { Rii1dest := 0 and Zilockb0 = false }
        else { Rii1dest := 1 and Zilockb0 = true } } }
      else {
       if Rii1dest = 1 then {
        if bit (7, Rii1[7]) then { Rii1dest := 0 and Zilockb0 = false }
        else {
         if bit (2, Rii1[5]) then { Rii1dest := 0 and Zilockb0 = false}
         else {
          if bit (0, Rii1[3]) then { Rii1dest := 0 and Zilockb0 = false}
          else {Rii1dest := 2 and Zilockb0 = true } } } }
       else {
        if Rii1dest = 2 then { Rii1dest := 0 and Zilockb0 = false}
        else { Rii1dest := 0 and Zilockb0 = false } } } } 
     else { Zilockb0 = false and Rii1dest := Rii1dest } and
     if (Rii1s and Zvalid0 and ~Ziopreq0) then {
       Mstrb0 = true and
       if Rii1dest = 0 then { Instcnt := Instcnt + 1 }
       else { Instcnt := Instcnt } }
     else { Instcnt := Instcnt } and
     if ~Ziopreq0 then {
      if Rii1[7] = 127 then { Stopped := true }
      else { Stopped := Stopped } and
      if Rii1[7] div 128 = 0 then { 
       Minst0[7] = Rii1[7] and Minst0[6] = Rii1[6] and Minst0[5] = 0 and
       if Rii1dest = 0 then {
        Minst0[4] = 0 and Minst0[3] = Rii1[5] and
        if ((bit (1, Rii1[5])) or (bit (2, Rii1[5]))) then {
         Minst0[2] = Rii1[4] and Minst0[1] = Rii1[3] and
         Minst0[0] = Rii1[2] }
        else {
         Minst0[2] = Rii2seg[2] and Minst0[1] = Rii2seg[1] and
         Minst0[0] = Rii1[4] } }
       else {
        if Rii1dest = 1 then {
         Minst0[4] = 4 and
         if ((bit (1, Rii1[5])) or (bit (2, Rii1[5]))) then {
          Minst0[3] = Rii1[1] and Minst0[2] = Rii2seg[2] and
          Minst0[1] = Rii2seg[1] and Minst0[0] = Rii1[0] }
         else {
          if ((bit (1, Rii1[3])) or (bit (2, Rii1[3]))) then {
           Minst0[3] = Rii1[3] and Minst0[2] = Rii1[2] and
           Minst0[1] = Rii1[1] and Minst0[0] = Rii1[0] }
          else {
           Minst0[3] = Rii1[3] and Minst0[2] = Rii2seg[2] and
           Minst0[1] = Rii2seg[1] and Minst0[0] = Rii1[2] } } }
        else {
         if Rii1dest = 2 then {
          Minst0[4] = 8 and Minst0[3] = Rii1[1] and
          Minst0[2] = Rii2seg[2] and Minst0[1] = Rii2seg[1] and
          Minst0[0] = Rii1[0] } } }  }
      else { 
       Minst0[6] = Rii1[6] and Minst0[5] = Rii1[5] and
       Minst0[4] = Rii1[4] and
       if Rii1dest = 0 then {
        if Rii1[7] = 136 then { Minst0[7] = 129 }
        else {
         if Rii1[7] = 137 then { Minst0[7] = 141 } 
         else {
          if Rii1[7] = 138 then { Minst0[7] = 129 }
          else { Minst0[7] = Rii1[7] } } } and
        Minst0[3] = Rii1[3] and
        if ((bit (1, Rii1[3])) or (bit (2, Rii1[3]))) then {
         Minst0[2] = Rii1[2] and Minst0[1] = Rii1[1] and
         Minst[0] = Rii1[0] }
        else {
          Minst0[2] = Rii2seg[2] and Minst0[1] = Rii2seg[1] and
          Minst0[0] = Rii1[2] } }
       else {
        if Rii1dest = 1 then {
         if Rii1[7] = 136 then { Minst0[7] = 143 }
         else {
          if Rii1[7] = 137 then { Minst0[7] = 143 }
          else {
           if Rii1[7] = 138 then { Minst0[7] = 140 }
           else { Minst0[7] = Rii1[7] } } } and
         Minst0[3] = Rii1[1] and Minst0[2] = Rii2seg[2] and
         Minst0[1] = Rii2seg[1] and Minst0[0] = Rii1[0] }
        else {
         Minst0[3] = 0 and Minst0[2] = 0 and Minst0[1] = 0 and
         Minst0[0] = 0 and Minst0[7] = Rii1[7] } }  } }
     else { Stopped := Stopped } and
     if ~(Zilocka0 or Zilockb0) then {
       Rii1 := Iinst0 and Rii1s := Istrb0 and Rii2seg := Rii1seg}
     else {Rii1 := Rii1 and Rii1s := Rii1s and Rii2seg := Rii2seg } 
     and 
     /* Alu2 */
      flow1 = (Ralu2in[6] div 16) and
      if Ralu2in[7] mod 16 = 8 then {evintslarith(ralu2o,Ralu2z)} else {
      if Ralu2in[7] mod 16 = 9 then {evintsllogical(ralu2o,Ralu2z)} else {
      if Ralu2in[7] mod 16 = 10 then {evintsrarith(ralu2o,Ralu2z)} else {
      if Ralu2in[7] mod 16 = 11 then {evintsrlogical(ralu2o,Ralu2z)} else {
          ralu2o = Ralu2z } } } } and 
      if flow1 < 12 then {
       buff[(flow1 * 4) + 3] = ralu2o[3] and
       buff[(flow1 * 4) + 2] = ralu2o[2] and
       buff[(flow1 * 4) + 1] = ralu2o[1] and
       buff[(flow1 * 4) + 0] = ralu2o[0] and
       if flow1 = 0 then {
        forall i < 16 : { if i > 3 then buff[i] = Ralu2[i] } } and
       if flow1=1 then {
        forall i < 16 : { if i < 4 or i > 7 then buff[i] = Ralu2[i] } } and
       if flow1=2 then {
        forall i < 16 : { if i < 8 or i > 11 then buff[i] = Ralu2[i] } } and
       if flow1 = 3 then {
        forall i < 12 : { buff[i] = Ralu2[i] } } }   
      else { buff = Ralu2 } and 
      if ((~Ralu2s) or (Ralu2c = 0)) then { Zvalid0 = false }
      else { Zvalid0 = bit ((Ralu2c + 4), Ralu2in[3]) } and
      if ~Ziopreq0 then { Mda0 = buff }
      else { true } and
      if ~(Zilocka0 or Zilockb0) then {
       Ralu2 := Ialu20 and Ralu2z := Ialu2z0 and Ralu2in := Ialu2in0 and
       Ralu2s := Ialu2s0 and Ralu2c := Ialu2c0 }
      else {
       Ralu2 := Ralu2 and Ralu2z := Ralu2z and Ralu2in := Ralu2in and
       Ralu2s := Ralu2s and Ralu2c := Ralu2c }  
     }
   }
   and
   
   define pipe2(Minst0, Mda0, Mstrb0,
     Mmem20, Mmem2b0, Mmem2in0, Mmem2s0) = {
   
     exists dstbase, dstaddr, flow1, flow2, flow, datbase, datbaseaddr, 
       datoffset, dataddr, t1, t2 : {
      dstbase = {Rmem1in[2] mod 4} and
      dstaddr = {if dstbase = 0 then { (Rmem1in[1] * 256) + Rmem1in[0]}
                 else { (Rmem1[(dstbase * 4 + 1)] * 256 + 
                         Rmem1[(dstbase * 4)])  } } and
      Mmem2in0[2] = {16 * (Rmem1in[2] div 16)} and
      Mmem2in0[1] = dstaddr div 256 and Mmem2in0[0] = dstaddr mod 256 and
      Mmem2in0[3] = Rmem1in[3] and Mmem2in0[6] = Rmem1in[6] and
      Mmem2in0[7] = Rmem1in[7] and
      flow1 = Rmem1in[6] div 16 and flow2 = Rmem1in[6] mod 16 and
      flow = {if bit (7, Rmem1in[7]) then flow1 else flow2} and
      Mmem2b0[3] = Rmem1[((flow mod 4) * 4) + 3] and
      Mmem2b0[2] = Rmem1[((flow mod 4) * 4) + 2] and
      Mmem2b0[1] = Rmem1[((flow mod 4) * 4) + 1] and
      Mmem2b0[0] = Rmem1[((flow mod 4) * 4) + 0] and
      if bit (7, Rmem1in[7]) then {
       datbase = Rmem1in[6] mod 16 and
       datbaseaddr = {if datbase = 0 then { 0 } else { 
                      if 0 < datbase and datbase < 4 then {  
                       (Rmem1[(datbase * 4 + 1)] * 256 + 
                        Rmem1[(datbase * 4)]) } else {
                      if 11 < datbase and datbase < 15 then {
                       (Rsp[datbase - 12][1] * 256 + 
                        Rsp[datbase - 12][0]) } else { 0 } } } } and
       datoffset = (Rmem1in[5] * 256) + Rmem1in[4] and
       dataddr = {if Rmem1in[7] = 141 then datbaseaddr - datoffset
                  else datbaseaddr + datoffset } and
       if dataddr >  msize * 4 then {
        Mmem2in0[4] = Rmem1in[4] and Mmem2in0[5] = Rmem1in[5] }
       else {
        if Rmem1s and ((flow1 >= 12) or ((flow2 >= 12) and 
           ((Rmem1in[7] = 140) or (Rmem1in[7] = 141)))) then {
         if flow1 >= 12 then {
          if (flow2 >= 12) and 
              ((Rmem1in[7] = 140) or (Rmem1in[7] = 141)) then {
           if flow1 = flow2 then {
            Rsp[flow1-12][1] := dataddr div 256 and
            Rsp[flow1-12][0] := dataddr mod 256 and
            t1 = ((flow1-12)+1)mod 3 and t2 = ((flow1-12)+2)mod 3 and
            Rsp[t1] := Rsp[t1] and Rsp[t2] := Rsp[t2] }
           else {
            Rsp[flow1-12][1] := dataddr div 256 and
            Rsp[flow1-12][0] := dataddr mod 256 and
            Rsp[flow2-12][1] := dataddr div 256 and
            Rsp[flow2-12][0] := dataddr mod 256 and
            Rsp[27-(flow1+flow2)] := Rsp[27-(flow1+flow2)] } }
          else {
            Rsp[flow1-12][1] := dataddr div 256 and
            Rsp[flow1-12][0] := dataddr mod 256 and
            t1 = ((flow1-12)+1)mod 3 and t2 = ((flow1-12)+2)mod 3 and
            Rsp[t1] := Rsp[t1] and Rsp[t2] := Rsp[t2] } }
         else {
          Rsp[flow2-12][1] := dataddr div 256 and
          Rsp[flow2-12][0] := dataddr mod 256 and
          t1 = ((flow2-12)+1)mod 3 and t2 = ((flow2-12)+2)mod 3 and
          Rsp[t1] := Rsp[t1] and Rsp[t2] := Rsp[t2] } }
        else {
         Rsp[0] := Rsp[0] and Rsp[1] := Rsp[1] and Rsp[2] := Rsp[2] } and
        Mmem2in0[5] = dataddr div 256 and
        Mmem2in0[4] = dataddr mod 256 } }
      else {
       Mmem2in0[4] = Rmem1in[4] and Mmem2in0[5] = Rmem1in[5] and
       Rsp[0] := Rsp[0] and Rsp[1] := Rsp[1] and Rsp[2] := Rsp[2] } and
      Mmem2s0 = Rmem1s and Mmem20 = Rmem1 and
      if Rmem1s then {Usecnt := Usecnt + 1}else {Usecnt := Usecnt} and
      Rmem1 := Mda0 and Rmem1in := Minst0 and Rmem1s := Mstrb0
     }
   }
   and

   define pipe3(Mmem20, Mmem2b0, Mmem2in0, Mmem2s0,
     Sinst0, Sda0, Sdb0, Sstrb0) = {
   
     exists address, waddress : {
      if Rmem2s then {
       if Rmem2in[3] div 16 ~= 0 then {Sstrb0 = true}else {Sstrb0 = false} and
       Sinst0 = Rmem2in and Sda0 = Rmem2 and
       address = Rmem2in[5] * 256 + Rmem2in[4] and
       waddress = ( address div 4) mod (msize + 1) and
       if Rmem2in[7] = 143 then {
        initword(Sdb0) and
        tcl("wmem",[strbyte(Rmem2in[5])+strbyte(Rmem2in[4]),strword(Rmem2b)]) and
            /*if Riopsta = 20 then {
          format("Writing to Memory[0000%1s%1s%1s%1s] the value ",
           hex[Rmem2in[5] div 16], 
           hex[Rmem2in[5] mod 16],
           hex[Rmem2in[4] div 16],
           hex[Rmem2in[4] mod 16]) and
           prnword(Rmem2b) and format("\n") } and*/
        (next Memory[waddress]) = Rmem2b  and
        forall i<msize + 1 : {
         if i ~= waddress then { (next Memory[i]) = Memory[i] }
         } }
       else {
        forall i < msize + 1 : { (next Memory[i])  = Memory[i]  } and
        if Rmem2in[7] div 2 = 70 then {
            tcl("cmem",[1]) and
         Sdb0[3] = 0 and Sdb0[2] = 0 and
         Sdb0[1] = Rmem2in[5] and Sdb0[0] = Rmem2in[4] }
        else {
         if bit (7, Rmem2in[7]) then {
             tcl("rmem",[strbyte(Rmem2in[5])+strbyte(Rmem2in[4]),strword(Memory[waddress])]) and
                 /*if Riopsta = 20 then{ 
           format("Reading from Memory[0000%1s%1s%1s%1s] the value ",
           hex[Rmem2in[5] div 16], 
           hex[Rmem2in[5] mod 16],
           hex[Rmem2in[4] div 16],
           hex[Rmem2in[4] mod 16]) and
           prnword(Memory[waddress]) and format("\n") } and*/
           Sdb0 = Memory[waddress] }
         else { tcl("cmem",[1]) and Sdb0 = Rmem2b } } } }
      else {
        tcl("cmem",[1]) and  
       forall i<msize+1: { (next Memory[i]) = Memory[i] } and
       Sstrb0 = false and initdword(Sinst0) and
       initqword(Sda0) and initword(Sdb0) } and
      Rmem2 := Mmem20 and Rmem2b := Mmem2b0 and
      Rmem2in := Mmem2in0 and Rmem2s := Mmem2s0 
     }
   }
   and
   
   define pipe4(Sinst0, Sda0, Sdb0, Sstrb0, Zilock0, 
     Pinst0, Pda0, Pdb0, Pstrb0) = {
     
     if Rstk1s then {
      if ~Zilock0 then {
       if Rstktop = Rstkbot then {
        /*format("bypassing the queue\n") and*/
        Rstkbot := Rstkbot and Rstktop := Rstktop and
        forall j<noslots+1: { (next Stack[j]) = Stack[j]} and
        Pda0 = Rstk1 and Pdb0 = Rstk1b and
        Pinst0 = Rstk1in and Pstrb0 = true 
        }
       else {
        /*format("in/out of the queue\n") and*/
        Rstktop := (Rstktop + 1) mod (noslots + 1) and
        Rstkbot := (Rstkbot + 1) mod (noslots + 1) and
        forall j<noslots+1: {
        if  j ~= Rstktop then { (next Stack[j]) = Stack[j]} 
        else { (next Stack[j][1]) = Rstk1 and 
               (next Stack[j][2]) = Rstk1b and
               (next Stack[j][0]) = Rstk1in } }  and
        Pda0=Stack[Rstkbot][1] and Pdb0 = Stack[Rstkbot][2] and
        Pinst0 = Stack[Rstkbot][0] and  Pstrb0 = true and
        /*format("writing to Queue[%t] the value \n", Rstktop) and
        prndword(Rstk1in) and format(" ") and 
        prnqword(Rstk1) and format(" ") and prnword(Rstk1b) and 
        format("\n") and*/
        tcl("stack",[Rstktop,(Rstkbot + 1) mod (noslots + 1),(Rstktop + 1) mod (noslots +1),strdword(Rstk1in),strqword(Rstk1),strword(Rstk1b)]) and
        /* format("reading from Queue[%t] the value \n", Rstkbot) and
        prndword(Stack[Rstkbot][0]) and format(" ") and
        prnqword(Stack[Rstkbot][1]) and format(" ") and
        prnword(Stack[Rstkbot][2]) and format("\n")*/
        tcl("stack",[Rstkbot,(Rstkbot + 1) mod (noslots + 1),(Rstktop + 1) mod (noslots +1),strdword(Stack[Rstkbot][0]),strqword(Stack[Rstkbot][1]),strword(Stack[Rstkbot][2])])
        }
       }
      else { 
       initdword(Pinst0) and initqword(Pda0)  and
       initword(Pdb0) and Pstrb0 = false and
       /*format("writing to Queue[%t] the value \n", Rstktop) and
       prndword(Rstk1in) and format(" ") and 
       prnqword(Rstk1) and format(" ") and prnword(Rstk1b) and 
       format("\n") and*/
       tcl("stack",[Rstktop,Rstkbot,(Rstktop + 1) mod (noslots + 1),strdword(Rstk1in),strqword(Rstk1),strword(Rstk1b)]) and
       Rstktop := (Rstktop + 1) mod (noslots + 1) and Rstkbot := Rstkbot and
       forall j<noslots+1: {
        if  j ~= Rstktop then { (next Stack[j]) = Stack[j]} 
        else { (next Stack[j][1]) = Rstk1 and 
               (next Stack[j][2]) = Rstk1b and
               (next Stack[j][0]) = Rstk1in } } and
       if (Rstktop + 1) mod (noslots + 1) = Rstkbot then {
        haltproc ("*** Stack Overflow ***") } } }
     else {
      if  (~Zilock0 and (Rstktop ~= Rstkbot)) then {
       Rstktop := Rstktop and
         forall j<noslots+1: {(next Stack[j]) = Stack[j]} and
       /*format("reading from Queue[%t] the value \n", Rstkbot) and
        prndword(Stack[Rstkbot][0]) and format(" ") and
        prnqword(Stack[Rstkbot][1]) and format(" ") and
        prnword(Stack[Rstkbot][2]) and format("\n")  and*/
       tcl("stack",[Rstkbot,(Rstkbot + 1) mod (noslots + 1),Rstktop,strdword(Stack[Rstkbot][0]),strqword(Stack[Rstkbot][1]),strword(Stack[Rstkbot][2])]) and
       Pda0=Stack[Rstkbot][1] and Pdb0 = Stack[Rstkbot][2] and
       Pinst0 = Stack[Rstkbot][0] and
       Rstkbot := (Rstkbot + 1) mod (noslots + 1) and Pstrb0 = true }
      else {
       Rstkbot := Rstkbot and Rstktop:= Rstktop and
       forall j<noslots+1: {(next Stack[j]) = Stack[j]} and
       Pstrb0 = false and initdword(Pinst0)  and
       initqword(Pda0) and initword(Pdb0) } } and
     Rstk1 := Sda0 and Rstk1b := Sdb0 and
     Rstk1in := Sinst0 and Rstk1s := Sstrb0 
   } 
   and

   define io(Pinst0, Pda0, Pdb0, Pstrb0, Zvalid0, Zilockb0,
     Minst0, Mda0, Mstrb0, Zilocka0, Ziopreq0) = {

     exists row0, row1, row2, row3, temp, temp1, temp2, iflagiop, 
      address, tiopcaddr, oflagiop, iopbufferiop, 
      ioptaskiop, iopaddriop : { 

      if Booting then {
       oflagiop = Oflag and 
       if Fiop >= |Io| then {
        ioptaskiop = "go" and  iflagiop = true and
        Booting := false and iopaddriop = 0 and 
        Intaddr := Intaddr and iopbufferiop = "00000000" and  Fiop := Fiop }
       else {
        Booting := Booting  and iopbufferiop = Io[Fiop] and 
        Fiop := Fiop + 1 and ioptaskiop = "win" and
        iopaddriop = Intaddr and Intaddr := Intaddr + 4 and 
        iflagiop = true } }
      else {
       iopbufferiop = "00000000"  and ioptaskiop = "go" and 
       iopaddriop = 0 and iflagiop = Iflag and
       Intaddr := Intaddr and Booting := Booting and Fiop := Fiop and
       if Oflag then {punchword (Iopobuff) and oflagiop = false }
       else { oflagiop = Oflag } }  and 
      if Riopsta = 0 then {
       Iopcaddr := Iopcaddr and
       (next Cachetag) = Cachetag and
       forall i<csize+1: { (next Cache[i]) = Cache[i] } and
       Iopobuff := Iopobuff and Oflag := oflagiop and  
       if iflagiop then {
        if ioptaskiop = "win" then {
         Mda0[3] = hexbinbyte (iopbufferiop[0], iopbufferiop[1]) and
         Mda0[2] = hexbinbyte (iopbufferiop[2], iopbufferiop[3]) and
         Mda0[1] = hexbinbyte (iopbufferiop[4], iopbufferiop[5]) and
         Mda0[0] = hexbinbyte (iopbufferiop[6], iopbufferiop[7]) and
         forall i<12 : { Mda0[4 + i]=0 } and
         Minst0[7] = 143 and Minst0[6] = 0 and
         Minst0[5] = iopaddriop div 256 and
         Minst0[4] = iopaddriop mod 256 and
         Minst0[3] = 0 and Minst0[2] = 0 and  Minst0[1] = 0 and
         Minst0[0] = 0 and  Mstrb0 = true and
         Ziopreq0 = true and Zilocka0 = true and
         Iflag := false and Riopsta := 0}
        else {
          if ioptaskiop = "go" then {
           Minst0[7] =  0 and Minst0[6] =  0 and Minst0[5] =  0 and
           Minst0[4] =  0 and Minst0[3] =  240 and Minst0[2] =  0 and
           Minst0[1] =  0 and Minst0[0] =  0 and Mstrb0 = true and
           Ziopreq0 = true and Zilocka0 = true and
           initqword(Mda0) and Iflag := false and Riopsta := 20}
          else {
           Iopcaddr := Iopcaddr and Iflag := iflagiop and
           Ziopreq0 = false and 
           {if ~Rii1s or ~Zvalid0 then {Mstrb0 = false}} and
            Zilocka0 = false and Riopsta := Riopsta } } }
       else {
         Iflag := iflagiop and Ziopreq0 = false and 
         {if ~Rii1s or ~Zvalid0 then {Mstrb0 = false}} and
         Zilocka0 = false and Riopsta := Riopsta } }  and
      if Riopsta = 4 then {
       tiopcaddr = 
        ((Riopi[1] * 256 + Riopi[0]) div 
         ((cgran + 1) * 8)) * ((cgran + 1) * 8) and
       Iopcaddr := tiopcaddr and  
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (tiopcaddr) div 256 and
       Minst0[4] = (tiopcaddr) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and
       temp2 = ((tiopcaddr) div 8) mod (csize + 1) and
       forall i<csize+1: {
        if i~= temp2 then { (next Cachetag[i]) = Cachetag[i] }
        else { (next Cachetag[i]) = tiopcaddr div ((csize + 1) * 8)} and
        (next  Cache[i])  = Cache[i] } and 
       Riopsta := 5 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 5 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 4) div 256 and
       Minst0[4] = (Iopcaddr + 4) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and (next Cachetag) = Cachetag and 
       forall i<csize+1:{(next Cache[i])  = Cache[i]} and 
       Riopsta := 6 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 6 then {
       Iopcaddr := Iopcaddr and  
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 8) div 256 and
       Minst0[4] = (Iopcaddr + 8) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp2 = ((Iopcaddr + 8) div 8) mod (csize + 1) and 
       forall i<csize+1: {
        if i~= temp2 then { (next Cachetag[i]) = Cachetag[i] }
        else { (next Cachetag[i]) = Iopcaddr div ((csize + 1) * 8)} and
        (next Cache[i])  = Cache[i] } and 
       Riopsta := 7 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff } and
      if Riopsta = 7 then { 
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 12) div 256 and
       Minst0[4] = (Iopcaddr + 12) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row0 = (temp1 div 8) mod (csize + 1) and
       (next Cache[row0][0]) = Rstk1b[2] and
       (next Cache[row0][1]) = Rstk1b[3] and
       (next Cache[row0][2]) = Rstk1b[0] and
       (next Cache[row0][3]) = Rstk1b[1] and
       forall j<12 : { (next Cache[row0][j+4]) = Cache[row0][j+4] }and 
       forall i< csize+1 : {
        if i ~= row0 then {
         (next Cache[i]) = Cache[i] } } and
       (next Cachetag) = Cachetag and 
       Riopsta := 8 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff } and
      if Riopsta = 8 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 16) div 256 and
       Minst0[4] = (Iopcaddr + 16) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and  
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       temp2 = ((Iopcaddr + 16) div 8) mod (csize + 1) and
       row1 = ((temp1 + 4) div 8) mod (csize + 1) and
       forall j< 16 : if j<4 or j>7 then { 
                       (next Cache[row1][j]) = Cache[row1][j]} and 
       (next Cache[row1][4]) = Rstk1b[2] and
       (next Cache[row1][5]) = Rstk1b[3] and
       (next Cache[row1][6]) = Rstk1b[0] and
       (next Cache[row1][7]) = Rstk1b[1] and
       forall i< csize+1 : {
         if i~= temp2 then { (next Cachetag[i]) = Cachetag[i] }
         else { (next Cachetag[i]) = Iopcaddr div ((csize + 1) * 8)} and
         if i ~= row1  then { (next Cache[i]) = Cache[i] } }and
       Riopsta := 9 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 9 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 20) div 256 and
       Minst0[4] = (Iopcaddr + 20) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row0 = ((temp1 + 8) div 8) mod (csize + 1) and
       row2 = (temp1 div 8) mod (csize + 1) and
       forall j<12 : {(next Cache[row0][4+j]) = Cache[row0][4+j]} and
       (next Cache[row0][0]) = Rstk1b[2] and
       (next Cache[row0][1]) = Rstk1b[3] and
       (next Cache[row0][2]) = Rstk1b[0] and
       (next Cache[row0][3]) = Rstk1b[1] and
       forall j<16 : if j<8 or j>11 then {
               (next Cache[row2][j]) = Cache[row2][j]} and
       (next Cache[row2][8]) = Rstk1b[2] and
       (next Cache[row2][9]) = Rstk1b[3] and
       (next Cache[row2][10]) = Rstk1b[0] and
       (next Cache[row2][11]) = Rstk1b[1] and    
       forall i< csize+1 : {
        if i ~= row0  and i ~= row2 then {
         (next Cache[i]) = Cache[i] } } and 
        (next Cachetag)  = Cachetag  and 
       Riopsta := 10 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff } and
      if Riopsta = 10 then { 
       Iopcaddr := Iopcaddr and  
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 24) div 256 and
       Minst0[4] = (Iopcaddr + 24) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row1 = ((temp1 + 12) div 8) mod (csize + 1) and
       row3 = ((temp1 + 4) div 8) mod (csize + 1) and
       temp2 =((Iopcaddr + 24) div 8) mod (csize + 1) and 
       forall j<16: if j<4 or j>7 then {
                      (next Cache[row1][j]) = Cache[row1][j]} and
       (next Cache[row1][4]) = Rstk1b[2] and
       (next Cache[row1][5]) = Rstk1b[3] and
       (next Cache[row1][6]) = Rstk1b[0] and
       (next Cache[row1][7]) = Rstk1b[1] and
       forall j<12 : (next Cache[row3][j]) = Cache[row3][j] and
       (next Cache[row3][12]) = Rstk1b[2] and
       (next Cache[row3][13]) = Rstk1b[3] and
       (next Cache[row3][14]) = Rstk1b[0] and
       (next Cache[row3][15]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i~= temp2 then { (next Cachetag[i]) = Cachetag[i] }
        else { (next Cachetag[i]) = Iopcaddr div ((csize + 1) * 8)} and
        if i ~= row1 and i ~= row3 then {
         (next Cache[i]) = Cache[i] } }and
       Riopsta := 11 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 11 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 28) div 256 and
       Minst0[4] = (Iopcaddr + 28) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row0 = ((temp1 + 16) div 8) mod (csize + 1) and
       row2 = ((temp1 + 8) div 8) mod (csize + 1) and
       forall j<12 : (next Cache[row0][j+4]) = Cache[row0][j+4] and 
       (next Cache[row0][0]) = Rstk1b[2] and
       (next Cache[row0][1]) = Rstk1b[3] and
       (next Cache[row0][2]) = Rstk1b[0] and
       (next Cache[row0][3]) = Rstk1b[1] and
       forall j<16 : if j<8 or j>11 then{
                      (next Cache[row2][j]) = Cache[row2][j]} and 
       (next Cache[row2][8]) = Rstk1b[2] and
       (next Cache[row2][9]) = Rstk1b[3] and
       (next Cache[row2][10]) = Rstk1b[0] and
       (next Cache[row2][11]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row0  and i ~= row2 then {
         (next Cache[i]) = Cache[i] } } and
       (next Cachetag)  = Cachetag  and
       Riopsta := 12 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 12 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 32) div 256 and
       Minst0[4] = (Iopcaddr + 32) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row1 = ((temp1 + 20) div 8) mod (csize + 1) and
       row3 = ((temp1 + 12) div 8) mod (csize + 1) and
       forall j<16 : if j<4 or j>7 then{
                     (next Cache[row1][j]) = Cache[row1][j]} and
       (next Cache[row1][4]) = Rstk1b[2] and
       (next Cache[row1][5]) = Rstk1b[3] and
       (next Cache[row1][6]) = Rstk1b[0] and
       (next Cache[row1][7]) = Rstk1b[1] and
       forall j<12 : (next Cache[row3][j]) = Cache[row3][j] and
       (next Cache[row3][12]) = Rstk1b[2] and
       (next Cache[row3][13]) = Rstk1b[3] and
       (next Cache[row3][14]) = Rstk1b[0] and
       (next Cache[row3][15]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row1 and i ~= row3 then {
         (next Cache[i]) = Cache[i] } } and 
       (next Cachetag)  = Cachetag  and
       Riopsta := 13 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 13 then {
       Iopcaddr := Iopcaddr and 
       Minst0[7] = 129 and  Minst0[6] = 0 and Minst0[3] = 0 and
       Minst0[5] = (Iopcaddr + 36) div 256 and
       Minst0[4] = (Iopcaddr + 36) mod 256 and
       Minst0[2] = 0 and Minst0[1] = 0 and Minst0[0] = 0 and
       Mstrb0 = true and Ziopreq0 = true and Zilocka0 = true and
       initqword(Mda0) and 
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row0 = ((temp1 + 24) div 8) mod (csize + 1) and
       row2 = ((temp1 + 16) div 8) mod (csize + 1) and
       forall j<12: (next Cache[row0][j+4]) = Cache[row0][j+4] and 
       (next Cache[row0][0]) = Rstk1b[2] and
       (next Cache[row0][1]) = Rstk1b[3] and
       (next Cache[row0][2]) = Rstk1b[0] and
       (next Cache[row0][3]) = Rstk1b[1] and
       forall j<16: if j<8 or j>11 then {
                     (next Cache[row2][j]) = Cache[row2][j]} and
       (next Cache[row2][8]) = Rstk1b[2] and
       (next Cache[row2][9]) = Rstk1b[3] and
       (next Cache[row2][10]) = Rstk1b[0] and
       (next Cache[row2][11]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row0 and i ~= row2 then {
         (next Cache[i]) = Cache[i] } } and 
        (next Cachetag)  = Cachetag  and 
       Riopsta := 14 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 14 then {
       Iopcaddr := Iopcaddr and Ziopreq0 = true and Zilocka0=true and
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row1 = ((temp1 + 28) div 8) mod (csize + 1) and
       row3 = ((temp1 + 20) div 8) mod (csize + 1) and
       forall j<16 : if j<4 or j>7 then { 
                      (next Cache[row1][j]) = Cache[row1][j]} and
       (next Cache[row1][4]) = Rstk1b[2] and
       (next Cache[row1][5]) = Rstk1b[3] and
       (next Cache[row1][6]) = Rstk1b[0] and
       (next Cache[row1][7]) = Rstk1b[1] and
       forall j<12: (next Cache[row3][j]) = Cache[row3][j] and
       (next Cache[row3][12]) = Rstk1b[2] and
       (next Cache[row3][13]) = Rstk1b[3] and
       (next Cache[row3][14]) = Rstk1b[0] and
       (next Cache[row3][15]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row1 and i ~= row3 then {
         (next Cache[i]) = Cache[i] } } and 
       (next Cachetag)  = Cachetag  and 
       initdword(Minst0) and Mstrb0 = false and initqword(Mda0) and
       Riopsta := 15 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 15 then {
        Iopcaddr := Iopcaddr and Ziopreq0 = true and Zilocka0=true and
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row2 = ((temp1 + 24) div 8) mod (csize + 1) and
       forall j<16: if j<8 or j>11 then {
                     (next Cache[row2][j]) = Cache[row2][j]} and
       (next Cache[row2][8]) = Rstk1b[2] and
       (next Cache[row2][9]) = Rstk1b[3] and
       (next Cache[row2][10]) = Rstk1b[0] and
       (next Cache[row2][11]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row2 then {
         (next Cache[i]) = Cache[i] } } and 
         (next Cachetag)  = Cachetag  and 
        initdword(Minst0) and Mstrb0 = false and initqword(Mda0) and
        Riopsta := 16 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 16 then {
       Iopcaddr := Iopcaddr and Ziopreq0 = true and Zilocka0=true and
       temp = Ralu1in[1]*256 + Ralu1in[0] and
       temp1 = temp - ( temp mod ((cgran + 1)*8)) and
       row3 = ((temp1 + 28) div 8) mod (csize + 1) and
       forall j<12: (next Cache[row3][j]) = Cache[row3][j] and
       (next Cache[row3][12]) = Rstk1b[2] and
       (next Cache[row3][13]) = Rstk1b[3] and
       (next Cache[row3][14]) = Rstk1b[0] and
       (next Cache[row3][15]) = Rstk1b[1] and
       forall i< csize+1 : {
        if i ~= row3 then {
         (next Cache[i]) = Cache[i] } } and 
        (next Cachetag)  = Cachetag  and 
       initdword(Minst0) and Mstrb0 = false and initqword(Mda0) and
       Riopsta := 20 and Iflag := iflagiop and Oflag := oflagiop and
       Iopobuff := Iopobuff }  and
      if Riopsta = 20 then {
       Iopcaddr := Iopcaddr and Iflag := iflagiop and 
       (next Cachetag) = Cachetag and
       forall i<csize+1: {(next Cache[i])  = Cache[i]}  and
       if Riops then {
        if Riopi[2] div 16 = 0 then { 
         address = Riopi[1] * 256 + Riopi[0] and
         Iopobuff := Iopobuff and Oflag := oflagiop and
         if ((Cachetag[(address div 8) mod (csize + 1)]
            ~= address div ((csize + 1) * 8))) then {
          Riopsta := 4 and Zilocka0 = true and Ziopreq0 = true and 
          initdword(Minst0) and Mstrb0 = false and initqword(Mda0) }
         else {
          Riopsta := 20 and Zilocka0 = false and Ziopreq0 = false and 
          {if ~Rii1s or ~Zvalid0 then {Mstrb0 = false} } } }
        else {
         address = 0 and Riopsta := 20 and Iopobuff := Riopd
         and Oflag := true and Ziopreq0 = false and Zilocka0 = false and 
         {if ~Rii1s or ~Zvalid0 then {Mstrb0 = false} } } }         
       else {
        Riopsta := 20 and address = 0 and Oflag := oflagiop and 
        Iopobuff := Iopobuff and  Zilocka0 = false and 
        Ziopreq0 = false and 
        {if ~Rii1s or ~Zvalid0 then {Mstrb0 = false}  } } } and
    if ~(Zilocka0 or Zilockb0) then {
      Riopi := Pinst0 and Riops := Pstrb0 and Riopd := Pda0 }
     else {
      Riopi := Riopi and Riops := Riops and Riopd := Riopd } 
    } 
   }
   and

   define heading() = {
     format ("EPSIM3 - Event Processor / 3 Simulator Vn %t\n",version) and
     format ("Constant Statistics\n") and
     format ("Cycle Time = 1/%t us\n", cyctime) and
     format ("I/O Rate = %t  bytes / s\n", 4000000*cyctime  / (iorate))
   }
   and
   define tracehdg() = {
     if proctrace then {
      format("State at Start of Cycle\n\n") 
     }
   }
   and
   define tracetail() = {
     format ("\n") and
     format ("Stop Instruction Executed\n") and
     format ("Cumulative Statistics\n") and
     format ("\n") and
     format ("Total Cycles = %t\n", Cycle) and
     format ("Processing Cycles = %t during which\n", Proccycle) and
     format ("  Elapsed Time = %t us\n", Proccycle / cyctime) and
     format ("  Instructions Executed = %t\n", Instcnt) and
     if  Proccycle / cyctime > 0 then {
      format ("  Execution Rate = %t  MIPS\n", Instcnt *cyctime/ Proccycle)
     }
     and
     if Instcnt > 0 then {
      format ("  Mean Cycles / Instruction = %t\n", Proccycle / Instcnt)
     }
     and       
     if Proccycle > 0 then {
      format ("  Efficiency = %t\n", Usecnt / Proccycle)
     }
     and
     format ("\n")
   }
   and
   define display_x() = {
    tcl("info",  [Cycle,Proccycle,Riopsta,Zilocka,Zilockb,Ziopreq,Zvalid]) and
    tcl("pipezero", [strdword(Ralu1in),Ralu1s,strqword(Ralu1a),strword(Ralu1b)]) and
    tcl("pipeone", [strdword(Rii1),Rii1s,strqword(Ralu2),Rii1dest]) and
    tcl("pipetwo", [strdword(Rmem1in),Rmem1s,strqword(Rmem1)]) and
    tcl("rsp",   [strhword(Rsp[0]),strhword(Rsp[1]),strhword(Rsp[2])]) and
    tcl("pipethree", [strdword(Rmem2in),Rmem2s,strqword(Rmem2),strword(Rmem2b)]) and
    tcl("pipefour", [strdword(Rstk1in),Rstk1s,strqword(Rstk1),strword(Rstk1b),Zilocka or Zilockb]) /*and
    
     (forall i<noslots+1 : if Rstkbot~=(next Rstkbot) or
                              Rstktop~=(next Rstkbot) then 
          tcl("stack",[i,Rstkbot,Rstktop,strdword(Stack[i][0]),strqword(Stack[i][1]),strword(Stack[i][2])]) 
          )  */
   } and
   define trace() = {
     if  ((proctrace) and  Riopsta=20 and
          (Proccycle >= ptstart) and 
          (Proccycle <= ptstop)) then {
      format("\n") and
      format("Cycle  Proccycle Iopsta Zilocka  Zilockb  Ziopreq Zvalid\n") and
      format("%5t  ", Cycle) and
      format("%9t   ",Proccycle) and 
      format("%5t   ", Riopsta) and
      prnbool (Zilocka) and format("        ") and
      prnbool (Zilockb) and format("        ") and
      prnbool (Ziopreq) and format("       ") and
      prnbool (Zvalid) and format("\n") and
      format("---------ralu1in ralu1s F3-------F2-------F1-------F0-ralu1a --ralu1b\n")
      and
      prndword (Ralu1in) and format("    ") and
      prnbool (Ralu1s) and format("   ") and
      prnqword1 (Ralu1a) and format(" ") and
      prnword (Ralu1b) and format("\n") and
      format("------------rii1 -rii1s -------------------------------ralu2 rii1dest\n")
      and
      prndword (Rii1) and format("    ") and
      prnbool (Rii1s) and format("   ") and
      prnqword1 (Ralu2) and format("    ") and
      format("%t", Rii1dest) and format("\n") and
      format("---------rmem1in rmem1s -------------------------------rmem1 rsp0 rsp1 rsp2\n")
      and
      prndword (Rmem1in) and format("    ") and
      prnbool (Rmem1s) and format("   ") and
      prnqword1 (Rmem1) and format(" ") and
      prnhword (Rsp[0]) and format(" ") and
      prnhword (Rsp[1]) and format(" ") and
      prnhword (Rsp[2]) and format("\n") and
      format("---------rmem2in rmem2s -------------------------------rmem2 --rmem2b\n")
      and
      prndword (Rmem2in) and format("    ") and
      prnbool (Rmem2s) and format("   ") and
      prnqword1 (Rmem2) and format(" ") and
      prnword (Rmem2b) and format("\n") and
      format("---------rstk1in rstk1s -------------------------------rstk1 --rstk1b\n")
      and
      prndword(Rstk1in) and format("    ") and
      prnbool (Rstk1s) and format("   ") and
      prnqword1 (Rstk1) and format(" ") and
      prnword (Rstk1b) and format("\n") and format("\n") 
     }
   }
   and
    define typestat() = {
     if Proccycle > 0 and Riopsta=20 then {
      format("\n") and
      format("Cyc = %6t", Cycle) and
      format (", Proc Cyc = %6t", Proccycle) and
      format (", Time = %5t us",  Proccycle / cyctime) and
      format (", Instrs = %6t", Instcnt) and
      format (", MIPS = %3t",  (Instcnt * cyctime/ Proccycle))  and
     format ("\n")}
   }
   and
   
   
   type_declaration() and initvar() and
   format("EPSIM3 - Event Processor / 3 Simulator Vn %t\n", version) and 
   format("Free Memory = %t kbytes\n",  ((msize+1) / 256) ) and 
   format("Running Simulation  - Cumulative Statistics:\n") and
   heading() and tracehdg() and
   tcl("init",[msize,noslots]) and always tclbreak() and
   {repeat { 
     skip  and Cycle := Cycle + 1 and
     if ~Booting then {Proccycle := Proccycle + 1}
     else {Proccycle := Proccycle} and
         /*typestat()  and*/
     io(Pinst, Pda, Pdb, Pstrb, Zvalid, Zilockb,
        Minst, Mda, Mstrb, Ziopreq, Zilocka)  and
     pipe0(Pinst, Pda, Pdb, Pstrb, Zilocka or Zilockb,
           Iinst, Istrb, Ialu2in, Ialu2c, Ialu2, Ialu2z, Ialu2s) and
     pipe1(Iinst, Istrb, Zilocka,  Ziopreq, Ialu2in, Ialu2c,
           Ialu2, Ialu2z, Ialu2s,
           Minst, Mda, Mstrb, Zvalid, Zilockb) and
     pipe2(Minst, Mda, Mstrb, 
           Mmem2, Mmem2b, Mmem2in, Mmem2s) and
     pipe3(Mmem2, Mmem2b, Mmem2in, Mmem2s,
           Sinst, Sda, Sdb, Sstrb) and
     pipe4(Sinst, Sda, Sdb, Sstrb, Zilocka or Zilockb,
           Pinst, Pda, Pdb, Pstrb)  and
     display_x() and
     if (ioptrace) then { trace() } 
    }
    until (Stopped) 
   };
   {empty and tracetail() and if memprn then {prnmem() and prncache()}
   }
  }
}.

set print_states=false.
set assign_ahead=true.
