/* -*- Mode: C -*-
 * library of commands to convert various types
 */

define dig = "0123456789".

define hex="0123456789ABCDEF".
define hwordlen = 1.
define fwordlen = 3.
define dwordlen = 7.
define qwordlen = 15.
define flowlength = 15.

define strb(x) = {
   if x then "1" else "0"
}.

define strbyte(x) = {
   hex[x div 16] + hex[x mod 16]
}.

define strhword(x) = {
   strbyte(x[hwordlen])+strbyte(x[hwordlen-1])
}.

define strword(x) = {
   strbyte(x[fwordlen  ])+strbyte(x[fwordlen-1])+
   strbyte(x[fwordlen-2])+strbyte(x[fwordlen-3])
}.

define strdword(x) = {
   strbyte(x[dwordlen  ])+strbyte(x[dwordlen-1])+
   strbyte(x[dwordlen-2])+strbyte(x[dwordlen-3])+
   strbyte(x[dwordlen-4])+strbyte(x[dwordlen-5])+
   strbyte(x[dwordlen-6])+strbyte(x[dwordlen-7]) 
}.

define strqword(x) = {
   strbyte(x[qwordlen   ])+strbyte(x[qwordlen- 1])+
   strbyte(x[qwordlen- 2])+strbyte(x[qwordlen- 3])+
   strbyte(x[qwordlen- 4])+strbyte(x[qwordlen- 5])+
   strbyte(x[qwordlen- 6])+strbyte(x[qwordlen- 7])+
   strbyte(x[qwordlen- 8])+strbyte(x[qwordlen- 9])+
   strbyte(x[qwordlen-10])+strbyte(x[qwordlen-11])+
   strbyte(x[qwordlen-12])+strbyte(x[qwordlen-13])+
   strbyte(x[qwordlen-14])+strbyte(x[qwordlen-15]) 
}.

define abs(x) = {
   if x<0 then -1*x else x
}.

define str(x) = {
    if x<0 then { "-"+str(abs(x)) } else
     if 0<=x and x<10 then dig[x]
     else str(x div 10) + str(x mod 10)
}.

define ctype(Y) = {
 if type(Y)="integer" then str(Y)
    else if type(Y)="bool" then strb(Y)
         else if type(Y)="string" then Y
              else "error"
}.

define parstr(Y) = {
 if |Y|=1 then ctype(Y[0])+":"
          else ctype(Y[0])+":"+parstr(Y[1..|Y|])
}.

define pref(X,Y) = {
   X[0..Y]
}.

define suf(X,Y) = {
   X[Y..|X|]
}.
define no_ch_1(X) = {
  skip and stable X
}. 

define no_ch_2(X,Y) = {
  skip and stable X and stable Y
}.

define no_ch_3(X,Y,Z) = {
  skip and stable X and stable Y and stable Z
}.

define no_ch_4(W,X,Y,Z) = {
  skip and stable W and stable X and stable Y and stable Z
}.

define no_ch_5(V,W,X,Y,Z) = {
  skip and stable V and stable W and stable X and stable Y and stable Z
}.

define no_ch_6(U,V,W,X,Y,Z) = {
  skip and stable U and stable V and stable W and
           stable X and stable Y and stable Z
}.

define no_ch_7(T,U,V,W,X,Y,Z) = {
  skip and stable T and stable U and stable V and stable W and
           stable X and stable Y and stable Z
}.

define strint(Y) = {
 if |Y|=0 then 0
 else if Y[0]="x" then "x"
      else {
          if Y[0]="-" then -1*strint(Y[1..|Y|])
          else (ascii(Y[0])-48)*(10**(|Y|-1)) + strint(Y[1..|Y|])
      }
}.

define avar(X) = 
{
    X[0]
}.

define aval(X) = 
{
    X[1]
}.

define atime(X) = 
{
    strint(X[2])
}.

define get(Xin) = {
   empty and input Xin
}.

define get2(Xin) = {
    input Xin
}.
