/* -*- Mode: C -*-
 * Lift simulation 
 * Need to modify so that each call is only answered by one lift 
 *
 */

define n = 2.
define m = 6.

define s = 0.
define u = 1.
define d = -1.

define c = 0.
define o = 1.

/* run */ define system_na() = exists E,S,P,B,C,Bu,Cu,Bd,Cd,
			 lift,in_service,out_of_service,s0,s1,s2,s3,s4,
			 idle,going_up,going_down,pause_up,pause_down,
			 main_control,lift_control,
			 called,called_up,called_down,calls,
			 stop_up,stop_down,
			 every,display,lift_calls: {
			     
define lift(i) = {
    P[i] = 0 and
    lift_control(i) and
    repeat {
      in_service(i);
      out_of_service(i)
    } until false
  } and

define in_service(i) = {
    halt(E[i]) and prefix s0(i)
  } and

define out_of_service(i) = {
    halt(~E[i])
  } and

define s0(i) = {
    idle(i);
    if called_up(i) then s1(i) else s2(i)
  } and

define idle(i) = {
    halt(called(i)) and keep{S[i] = [s,c]} and stable P[i]
  } and

define s1(i) = {
    going_up(i);
    if called_up(i) then s3(i) else s4(i)
  } and

define going_up(i) = {
    halt(stop_up(i)) and keep{S[i] = [u,c]} and P[i] gets P[i]+1
  } and

define s2(i) = {
    going_down(i);
    if called_down(i) then s4(i) else s3(i)
  } and

define going_down(i) = {
    halt(stop_down(i)) and keep{S[i] = [d,c]} and P[i] gets P[i]-1
  } and

define s3(i) = {
    pause_up(i);
    if called_up(i) then s1(i) else s0(i)
  } and

define pause_up(i) = {
    skip and keep{S[i] = [u,o]} and stable P[i]
  } and

define s4(i) = {
    pause_down(i);
    if called_down(i) then s2(i) else s0(i)
  } and

define pause_down(i) = {
    skip and keep{S[i] = [d,o]} and stable P[i]
  } and

define lift_control(i) = {
    array(B[i],m) and
    array(C[i],m) and
    forall j<m : {
      C[i][j] = false and
      C[i][j] gets ((C[i][j] and ~(P[i]=j)) or B[i][j])
    }
  } and

define main_control() = {
    array(E,n) and
    array(S,n) and
    array(P,n) and
    array(B,n) and 
    array(C,n) and 
    array(Bu,m) and
    array(Cu,m) and
    array(Bd,m) and
    array(Cd,m) and
      
    forall j<m : floor_control(j)
    
  } and

define floor_control(i) = {
    Cu[i] = false and
    Cd[i] = false and
    Cu[i] gets ((Cu[i] and ~exists j<n : (P[j]=i and S[j][0]=u)) or Bu[i]) and
    Cd[i] gets ((Cd[i] and ~exists j<n : (P[j]=i and S[j][0]=d)) or Bd[i])
  } and

define called(i) = calls(i,0,m) and
define called_up(i) = (calls(i,P[i]+1,m) or Cu[P[i]]) and
define called_down(i) = (calls(i,0,P[i]) or Cd[P[i]]) and
define calls(i,x,y) = exists j<y-x:(C[i][x+j] or Cu[x+j] or Cd[x+j]) and

define stop_up(i) = (C[i][P[i]] or Cu[P[i]] or ~called_up(i)) and
define stop_down(i) = (C[i][P[i]] or Cd[P[i]] or ~called_down(i)) and
  
define display() = {
    home_cifer() and
    format("\nSTATE %#\n") and
    if S=S and C=C and Cd=Cd and Cu=Cu and P=P then
    forall i<m : exists f : {
      f = m-1-i and
      format("Floor %d: %2s%2s", f,
            if Cu[f] then "+ " else "",
          if Cd[f] then "- " else "") and
      forall l<n : {
        if P[l] = f
        then format("%7s %12t",
              if S[l][1]=o then "open " else "closed",
              lift_calls(l,m-1))
        else format("%20s","")
      } and
      format("\n")
    } 
  } and

define lift_calls(l,f) = (if f<0 then [] else
        ((if C[l][f] then [f] else []) + lift_calls(l,f-1))) and

define every(x,y,z,X) = {
    len (x-1) and keep{X=false};
    skip and X=true;
    every(y,z,x,X)
  } and

  clear_cifer() and

    
  forall i<m : {
/*
    if i<m-1 then every(1+5*i,6*m+2*i,15*m+3-15*i,Bu[i])
         else Bu[i] is false and
    if i>0 then every(1+5*i,9*m+i+3,2*m+5*i,Bd[i])
        else Bd[i] is false and
    forall j<n : {
      every(17+3*i+5*j,4*m+4*i-2*j,5*m-3-5*i+7*j,B[j][i])
    }
*/
    if i<m-1 then every(5*m-1-5*i,6*m+2*i,15*m+3-15*i,Bu[i])
         else Bu[i] is false and
    if i>0 then every(9*m-1-9*i,9*m+i+3,2*m+5*i,Bd[i])
        else Bd[i] is false and
    forall j<n : {
      every(1+3*i+5*j,4*m+4*i-2*j,5*m-3-5*i+7*j,B[j][i])
    }
  } and
/*  forall i<n : E[i] is false and*/
  forall i<n : while true do {
    len 20 and keep E[i]=false;
    len 5+5*i and keep E[i]=true and keep_stable(S[i]) and stable(P[i]);
    len 200+100*i and keep E[i]=false
  } and
  main_control() and
  forall i<n : lift(i) and
  always display()
}.

define clear_cifer() = format("J").
define clear_bbc() = format("").
define home_cifer() = format("H").
define home_bbc() = format("").

set print_states=false.
set verbosity=1.
set assign_ahead=false.        

define keep_stable(X) = exists x:{x=X and keep {X=x}}.

define array(L,n) = {
  list(L,n) and stable_struct(L)
}.

