# lifts5.tcl --
#
#	This file implements package lifts-simple, which  ...
#
# Copyright (c) 1998-1999 Antonio Cau
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#package require NAME VERSION
package provide lifts5 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
#namespace export -clear *
variable nlifts;
variable nfloor;
variable canv;
variable prev;
variable prevop;
variable nfloors;
variable col;
variable prevty;


# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
  variable canv;
  variable nlifts;
  variable prev;
  variable prevop;
  variable nfloors;
  variable col;
  variable prevty;
    
    set nlifts  [lindex $nl 0];
    set nfloors [lindex $nl 1];
    set tmlift  [lindex $nl 2];
    set col(0) black;
    set col(1) bisque;
    set col(2) blue;

    $canv delete all
    $canv config -scrollregion "0 0 1000 600"

    for {set i 0} {$i<$nlifts} {incr i} {
     set prev($i) 0;
     set prevop($i) 1;
     set prevty($i) [expr $tmlift-1];
     $canv create line \
         [expr 60+50*$i] [expr $nfloors*40+20] \
         [expr 60+50*$i] [expr $nfloors*40+40] \
      -width 30 -fill $col(1) -tags lift($i) 
    }

    for {set i 0} {$i<$nlifts} {incr i} {
     $canv create line [expr 57+50*$i] [expr $nfloors*40+30-$nfloors*20*$tmlift] \
        [expr 57+50*$i] [expr $nfloors*40+30-$nfloors*20*$tmlift-8] \
     -arrow first -fill $col(0) -width 2 -tags dird($i)
     $canv create line [expr 63+50*$i] [expr $nfloors*40+30-$nfloors*20*$tmlift] \
        [expr 63+50*$i] [expr $nfloors*40+30-$nfloors*20*$tmlift-8] \
     -arrow last -fill $col(0) -width 2 -tags diru($i)
    }

    for {set i 0} {$i<$nfloors} {incr i} {
     $canv create text \
      10 [expr $nfloors*40+30-$i*20*$tmlift] -text $i
        if {$i > 0} {
         $canv create poly 20 [expr  $nfloors*40+28-$i*20*$tmlift] 26 [expr  $nfloors*40+28-$i*20*$tmlift] \
                       23 [expr  $nfloors*40+32-$i*20*$tmlift] \
        -fill $col(0) -width 2 -outline $col(0) -tags butd($i)
        }
        if { $i < $nfloors-1 } {
         $canv create poly 30 [expr  $nfloors*40+32-$i*20*$tmlift]  36 [expr  $nfloors*40+32-$i*20*$tmlift] \
                 33 [expr  $nfloors*40+28-$i*20*$tmlift] \
        -fill $col(0) -width 2 -outline $col(0) -tags butu($i)
        }
    }
    for {set i 0} {$i<$nlifts} {incr i} {
     for {set j 0} {$j<$nfloors} {incr j} {
         $canv create oval [expr 55+$i*50] [expr $nfloors*40+60+15*($nfloors-$j)] \
           [expr 55+$i*50+10] [expr $nfloors*40+60+15*($nfloors-$j)+10] \
           -fill $col(0) -outline $col(0) -tags but($i,$j)
         $canv create text [expr 70+$i*50] [expr $nfloors*40+62+15*($nfloors-$j)] \
            -text $j
     }
    }
    for {set i 0} {$i<$nlifts} {incr i} {
      $canv create poly [expr 55+$i*50] [expr $nfloors*40 +65+15*($nfloors+1)] \
        [expr 60+$i*50] [expr $nfloors*40+60+15*($nfloors+1)] \
        [expr 65+$i*50] [expr $nfloors*40+65+15*($nfloors+1)] \
        [expr 60+$i*50] [expr $nfloors*40+70+15*($nfloors+1)] \
         -fill $col(0) -tags buts($i)
    }    
   
}



# lift --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc lift {nl} {
  variable canv;
  variable prev;
  variable col;
  variable prevop;
  variable prevty;

  set ln  [lindex $nl 0]
  set y   [lindex $nl 1]
  set op  [lindex $nl 2]
  set ty  [lindex $nl 3]
  set dir [lindex $nl 4]

#  after 250
  
  if { $op == 1} {
      if { $prevop($ln) != $op } {
      for {set i 0} {$i<15} {incr i} {
       $canv itemconfigure lift($ln) -fill $col(2) -width [expr 15+$i]
       update idletasks
      }
      $canv itemconfigure lift($ln) -fill $col(1)
      set prevop($ln) $op
      }
  } else {
    if { $prevop($ln) != $op } { 
     for {set i 0} {$i<15} {incr i} {
     $canv itemconfigure lift($ln) -fill $col(2) -width [expr 30-$i]
     update idletasks
     }
     $canv itemconfigure lift($ln) -fill $col(0)
     set prevop($ln) $op
    }
  }

    if { $prev($ln)-$y != 0 || $prevty($ln)-$ty != 0} { 
        if { $prev($ln)-$y != 0 && $prevty($ln)-$ty != 0} {        
         for {set i 0} {$i<20} {incr i} { 
          $canv move lift($ln) 0 [expr ($prev($ln)-$y)]
          update idletasks
          } 
         } else {
           if { $prev($ln)-$y != 0} {
            for {set i 0} {$i<20} {incr i} { 
             $canv move lift($ln) 0 [expr ($prev($ln)-$y)]
             update idletasks
            }
           } else {
               if { $dir == 1 } { 
                for {set i 0} {$i<20} {incr i} { 
                 $canv move lift($ln) 0 -1
                 update idletasks
                }
               } else {
                 for {set i 0} {$i<20} {incr i} { 
                 $canv move lift($ln) 0 1
                 update idletasks
                 }
                }
            }
       }      
      set prev($ln) $y
   }
    

}

# floor --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc floor {nl} {
    variable canv;
    variable nfloors;
    variable col;

    set flo  [lindex $nl 0]
    set up   [lindex $nl 1]
    set down [lindex $nl 2]

    
    if {$flo > 0} {
     $canv itemconfigure butd($flo) -fill $col($down) -outline $col($down)
    }
    
     
    if { $flo < $nfloors-1 } {
      $canv itemconfigure butu($flo) -fill $col($up) -outline $col($up)
    }
}


# button --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc button {nl} {
   variable canv;
   variable nfloors;
   variable col;

   set ln  [lindex $nl 0]
   set flo [lindex $nl 1]
   set but [lindex $nl 2]
   
    
   $canv itemconfigure but($ln,$flo) -fill $col($but) -outline $col($but)
    
}

# stop --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc lstop {nl} {
   variable canv;
   variable nfloors;
   variable col;

   set ln  [lindex $nl 0]
   set but [lindex $nl 1]
  
   $canv itemconfigure buts($ln) -fill $col($but)   
}

# dir --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc dir {nl} {
   variable canv;
   variable col;

   set ln  [lindex $nl 0]
   set dd  [lindex $nl 1]

    if {$dd == 0 } {
     $canv itemconfigure diru($ln) -fill $col(0)
     $canv itemconfigure dird($ln) -fill $col(0)
    } else {
      if {$dd == 1 } { 
       $canv itemconfigure dird($ln) -fill $col(0)
       $canv itemconfigure diru($ln) -fill $col(1)
      } else {
       if {$dd == 2 } { 
        $canv itemconfigure diru($ln) -fill $col(0)
        $canv itemconfigure dird($ln) -fill $col(1)
       }
      }
    }
}


}; # end of namespace lifts5
