/* -*- Mode: C -*-
 * Simple example of two processes communicating via buffers.
 *   Ben Moszkowski.  21 Apr 85
 *
 * Process 1 is passed a number and iteratively multiples it by 3.
 * Process 2 awaits the result and then iteratively multiplies it by 5.
 *
 */

define process1(n,Buf1,Buf2) = process {
    exists I: {
	{
	    I=0 and Buf1=[]
	    and for 3 times do {
		skip and I:=I+n
	    }
	    and stable Buf1
	};
	{
	    skip and Buf1:=[I] and stable I
	}
    };
    {
	halt(|Buf2|=1) and stable Buf1
    }
}.


define process2(Buf1,Buf2) = process {
    {
	halt(|Buf1|=1) and Buf2=[] and stable Buf2
    };
    exists I: {
	{
	    I=0
	    and for 5 times do {
		skip and I:=I+Buf1[0]
	    }
	    and stable Buf2
	};
	{
	    skip and Buf2:=[I] and stable I
	}
    }
}.


/* run */ define buffer_test() = exists Buf1,Buf2: {
    halt(|Buf2|=1)
    and format("The answer should be 4*3*5=60.\n")
    and process1(4,Buf1,Buf2)
    and process2(Buf1,Buf2)
    and always format("Buffer1=%8t Buffer2=%8t\n",Buf1,Buf2)
}.

