/* -*- Mode: C -*-
 * Tree evaluation in first-order logic 
 */

define eval_test(t) = exists v : {
    empty and
    eval_tree(t,v) and
    format("t=%t, value=%t\n",t,v)
}.

define eval_tree(T,V) = {
    if is_integer(T) then V=T
    else exists LV,RV : {
	eval_tree(T[lt],LV) and
	eval_tree(T[rt],RV) and
	apply(T[op],LV,RV,V)
    }
}.

define apply(operator,V1,V2,V) = {
    if operator="+" then V=V1+V2
    else if operator="*" then V=V1*V2
}.

define op=0.
define lt=1.
define rt=2.

define eval_test1 = 1.

define eval_test2 = ["+",1,2].

define eval_test3 = ["*",["+",1,["*",2,3]],["+",4,5]].

define eval_test4 = ["+",
			["*",
			    ["+",1,1],
			    ["+",1,1]],
			["*",
			    ["+",1,1],
			    ["+",1,1]]].

define eval_test5 = ["+",["*",eval_test3,eval_test3],eval_test3].

define eval_test6 = 
  ["+",["*",["+",1,2],3],["+",["*",4,5],["+",6,7]]].

load "misc".

