/* -*- Mode: C -*-
 * Tree evaluation in first-order logic 
 */

define eval_test(t) = {
    empty and
    format("Tree=%t\n", eval_tree([t]))
}.

define eval_tree(TreeHist) = {
    if is_integer(TreeHist[0])
    then TreeHist
    else eval_tree([eval_args(TreeHist[0])] + TreeHist)
}.

define eval_subtree(Tree) = {
    if is_integer(Tree)
    then Tree
    else eval_args(Tree)
}.

define eval_args(Tree) = {
    if is_integer(Tree[lt]) and is_integer(Tree[rt])
    then expr_val(Tree)
    else [Tree[op],eval_subtree(Tree[lt]),eval_subtree(Tree[rt])]
}.

define expr_val(Tree) = {
    if Tree[op]="+" then Tree[lt]+Tree[rt]
    else if Tree[op]="*" then Tree[lt]*Tree[rt]
}.

define op=0.
define lt=1.
define rt=2.

define eval_test1 = 1.

define eval_test2 = ["+",1,2].

define eval_test3 = ["*",["+",1,["*",2,3]],["+",4,5]].

define eval_test4 = ["+",
			["*",
			    ["+",1,1],
			    ["+",1,1]],
			["*",
			    ["+",1,1],
			    ["+",1,1]]].

define eval_test5 = ["+",["*",eval_test3,eval_test3],eval_test3].

define eval_test6 = 
  ["+",["*",["+",1,2],3],["+",["*",4,5],["+",6,7]]].

load "misc".

