/*  -*- Mode: C -*-
 * Tests for the Tempura interpreter.  18 Jan 85
 *  Ben Moszkowski
 * Updated 29 Jan 85.
 */

/*set(garbage_flag,true). 	garbage collect before each run-command */
/*set(echo_flag,true).		echo commands */

load "library".

message("Testing three simple Tempura programs.").
load "simple".

run linear_test(3).
run while_test(4).
run skip_test().


message("Testing tree summation program.").
load "sum-tree".
run(sum_test(sum_test4)).

message("Testing parallel tree summation program.").
load "par-sum-tree".
run(sum_test(sum_test4)).

message("Testing serial quicksort").
load "ser-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3).
set print_states = true.

message("Testing parallel quicksort").
load "par-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3). 
set print_states = true.

message("Testing fast parallel quicksort").
load "fast-par-qsort".
run sort_test(sort_test1).
set print_states = false.
run sort_test(sort_test3).
set print_states = true.

message("Testing pulse program").
load "pulse".
run pulse_test().

message("Testing latch program").
load "latch".
run latch_test().

message("Testing multiplier").
load "mult".
run mult_test(4,9).

message("Testing simple bootstrapped interpreter").
load "boot".
run boot_test(boot_test2).

message("Testing projection").
load "proj".
/*set assign_ahead = false.*/
run simple_proj_test(). 
run var_proj_test(). 
/*set assign_ahead = true.*/
 
message("Simple test of pointers.").
load "pointers".
run pointer_test().

message("Test of a pair of simple processes using shared buffers.").
load "buffer-example".
run buffer_test().

message("Testing process package.").
load "processes".
run process_test(process_test4).

message("Testing stream_test program").
load "streams".
run stream_test([0,10,20,30,40]).

message("Testing stream_status_test program").
run stream_status_test([0,10,20,30,40]).

message("Testing stream lexer").
load "stream-lexer".
run lexer_test(lexer_test2).
/*garbage_collect().*/
run lexer_test(lexer_test4).

message("Testing stream parser").
load "stream-parser".
run parser_test(parser_test1).
run parser_test(parser_test4). 

message("Testing stream lexer-parser-evaluator").
load "stream-eval".
run sys_test(lexer_test4).

message("End of tests").
