/* -*- Mode: C -*-
 * Tempura solution to the "Towers of Hanoi" problem (Roger Hale) 
 *
 */

define hanoi(n) = exists L,C,R : {
    list(L,n) and forall i<n : L[i]=i and
    C=[] and R=[] and
    move(n,L,C,R) and
    always format("L=%10t C=%10t R=%10t\n",L,C,R)
}.

/* Move n discs from peg A to peg B */
define move(n,A,B,C) = {
    if n=0 then empty
    else {
	move(n-1,A,C,B);
	{
	    skip and A:=A[1..|A|] and B:=A[0..1]+B and C:=C
	};
	move(n-1,C,B,A)
    }
}.


