/* -*- Mode: C -*-
 * Program to do parallel quicksort.  Ben Moszkowski
 * Initial version written around 29 Apr 84.
 * Subsequent changes made.
 * Updated 7 Feb 85.
 */

define par_quicksort(L) = {
    if |L| <= 1
    then empty
    else exists pivot : {
	quick_partition(L,pivot);
	sort_parts(L,pivot)
    }
}.

define sort_parts(L,pivot) = {
    exists Done,Ready1,Ready2 : {
	Ready1=false and Ready2=false
	and Done is (Ready1 and Ready2)
	and (halt Done)
	and quicksort_process(Done,Ready1, L[0 to pivot])
	and quicksort_process(Done,Ready2, L[pivot+1 to |L|])
        }
    and stable L[pivot]
}.

define quicksort_process(Done,Ready,L) = process {
    {
	par_quicksort(L) and
	stable Ready
    };
    {
	skip and Ready:=true and stable L
    };
    {
	halt(Done)
	and stable Ready and stable L
    }
}.

define monitor(L) = {
    exists Tag_list : {
	fixed_list(Tag_list,|L|) and
	forall i<|L| : {
	    Tag_list[i] is (if i=L[i] then 1 else 0)
	} and
	box format("List=%t  Tag_list=%t\n",L,Tag_list)
    }
}.

/*  test of quicksort */
/* run */ define sort_test(init_vector) = {
    exists L : {
	fixed_list(L,|init_vector|)
	and L=init_vector
	and par_quicksort(L)
        and monitor(L)
    }
}.

define sort_test1 = [2,0,1].

define sort_test2 = [2,4,9,1,0,10,6,8,7,5,3].

define sort_test3 = [13,7,5,3,1,9,8,6,2,0,12,11,4,10].

