/* -*- Mode: C -*-
 * Parallel summing of the nodes of a binary tree.
 * 17 Apr 85.  
 * Ben Moszkowski 
 *
 */

load "library".

define sum_tree(Tree) = {
    if is_integer(Tree) then empty
    else {
	exists Done:{
	    (Done is (is_integer(Tree[0]) and is_integer(Tree[1])))
	    and halt(Done)
	    and stable(struct(Tree))
	    and sum_tree_process(Done,Tree[0])
	    and sum_tree_process(Done,Tree[1])
	};
	{
	    skip and Tree:=Tree[0]+Tree[1]
	}
    }
}.

/* Simple process to sum a tree */
define sum_tree_process(Done,Tree) = process {
    sum_tree(Tree);
    {
	halt Done
	and stable Tree
    }
}.

define sum_test(t) = {
    exists Tree : {
	Tree=t
	and sum_tree(Tree)
        and always format("Tree=%t\n",Tree)
    }
}.

define sum_test1 = 1.

define sum_test2 = [1,2].

define sum_test3 = [[1,[2,3]],[4,5]].

define sum_test4 = [[[1,1],[1,1]],[[1,1],[1,1]]].

define sum_test5 = [[sum_test3,sum_test3],sum_test3].

/* run */ define run_test() = {
 {format("******* test 1 *******\n") and sum_test(sum_test1)};
 {format("******* test 2 *******\n") and sum_test(sum_test2)};
 {format("******* test 3 *******\n") and sum_test(sum_test3)};
 {format("******* test 4 *******\n") and sum_test(sum_test4)};
 {format("******* test 5 *******\n") and sum_test(sum_test5)}
}.

