/* -*- Mode: C -*-
 * Program to do serial quicksort.  
 */

define serial_quicksort(L) = {
    if |L| <= 1
    then empty
    else exists pivot : {
	quick_partition(L,pivot);
	sort_parts(L,pivot)
    }
}.

define sort_parts(L,k) = {
    {serial_quicksort(L[0 to k]) and stable L[k to |L|]};
    {serial_quicksort(L[(k+1) to |L|]) and stable L[0 to (k+1)]}
}.

define sort_test(init_vector) = {
    exists L : {
	fixed_list(L,|init_vector|)
	and L=init_vector
	and serial_quicksort(L)
        and monitor(L)
    }
}.

define monitor(L) = {
    exists Tag_list : {
	fixed_list(Tag_list,|L|) and
	forall i<|L| : {
	    Tag_list[i] is (if i=L[i] then 1 else 0)
	} and
	box format("List=%t  Tag_list=%t\n",L,Tag_list)
    }
}.

define sort_test1 = [2,0,1].

define sort_test2 = [2,4,9,1,0,10,6,8,7,5,3].

define sort_test3 = [13,7,5,3,1,9,8,6,2,0,12,11,4,10].

