/* -*- Mode: C -*-
 * Sum the nodes of a binary tree.  
 * 15 Apr 85.  
 * Ben Moszkowski 
 */

load "library".

define sum_tree(Tree) = {
    if is_integer(Tree) then empty
    else {
	sum_subtree(Tree,0);
	sum_subtree(Tree,1);
	{
	    skip and Tree:= Tree[0]+Tree[1]
	}
    }
}.

/* Sum the i-th subtree.  Keep the other subtree stable */
define sum_subtree(Tree,i) = {
    sum_tree(Tree[i])
    and stable(struct(Tree))
    and stable(Tree[1-i])
}.

define sum_test(t) = {
    exists Tree : {
	Tree=t
	and sum_tree(Tree)
        and always format("Tree=%t\n",Tree)
    }
}.


define sum_test1 = 1.

define sum_test2 = [1,2].

define sum_test3 = [[1,[2,3]],[4,5]].

define sum_test4 = [[[1,1],[1,1]],[[1,1],[1,1]]].

define sum_test5 = [[sum_test3,sum_test3],sum_test3].


/* run */ define run_test() = {
 {format("******* test 1 *******\n") and sum_test(sum_test1)};
 {format("******* test 2 *******\n") and sum_test(sum_test2)};
 {format("******* test 3 *******\n") and sum_test(sum_test3)};
 {format("******* test 4 *******\n") and sum_test(sum_test4)};
 {format("******* test 5 *******\n") and sum_test(sum_test5)}
}.
