/* -*- Mode: C -*-
 * atm.t automatic teller machine
 *
 */
load "../library/tcl".
set print_states=false.
define nr_of_customers = 20.
define tr_idle = 0.
define max_pin_try = 3.
define max_per_tr = 150.
define max_atm = 600.
define disabled = -1.
define enabled = 1.

define array(L,n) = {
  list(L,n) and stable(struct(L))
}.

/* run */ define atm_test() = 
{
    exists Account, Card, Pin, Atm_money, Customer,
           Tr_account, Tr_pin, Tr_money, Tr_pin_try : {
               
define atm_init() = {
             array(Account, nr_of_customers) and
             array(Card, nr_of_customers) and
             array(Pin, nr_of_customers)  and
             
            Tr_pin=0 and
            Customer=0 and 
            Tr_account=0 and 
            Tr_money=0 and 
            Tr_pin_try=0 and 
            Atm_money=max_atm and 
            forall i<nr_of_customers: 
             {
                 array(Card[i],2) and
                 Card[i][0]=i and /* account nr */
                 Card[i][1]=enabled and /* card status */
                 Account[i]=20*i and 
                 Pin[i]=i 
             }
            
        }
        and

define new_customer() = {
            skip and 
            format("Waiting for new customer\n\n") and
            Customer:=random mod (nr_of_customers+10) and
            stable(Tr_account) and stable(Tr_pin) and
            stable(Tr_money) and stable(Atm_money) and
            stable(Tr_pin_try) and
            forall i<nr_of_customers : {
              stable(Pin[i]) and
              stable(Account[i]) and
              stable(Card[i])
            }
        }
        and           

define customer_ok() ={
            Customer~=0 and Customer<nr_of_customers
        }
        and     

define wait_customer() = {
              format("Please insert card\n") and
              repeat new_customer() until customer_ok()          
        }
        and 

define read_card() = {
            skip and
            format("Reading card\n") and
            Tr_account:=Card[Customer][0] and
            stable(Tr_pin) and stable(Tr_money) and
             stable(Atm_money) and stable(Customer) and
            stable(Tr_pin_try) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            }
            
        }
        and 

define inp_pin() = {
            skip and
            format("Customer %t enter your pin number\n",Tr_account) and
            format("0 is exit\n\n") and
            next( input Tr_pin) and
            Tr_pin_try:=Tr_pin_try+1 and
            stable(Tr_account) and stable(Tr_money) and
            stable(Atm_money) and stable(Customer) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            } 
        }
        and

define pin_ok() = {
            Tr_pin=Pin[Tr_account] or Tr_pin_try=max_pin_try or Tr_pin=0
        }
        and

define get_pin() = {
            repeat inp_pin() until pin_ok()
          }
          and

define pin_exit() = {
            Tr_pin=0
          }
          and          

define max_available() = {
            if max_per_tr <=Atm_money then
               if max_per_tr<=Account[Tr_account] then max_per_tr
               else Account[Tr_account]
            else if Atm_money<=Account[Tr_account] then Atm_money
                 else Account[Tr_account]
        }
        and
        
define inp_money() = {
            skip and
            format("Max. available at this atm %t\n",max_available()) and
            format("0 is exit\n\n") and
            format("Enter amount of money\n") and
            next (input Tr_money) and
            stable(Tr_account) and stable(Tr_pin) and
            stable(Tr_pin_try) and 
            stable(Atm_money) and stable(Customer) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            }
            
        }
        and

define card_disabled() = {
            Card[Tr_account][1]=disabled
        }
        and

define amount_ok() = {
            Tr_money>=0 and
            Account[Tr_account]-Tr_money>=0 and
            Atm_money-Tr_money>=0 and Tr_money<=max_per_tr
        }
        and

define request_money() = {
            repeat inp_money() until amount_ok()
          }
          and

define max_pin() = {
            Tr_pin~=Pin[Tr_account] and Tr_pin_try>=max_pin_try and Tr_pin~=0
          }
          and

define money_exit() = {
            Tr_money=0
          }
          and

define debit_account() = {
             skip and
            stable(Tr_account) and stable(Tr_money) and
            stable(Tr_pin) and Atm_money:=Atm_money-Tr_money and
             stable(Customer) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                if i=Tr_account then
                  Account[Tr_account]:=Account[Tr_account]-Tr_money
                else stable(Account[i]) and
                stable(Card[i])
            }
        }
        and

define reset() = {
            Tr_account:=tr_idle and Tr_money:=0 and Tr_pin:=0 and
            Tr_pin_try:=0 and Customer:=0
          }
          and
          
          
define take_card_money() = {
            skip and
            format("Please take your card\n") and
            format("Please take your money\n\n") and
            reset() and stable(Atm_money) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            } 
        }
        and

define take_card_pin_exit() = {
            skip and
            format("Please take your card\n\n") and
            reset() and stable(Atm_money) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            } 
        }
        and

define take_card_money_exit() = {
            skip and
            format("Please take your card\n\n") and
            reset() and stable(Atm_money) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            } 
        }
        and          

define take_disabled_card() = {
            skip and
            format("Customer %t your card is disabled\n",Tr_account) and
            format("Please take your card\n\n") and
            reset() and stable(Atm_money) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
            } 
        }
        and
          
define disable_card() = {
            skip and
            format("Wrong Pin, your card will be disabled!\n") and
            stable(Tr_account) and stable(Tr_money) and
            stable(Tr_pin) and stable(Tr_pin_try) and
            stable(Customer) and stable(Atm_money) and
            forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                if i~= Tr_account then stable(Card[i])
                else {
                    Card[i][1]:=disabled and
                    Card[i][0]:=Card[i][0]
                }
                
            } 
        }
        and

define customer_processing() = {
            wait_customer();
            read_card();
            if card_disabled() then take_disabled_card()
            else {
                get_pin();
                if max_pin() then {
                    disable_card();
                    take_disabled_card()
                }
                else {
                  if pin_exit() then take_card_pin_exit()
                  else {
                    request_money();
                    if money_exit() then take_card_money_exit()
                    else {
                      debit_account();
                      take_card_money()
                    }
                  }
                }
            }
        }
        and

define empty_atm() = {
              skip and
              format("This atm is empty\n\n") and
              stable(Tr_account) and stable(Tr_money) and
              stable(Tr_pin) and stable(Tr_pin_try) and
              stable(Atm_money) and stable(Customer) and
              forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
              }
          }
          
    
        and

define refill_atm() = {
              skip and
              format("Refilling atm\n\n") and
              Atm_money:=max_atm and
              stable(Tr_account) and stable(Tr_money) and
              stable(Tr_pin) and stable(Tr_pin_try) and
              stable(Customer) and
              forall i<nr_of_customers : {
                stable(Pin[i]) and
                stable(Account[i]) and
                stable(Card[i])
              }
          }
          
    
        and



define main() = {
            atm_init() and
            while true do {
                while Atm_money>0 do {
                    customer_processing()
                };
                empty_atm();
                refill_atm()
            }
            
            
        }
        and   
        main()
    }
    
}.

