/* -*- Mode: C -*-
 * tempura code for robot control system
 * OCS : operator control system
 * ICS : infrared control system
 * MCS : motor control system
 */

define move(X,Y) = {
  format("sending left %t  right %t \n", X, Y)
}.

define s = 0.

define f = 20.

define b = -20.

define olc = [b,b,b,s,f,f,f,s].

define orc = [b,s,f,f,f,s,b,b].


define robot(Itype,Mtype) = {
  exists Direction, Loc, Roc, Lic, Ric, 
    Opactive, Iractive, Ircounts, Sensors, Direction1, Direction2 :
    { list(Ircounts,8) and stable(struct(Ircounts)) and

define OCS() = {
  exists Lloc, Lroc : { Lloc=s and Lroc=s and
   while true do { skip and
     if Itype=0 then {
       input Direction and
       if Direction~="n"  and Direction~="ne" and
          Direction~="e"  and Direction~="se" and
          Direction~="s"  and Direction~="sw" and
          Direction~="w"  and Direction~="nw" then {
         Loc=Lloc and Roc=Lroc } and
       if Direction="n"  then { Loc=f and Roc=f } and
       if Direction="ne" then { Loc=f and Roc=s } and
       if Direction="e"  then { Loc=f and Roc=b } and
       if Direction="se" then { Loc=s and Roc=b } and
       if Direction="s"  then { Loc=b and Roc=b } and
       if Direction="sw" then { Loc=b and Roc=s } and
       if Direction="w"  then { Loc=b and Roc=f } and
       if Direction="nw" then { Loc=s and Roc=f } 
      } and
     if Itype=1 then {
      input Direction1 and input Direction2 and
      if Direction1~="u" and Direction2~="u" and
         Direction1~="s" and Direction2~="s" and
         Direction1~="d" and Direction2~="d" then {
        Loc=Lloc and Roc=Lroc } and
      if Direction1="u" then { Loc=f } and
      if Direction2="u" then { Roc=f } and
      if Direction1="s" then { Loc=s } and
      if Direction2="s" then { Roc=s } and
      if Direction1="d" then { Loc=b } and
      if Direction2="d" then { Roc=b } 
     } and 
     if Itype=2 then {
      input Loc and input Roc 
     } and 
     Lloc:=Loc and Lroc:=Roc and
     Opactive = {if (Lloc ~= Loc) and (Lloc ~= Loc) then 1 else 0}
   }
  }
 } and

define sum(X) = {
  {if Ircounts[0]>100 then X[0] else 0} +
  {if Ircounts[1]>100 then X[1] else 0} +
  {if Ircounts[2]>100 then X[2] else 0} +
  {if Ircounts[3]>100 then X[3] else 0} +
  {if Ircounts[4]>100 then X[4] else 0} +
  {if Ircounts[5]>100 then X[5] else 0} +
  {if Ircounts[6]>100 then X[6] else 0} +
  {if Ircounts[7]>100 then X[7] else 0}
 } and

define ICS() = {
  while true do {
    skip and
    input Sensors and
    (forall i<8 : Ircounts[i] = if Sensors[i]="1" then 101 else 0 ) and
    Iractive = {if (exists i < 8 : Ircounts[i]>100) then 1 else 0} and
    Lic = sum(olc) and
    Ric = sum(orc)
  }
 } and

define MCS() = { 
  while true do { 
    skip and
    if Opactive=1 then {
      format("operator move \n") and
      move(Loc,Roc) }
    else {
      if Iractive=1 then {
        format("infrared move \n") and
        move(Lic,Ric) }
      else {
        if Mtype=0 then {  
         format("using previous values \n") and
         move(Loc,Roc)
        }
         else {
          format("stop \n") and
          move(s,s)
         } 
      }
    }
  }
 } and
 
 MCS() and ICS() and OCS()
 }    
}.

/* run */ define robot_1_p_nesw() = robot(0,0).
/* run */ define robot_1_p_usd() = robot(1,0).
/* run */ define robot_2_p() = robot(2,0). 
/* run */ define robot_1_s_nesw() = robot(0,1).
/* run */ define robot_1_s_usd() = robot(1,1).
/* run */ define robot_2_s() = robot(2,1).
