/* -*- Mode: C -*-
 * watchdog timer
 */

load "../library/tam".

/* we have at least 2 dog processes */
define no = 4.

/* the check interval length for each dog proces */
define pl = [1,2,4,6].

/* the number of checks for each dog proces */
define nl = [4,4,4,4].

/* the list of length of the interval between two  input changes 
   for each dog proces */
define di = [ [0,0,0,0,0,0], [1,1,1,1,1,2], [2,1,1,3], [2,2,2,4] ].

/* run */ define watchdog() = {
 exists Dl,Alml,Alm : {
  
  list(Dl, no) and stable(struct(Dl)) and
  list(Alml, no) and stable(struct(Alml)) and
  forall i<no : { 
    shunt(Dl[i]) and rds(Dl[i])=0 and stmp(Dl[i])=0 and
    shunt(Alml[i]) and rds(Alml[i])=0 and stmp(Alml[i])=0
  } and

define check(k) = {
    skip;format("                             checkpoint dog %t \n",k)} and
define print(k) = {
   format("dog %t   D=%t   Alm=%t \n",k,Dl[k],Alml[k])
  } and
define printe(k) = {
   format("dog %t   D=%t   Alm=%t  end\n",k,Dl[k],Alml[k])
  } and

define dogi(k) = {
   exists I : { I=0 and
    {repeat {
     {len(di[k][I]) and stable(Dl[k]) and stable(I)};
     { skip and I:=I+1 and swrs(Dl[k],rds(Dl[k])) }
    } until I=|di[k]| }
    ; always { stable(Dl[k]) }
   }
  }
  and

define dog(k) = {
   {for nl[k] times do  {
     len(pl[k])  and
     if pl[k]>1 then {
      exists W : { W=0 and 
       {len(pl[k]-1) and 
        keep { 
         print(k) and
         if stmp(Dl[k])= stmp(next Dl[k]) 
         then { Alml[k]:=Alml[k]  and W:=W}
         else { Alml[k]:=Alml[k]  and W:=1}
        }  
       };{check(k) and print(k) and 
          if W=0 and stmp(Dl[k])=stmp(next Dl[k])
          then {swrs(Alml[k],1) }
          else {Alml[k]:=Alml[k] }
         }
       }
      }
     else { skip and check(k) and print(k) and 
      if stmp(Dl[k]) = stmp(next Dl[k]) 
      then { swrs(Alml[k],1)  }
      else { Alml[k]:=Alml[k] }
     }
   }};
     {repeat {skip  and printe(k) and Alml[k]:=Alml[k] } until false}
  } and
  
define funnel() = {
 keep { 
  
  if forall i<|Alml| : { stmp(next Alml[i]) = stmp(Alml[i])
                         and rds(next Alml[i]) = rds(Alml[i])  } 
   then { Alm:=Alm }
   else {
     if forall i<|Alml| : {
          forall j<|Alml| : {
            if stmp(next Alml[i]) ~= stmp(Alml[i]) and
               stmp(next Alml[j]) ~= stmp(Alml[j])
            then  rds(next Alml[i]) = rds(next Alml[j])
           }
        }
      then { 
        forall i<|Alml| : {
           if  stmp(next Alml[i]) ~= stmp(Alml[i]) or 
                rds(next Alml[i]) ~= rds(Alml[i])
           then {  swrs(Alm,rds(next Alml[i])) }
        }
      }
      else {skip;format("error\n")}
    } and
 {format("                             general alarm  %t\n
          ----------------------------------------------------\n",Alm)}
 }
} and 

  shunt(Alm) and rds(Alm)=0 and stmp(Alm)=0 and
  prefix{len(25)} and
  forall i< no : {
   dog(i) and dogi(i)
  }  and
  funnel() 
 }
}.

