# lifts5.tcl --
#
# Copyright (c) 1998-1999 Antonio Cau
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#package require NAME VERSION
package provide supermarket1 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
#namespace export -clear *
variable nclients;
variable ncashpoints;
variable canv;
variable col;

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
  variable canv;
  variable nclients;
  variable ncashpoints;
  variable col; 

    
    set nclients    [lindex $nl 0];
    set ncashpoints [lindex $nl 1];
    set col(0) black;
    set col(1) bisque;
    set col(2) SkyBlue;
    set col(3) red;
    set col(4) green;
    set col(5) white;
    set col(6) yellow;
    set stepper 0;
    set run     0;

    $canv delete all

    for {set i 0} {$i<$nclients} {incr i} {
     $canv create oval \
       10  [expr 60+30*$i]\
       30  [expr 80+30*$i]\
       -width 0 -fill $col(1) -tags client($i)  
     $canv create text 20 [expr 70+30*$i]\
             -text $i -tags clienttxt($i)
    }

    for {set i 0} {$i<$ncashpoints} {incr i} {
      $canv create rect \
         280 [expr 50+50*$i]\
         360  [expr 70+50*$i]\
         -fill $col(3) -tags cashpoint($i)
      $canv create text 320 [expr 60+50*$i]\
       -anchor c -text $i:closed -tags cptext($i)
    }
    
    $canv create rect \
       90 30 \
       400 250 \
       -outline $col(0) -width 3
    
    $canv create line \
       90 40 \
       90 180 \
       -fill $col(0) -width 3 -tags smdoor

#    $canv create line \
#       400 160 \
#       400 210 \
#       -fill $col(0) -width 3 -tags smdoor

    $canv create text 450 40\
       -anchor c -text Time -tags tmr

}

# timer --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc tmr {nl} {
  variable canv;
  variable nclients;
  variable ncashpoints;
  variable col;

  set ti [lindex $nl 0]

  $canv itemconfigure tmr -text Time:$ti 

}


# client --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc client {nl} {
  variable canv;
  variable nclients;
  variable ncashpoints;
  variable col;

  set cl  [lindex $nl 0]
  set cls [lindex $nl 1]
  set cp  [lindex $nl 2]
  set qps [lindex $nl 3]


  switch -exact -- $cls {
   0 { $canv coords client($cl)\
         10  [expr 60+30*$cl]\
         30  [expr 80+30*$cl]
       $canv coords clienttxt($cl)\
         20 [expr 70+30*$cl]
       $canv itemconfigure client($cl) -fill $col(1)
     }
   1 { $canv coords client($cl)\
         110  [expr 60+30*$cl]\
         130  [expr 80+30*$cl]
       $canv coords clienttxt($cl)\
         120 [expr 70+30*$cl]
       $canv itemconfigure client($cl) -fill $col(2)
     }
   3 { $canv coords client($cl)\
         300  [expr 75+50*$cp]\
         320  [expr 95+50*$cp]
       $canv coords clienttxt($cl)\
         310  [expr 85+50*$cp]
       $canv itemconfigure client($cl) -fill $col(4)
     }
   2 { $canv coords client($cl)\
         [expr 250-30*$qps]  [expr 75+50*$cp]\
         [expr 270-30*$qps]  [expr 95+50*$cp]
       $canv coords clienttxt($cl)\
         [expr 260-30*$qps]  [expr 85+50*$cp]
       $canv itemconfigure client($cl) -fill $col(3)
     }
  }
}


# supermarket --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc supermarket {nl} {
  variable canv;
  variable nclients;
  variable ncashpoints;
  variable col;

  set sm [lindex $nl 0]

  $canv itemconfigure smdoor -fill $col($sm) 
}



# cashpoint --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc cashpoint {nl} {
  variable canv;
  variable nclients;
  variable ncashpoints;
  variable col;

  set cp  [lindex $nl 0]
  set cps [lindex $nl 1]

  switch -exact -- $cps {
   0 { $canv itemconfigure cptext($cp) -text $cp:closed 
       $canv itemconfigure cashpoint($cp) -fill $col(3)
     }
   1 { $canv itemconfigure cptext($cp) -text $cp:open,busy
       $canv itemconfigure cashpoint($cp) -fill $col(2)
     }
   2 { $canv itemconfigure cptext($cp) -text $cp:open,free
       $canv itemconfigure cashpoint($cp) -fill $col(4)
     }
   3 { $canv itemconfigure cptext($cp) -text $cp:closing,busy
       $canv itemconfigure cashpoint($cp) -fill $col(1)
     } 
   4 { $canv itemconfigure cptext($cp) -text $cp:closing,free
       $canv itemconfigure cashpoint($cp) -fill $col(6)
     } 
  }
} 


}; # end of namespace out
