/* -*- Mode: C -*-
 * check ex5.v verilog prog, i.e., the four bit adder program
 *
 */

load "../library/conversion".
load "../library/exveri".

/* vdmp ex5.dmp */

/* veri ex5.v 0 */


set print_states = false.


define bits=[1,2,4,8,16,32,64,128].
define  bit (Bitno, Number)= {
    if ( (Number div (2**Bitno)) mod 2 = 1) then 1 else 0}.

define inttobits(L,X) = {
    if L=1 then [bit(0,X)]
    else [bit(L-1,X)]+inttobits(L-1,X)
}.

define bitstoint(X) = {
    if |X| = 1 then X[0]
    else 
    {
        2**(|X|-1)*X[0] + bitstoint(suf(X,1))
    }
}.

define check_sum(X) = {
   get2(X) and 
   if avar(X)~="sum" then 
   {
       format("!%d:: sum wrong input received %s\n",atime(X), aval(X))
    }
}.

define nor2(N1,N2) = 
{
    if N1=0 and N2=0 then 0
    else if N1=1 and N2=0 then 1
    else if N1=1 and N2=1 then 0
    else if N1=0 and N2=1 then 1
    else format("error")
}.

define nor (N1, N2, N3, N4, N5, N6) = 
{
    N1 = nor2(nor2(nor2(N2,N3),nor2(N4,N5)),N6)
}.


define four_bit_adder(A4, B4, SUM5, NULLFLAG) = 
{
    exists CARRY0,CARRY1,CARRY2 : 
    {
        CARRY0 = ((A4[3] + B4[3] + 0) div 2) and
        CARRY1 = ((A4[2] + B4[2] + CARRY0) div 2) and
        CARRY2 = ((A4[1] + B4[1] + CARRY1) div 2) and       
        SUM5   =  [ (A4[0]+B4[0]+CARRY2) div 2,
                    (A4[0]+B4[0]+CARRY2) mod 2,
                    (A4[1]+B4[1]+CARRY1) mod 2,
                    (A4[2]+B4[2]+CARRY0) mod 2,
                    (A4[3]+B4[3]+     0) mod 2  ] and
        nor (NULLFLAG, SUM5[0], SUM5[1], SUM5[2], SUM5[3], SUM5[4])
    }
}.


/* run */ define test() = {
    exists X,T,S,A,B,SUM5,NF :{
        list(SUM5,5) and stable(struct(SUM5)) and
        {T=0 and S=0 and A=0 and B=0 and  veri_dot()};no_ch_4(A,B,T,S);
             {check_sum(X) and T:= atime(X) and S:=aval(X) and no_ch_2(A,B)};
        {check_sum(X) and T:= atime(X) and S:=aval(X) and no_ch_2(A,B)};
        {check_sum(X) and T:= atime(X) and S:=aval(X) and no_ch_2(A,B)};
        {check_sum(X) and T:= atime(X) and S:=aval(X) and no_ch_2(A,B)};
        {halt(T>5120) and            
             always ( check_sum(X) and
                       
                      four_bit_adder(inttobits(4,A),inttobits(4,B),SUM5,NF) and
                      if T<=5120 then {T:= atime(X) and S:=aval(X)} and
                      if (atime(X)-T>1) then
                       {if strint(S)~=bitstoint(SUM5) then empty
                                     else format("!%d:: ok \n",T) and
                                     
                         if T<=5120 then { A:=(A+1) mod 16 and
                                           B:=if A mod 16 <= 14 then B else B+1
                   }
                  }
                  else { if T<=5120 then {A:=A and B:=B}
                  }
                 
                 )
             }
    }
}.
    
    
