`timescale 1us / 1us
module four_bit_adder (A4, B4, SUM5, NULL_FLAG);
input         A4,
              B4;
   output     SUM5,
              NULL_FLAG;

wire    [3:0] A4,
              B4;
wire    [4:0] SUM5;
wire    [2:0] CARRY;

one_bit_adder  Bit0 (A4[0], B4[0],     1'b0, SUM5[0], CARRY[0]);
one_bit_adder  Bit1 (A4[1], B4[1], CARRY[0], SUM5[1], CARRY[1]);
one_bit_adder  Bit2 (A4[2], B4[2], CARRY[1], SUM5[2], CARRY[2]);
one_bit_adder  Bit3 (A4[3], B4[3], CARRY[2], SUM5[3], SUM5 [4]);

nor   #1 Nor_for_zeroflag
  (NULL_FLAG, SUM5[0], SUM5[1], SUM5[2], SUM5[3], SUM5[4]);
endmodule

module one_bit_adder (A, B, CARRY_IN, SUM, CARRY_OUT);
input         A,
              B,
              CARRY_IN;
output        SUM,
              CARRY_OUT;
   
assign #1  {CARRY_OUT, SUM} = A + B + CARRY_IN;
endmodule

module test;
   reg  [3:0] A4,
              B4,
              CARRY_IN;
   wire [4:0]  SUM5;
  wire  FLAG;


   initial begin
       $dumpfile("ex5.dmp");
       $dumpvars;
       $monitor("!PROG: assert sum:%d:%d:!", SUM5, $time);
       #20 A4 = 0;
         B4 = 0;
       while ( (A4<=14) || (B4 <=14) )
        begin
        if (A4>14)
           begin
              #20 A4=0;
              if (B4<=14) B4=B4+1;
               else B4=15 ;
           end
        else #20 A4=A4+1;
           
                end
      #20 A4=0;
          B4=0;
      #1 $finish;
   end

   four_bit_adder adder(A4, B4, SUM5, FLAG);
endmodule // test