#!/bin/sh
# anatempura.tcl.  Generated from anatempura.tcl.in by configure. \
exec tclsh "$0" ${1+"$@"}

package require Tk
package require Expect
# anatempura --
#
#	This file implements package anatempura, which  
#       implements a graphical front end and monitor to Tempura
#
# Copyright (c) 1998-2007 Antonio Cau
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#  -*- Mode: Tcl -*-

#package require NAME VERSION
package provide anatempura 0.80 
namespace eval anatempura {;
#namespace export -clear *

# variable TEMPURA
 global veri proggy_id spawn_id term_spawn_id nop_id ext_id

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {} {
 variable TEMPURA
 global term_spawn_id
if {[file exists $TEMPURA(rc_file)]} {
  set tmp $TEMPURA(tempura_dir)
  set TEMPURA(tempura_dir) ""
  source $TEMPURA(rc_file)
  if {$TEMPURA(tempura_dir) != "" && [file isdirectory $TEMPURA(tempura_dir)]} {
       newdir $TEMPURA(tempura_dir) 
       setpath 
    } else {
      set TEMPURA(tempura_dir) $tmp
      setpath
    }
  
}

}






# openfile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc openfile {} {

    variable TEMPURA
    set types {
    { {Tempura File}       {.t}  }
    { {TCL File}           {.tcl}}
    { {C File}             {.c}  }
    { {Verilog File}       {.v}  }
    }
    set tmp $TEMPURA(base_file)
    set TEMPURA(base_file) \
        [tk_getOpenFile -defaultextension ".t" -filetypes $types -initialdir $TEMPURA(tempura_dir) ]
    if {$TEMPURA(base_file) != ""} {
      newdir [file dir $TEMPURA(base_file)]
      setpath
      set TEMPURA(tempura_file) [file tail $TEMPURA(base_file)]
      buildeditmenu [file join $TEMPURA(tempura_dir) $TEMPURA(tempura_file)]
      set ttt [file rootname $TEMPURA(tempura_file)]
      set TEMPURA(file_lbl) "  $ttt"
      #set TEMPURA(file_tcl) "$TEMPURA(tempura_file)cl"
      #set TEMPURA(file_package) [string trimright $TEMPURA(file_tcl) ".tcl"]
    } else {
      set TEMPURA(base_file) $tmp
    }

}

proc setpath {} {
     variable TEMPURA
     global term_spawn_id 

      cd $TEMPURA(tempura_dir)
      $tkterm::term insert end "set path =\"$TEMPURA(tempura_dir)\".\n"
      $tkterm::term see end
      tkterm::insert "set path =\"$TEMPURA(tempura_dir)\"."
      set tkterm::cmd [join $tkterm::cmd ""]
      exp_send -i $term_spawn_id -- "set path =\"$TEMPURA(tempura_dir)\".\r"  
      history add $tkterm::cmd
      set tkterm::cmd {}
      set tkterm::point 0 
}


# reload --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc reload {} {
    variable TEMPURA
 
 if { $TEMPURA(tempura_file) != "" && $TEMPURA(tempura_dir)!=""} {
 buildeditmenu [file join $TEMPURA(tempura_dir) $TEMPURA(tempura_file)]
 }
}

# savefile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc savefile {} {

    variable TEMPURA
    set types {
    {{Output  Files}      {.out} }
    }  
    set TEMPURA(save_file) \
        [tk_getSaveFile -defaultextension ".out" -filetypes $types -initialdir $TEMPURA(tempura_dir)    ]
    if {$TEMPURA(save_file) != ""} {
      newdir [file dir $TEMPURA(save_file)]
      set TEMPURA(out_file) [file tail $TEMPURA(save_file)]
      cd $TEMPURA(tempura_dir)
      set output [open $TEMPURA(out_file) w]
       puts $output [$TEMPURA(output) get 0.0 end]
       close $output
    } 

}

# newfile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc newfile {} {

    variable TEMPURA 
    set types {
    { {Tempura File}       {.t}  }
    { {TCL File}           {.tcl}}
    { {C File}             {.c}  }
    { {Verilog File}       {.v}  }
    }
    set tmp $TEMPURA(base_file)
    set TEMPURA(base_file) \
     [tk_getSaveFile -defaultextension ".t" -filetypes $types -initialdir $TEMPURA(tempura_dir) ]
    
    if {$TEMPURA(base_file) != "" && ![file exists $TEMPURA(base_file)]} {
      set fId [open $TEMPURA(base_file) w]
      close $fId
      newdir [file dir $TEMPURA(base_file)]
      setpath
      set TEMPURA(tempura_file) [file tail $TEMPURA(base_file)]
      buildeditmenu [file join $TEMPURA(tempura_dir) $TEMPURA(tempura_file)]
      set ttt [file rootname $TEMPURA(tempura_file)]
      set TEMPURA(file_lbl) "  $ttt"
      editfile $TEMPURA(tempura_file)
    } else {
      set TEMPURA(base_file) $tmp
    }
}

# setdir --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc setdir {} {

    variable TEMPURA 
    global term_spawn_id
    set tmp $TEMPURA(tempura_dir)
    #set TEMPURA(tempura_dir) ""
    #visual::Window show .top22
    #$TEMPURA(dir) icursor 0
    #focus $TEMPURA(dir)
    #tkwait window $TEMPURA(dir)
    set TEMPURA(tempura_dir) \
     [tk_chooseDirectory -initialdir $TEMPURA(tempura_dir) -mustexist true]
    if {$TEMPURA(tempura_dir) != "" && [file isdirectory $TEMPURA(tempura_dir)]} {
      newdir $TEMPURA(tempura_dir) 
      setpath 
    } else {
      set TEMPURA(tempura_dir) $tmp
    }
}

# newdir --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
#    d          directory
# Results:
#   Returns ...
#
proc newdir {d} {
  variable TEMPURA
  if {![file isdirectory $d]} {return}
  set TEMPURA(tempura_dir) "[convertfilename $d]"
  
}

# convertfilename --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
#    f          filename
# Results:
#   Returns ...
#
proc convertfilename {f} {
  #set f [glob $f]
  #if {[string first "./" $f] == 0} {set f "[pwd]/[string range $f 2 end]"}
  #if {[string first "/" $f] != 0} {set f "[pwd]/$f"}
  return $f
}

# buildeditmenu --
#
#   ADD COMMENTS HERE
#
# buildeditmenu:  Given a base file, find all the files loaded by
# it, and put them in the edit menu.
#
# Arguments:
#   args	comments
#    f           filename
# Results:
#   Returns ...
#
proc buildeditmenu {f} {
  
  variable TEMPURA
  global veri 

  .top18.cpd20.03.04 delete 0 last
  .top18.cpd20.05.06 delete 0 last
  .top18.cpd20.07.08 delete 0 last

  set dir [file dir $f]
  set main [file tail $f]
  cd $dir 
  .top18.cpd20.03.04 add command -label "$main" \
   -command "anatempura::editfile $f"   
  .top18.cpd20.05.06 add command -label "$main" \
   -command "anatempura::loadfile [file rootname $main]"
  
  set fId [open $f r]
  set proggy "0"
  set wave ""
  set flist {}
  set dlist {}
  set plist {}
  set vlist {}
  set jlist {}
  lappend plist "0"
  lappend vlist "1"
  lappend jlist "1"
  while {[gets $fId line] >= 0} {
    if {[string first "load" $line] != -1 } {
	lappend flist "[lindex [split $line "\"\""] 1]"
    } elseif {[string first "/* run */ define" $line] != -1 } {
	lappend dlist "[lindex [split [string trimleft $line " "] " "] 4]"
    } elseif {[string first "/* prog " $line] != -1 } {
        set proggy "[lindex [split [string trimleft $line " "] " "] 2]"
        set pnum   "[lindex [split [string trimleft $line " "] " "] 3]"
        lappend plist "$pnum$proggy"
        .top18.cpd20.05.06 add command -label $proggy.c \
      -command "anatempura::checkprog $proggy"
        .top18.cpd20.03.04 add command -label $proggy.c \
      -command "anatempura::editfile $proggy.c"       
    } elseif {[string first "/* veri " $line] != -1 } {
        set proggy "[lindex [split [string trimleft $line " "] " "] 2]"
        set pnum   "[lindex [split [string trimleft $line " "] " "] 3]"
        lappend vlist "$pnum$proggy"
        .top18.cpd20.05.06 add command -label $proggy \
      -command "anatempura::checkveri $proggy"
        .top18.cpd20.03.04 add command -label $proggy \
      -command "anatempura::editfile $proggy"
    } elseif {[string first "/* java " $line] != -1 } {
        set proggy "[lindex [split [string trimleft $line " "] " "] 2]"
        set pnum   "[lindex [split [string trimleft $line " "] " "] 3]"
        lappend jlist "$pnum$proggy"
        .top18.cpd20.05.06 add command -label $proggy.java \
      -command "anatempura::checkjava $proggy.java"
        .top18.cpd20.03.04 add command -label $proggy.java \
      -command "anatempura::editfile $proggy.java"
    } elseif {[string first "/* vdmp " $line] != -1 } {
        set wave "[lindex [split [string trimleft $line " "] " "] 2]"
    } elseif {[string first "/* tcl " $line] != -1 } {
        visual::Window show .top23
        set TEMPURA(file_tcl) "[lindex [split [string trimleft $line " "] " "] 2].tcl"
        .top18.cpd20.03.04 add command -label $TEMPURA(file_tcl) \
      -command "anatempura::editfile $TEMPURA(file_tcl)"
    }
   }
  close $fId
  
  foreach f $flist {
    if {[file extension $f] == ""} {set f "$f.t"}
    if {![file exists [file join $dir $f]]} continue
      set fId [open $f r]
      while {[gets $fId line] >= 0} {
      if {[string first "/* run */ define" $line] != -1 } {
	    lappend dlist "[lindex [split [string trimleft $line " "] " "] 4]"
       } 
  }
  close $fId
    .top18.cpd20.03.04 add command -label $f \
      -command "anatempura::editfile $f"
    .top18.cpd20.05.06 add command -label $f \
      -command "anatempura::loadfile [file rootname $f]"

  }
  set num 0
  if {$wave != ""} {
    .top18.cpd20.07.08 add command -label "wave $wave" \
          -command "anatempura::wavefile $wave "
    incr num   
   }
  
  foreach f $dlist {
    if {$num < 24} {     
       .top18.cpd20.07.08 add command -label "run $f" \
          -command "anatempura::runfile $f $plist $vlist $jlist"
      } else { 
        set num 0
        .top18.cpd20.07.08 add command -label "run $f" \
          -columnbreak 1\
          -command "anatempura::runfile $f $plist $vlist $jlist"
     }
     incr num
  }
  
}


proc wavefile {f} {
    variable TEMPURA
    if {[file exists [file join $TEMPURA(tempura_dir) $f]]} {
     if {[file exists anatempura::TEMPURA(wave)]} {
           exec  [file nativename $TEMPURA(wave)] [file nativename [file join $TEMPURA(tempura_dir) $f]] &
     }   
    }
}

# editfile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
#     f           filename
# Results:
#   Returns ...
#
proc editfile {f} {
    variable TEMPURA
    if {[file exists [file join $TEMPURA(tempura_dir) $f]] } {
      if {$TEMPURA(tempura_editor)=="vi"} {
        exec xterm -e vi [file nativename [file join $TEMPURA(tempura_dir) $f]] &
      } else {
         exec $TEMPURA(tempura_editor) [file nativename [file join $TEMPURA(tempura_dir) $f]] &
      }
    }
}

# loadfile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
#     f           filename
# Results:
#   Returns ...
#
proc loadfile {f} {
  variable TEMPURA
  global term_spawn_id
   $tkterm::term insert end "load \"$f\".\n"
   $tkterm::term see end
   tkterm::insert "load \"$f\"."
   set tkterm::cmd [join $tkterm::cmd ""]
   exp_send -i $term_spawn_id -- "load \"$f\".\r"
   history add $tkterm::cmd
   set tkterm::cmd {}
   set tkterm::point 0
   update idletasks
}


# runfile --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
#     f            filename
# Results:
#   Returns ...
#
proc runfile {f args} {
   variable TEMPURA 
   global proggy_id spawn_id nop_id term_spawn_id veri ext_id
   set lfile [file rootname $TEMPURA(tempura_file)]
   $tkterm::term insert end "load \"$lfile\".\n"
   $tkterm::term see end
   tkterm::insert "load \"$lfile\"."
   set tkterm::cmd [join $tkterm::cmd ""]
   exp_send -i $term_spawn_id -- "load \"$lfile\".\r"
   history add $tkterm::cmd
   set tkterm::cmd {}
   set tkterm::point 0
   set ind [lsearch $args "1"]
   set plist [lrange $args 0 [expr {$ind - 1}]]
   set vlist [lrange $args $ind end]
   set jlist [lrange $args $ind end]
   
   foreach pr $plist {
     if {$pr!="0"} { 
      set id [string range $pr 0 0]
      set ext [string range $pr 1 end]
      if {[file exists [file join $TEMPURA(tempura_dir) $ext]$TEMPURA(prog_exe)]} { 
        tkterm::e_insert "External C program $ext starts.\n"       
        eval exp_spawn {[file nativename [file join $TEMPURA(tempura_dir) $ext]$TEMPURA(prog_exe)]} 
        lappend proggy_id $spawn_id
        set ext_id($id) $spawn_id
      }
     }
    }
    
    foreach vr $vlist {
      if {$vr!="1"} {
       set id [string range $vr 0 0]
       set ext [string range $vr 1 end]
       if {[file exists [file join $TEMPURA(tempura_dir) $ext]]} {
         if {[file exists $anatempura::TEMPURA(veriwell)]} {
         tkterm::e_insert "External verilog program $ext starts.\n"
         eval exp_spawn {[file nativename $anatempura::TEMPURA(veriwell)] -s [file nativename [file join $TEMPURA(tempura_dir) $ext]]}
         lappend proggy_id $spawn_id
         set ext_id($id) $spawn_id
         }
        }
     }
    }

    foreach vr $jlist {
      if {$vr!="1"} {
       set id [string range $vr 0 0]
       set ext [string range $vr 1 end]
       set cext $ext.class
       if {[file exists [file join $TEMPURA(tempura_dir) $cext]]} {
         if {[file exists $anatempura::TEMPURA(java)]} {
         tkterm::e_insert "External java program $ext starts.\n"
         eval exp_spawn {[file nativename $anatempura::TEMPURA(java)] -classpath [file nativename $TEMPURA(tempura_dir)] $ext}
         lappend proggy_id $spawn_id
         set ext_id($id) $spawn_id
         }
        }
     }
    }
   $tkterm::term insert end "run $f.\n"
   $tkterm::term see end
   tkterm::insert "run $f."
   set tkterm::cmd [join $tkterm::cmd ""]
   exp_send -i $term_spawn_id -- "run $f.\r"
   history add $tkterm::cmd
   set tkterm::cmd {}
   set tkterm::point 0
   update idletasks
}


proc checkprog {f} {
   variable TEMPURA 
   global proggy_id spawn_id nop_id term_spawn_id veri
     if {[file exists [file join $TEMPURA(tempura_dir) $f.c]]} { 
           if {[file exists $anatempura::TEMPURA(gcc)]} {
           tkterm::e_insert "Compiling external C program.\n"
           $tkterm::term see end         
           eval exp_spawn {[file nativename $anatempura::TEMPURA(gcc)] -o [file nativename [file join $TEMPURA(tempura_dir) $f]] \
             [file nativename [file join $TEMPURA(tempura_dir) $f.c]]}
           #sleep 1
           set nop_id $spawn_id
           lappend proggy_id $nop_id
           }
      }
}

proc checkveri {f} {
   variable TEMPURA 
   global proggy_id spawn_id nop_id term_spawn_id veri
     if {[file exists [file join $TEMPURA(tempura_dir) $f]]} { 
           if {[file exists $anatempura::TEMPURA(veriwell)]} {
           tkterm::e_insert "Compiling external verilog program.\n"
           $tkterm::term see end         
           eval exp_spawn {[file nativename $anatempura::TEMPURA(veriwell)] -c [file nativename [file join $TEMPURA(tempura_dir) $f]]}
           #sleep 1
           set nop_id $spawn_id
           lappend proggy_id $nop_id
           }
      }
}

proc checkjava {f} {
   variable TEMPURA 
   global proggy_id spawn_id nop_id term_spawn_id veri
     if {[file exists [file join $TEMPURA(tempura_dir) $f]]} { 
           if {[file exists $anatempura::TEMPURA(javac)]} {
           tkterm::e_insert "Compiling external java program.\n"
           $tkterm::term see end         
           eval exp_spawn {[file nativename $anatempura::TEMPURA(javac)] [file nativename [file join $TEMPURA(tempura_dir) $f]]}
           #sleep 1
           set nop_id $spawn_id
           lappend proggy_id $nop_id
           }
      }
}

# helptempura --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#

proc helptempura {} {
    variable TEMPURA
visual::Window show .top20
$TEMPURA(help) configure -state disabled

# invoke --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc invoke {index} {
    variable TEMPURA 
    set tags [$TEMPURA(help) tag names $index]
    set i [lsearch -glob $tags demo-*]
    if {$i < 0} {
	return
    }
    set cursor [$TEMPURA(help) cget -cursor]
    $TEMPURA(help) configure -cursor watch
    update
    set demo [string range [lindex $tags $i] 5 end]
    $TEMPURA(help) configure -state normal
    $demo
    update
    $TEMPURA(help) configure -cursor $cursor
    $TEMPURA(help) configure -state disabled
}

# wnextcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc wnextcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "WNEXT\n" title
$TEMPURA(help) insert end \
"The operator `wnext' is the Tempura form of the operator \"weak O\" in temporal
logic. The term \"wnext ...\" causes \"...\" to be executed on the next state, if
there is one. Thus, the term

                           wnext \{ I=1 \}

means that the variable I has the value 1 on the next state if the interval
has a length of at least 1. If the interval is empty, this term is true.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# wherecomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc wherecomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "WHERE\n" title
$TEMPURA(help) insert end \
"The operator `where' is equivalent to `and'. It is provided for compatibility
with other systems.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# variablescomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc variablescomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "VARIABLES\n" title
$TEMPURA(help) insert end \
"Tempura variables are of two basic kinds:
   -State variables change in value from state to state. Conventionally,
    they are assigned names starting with a capital letter: I, Foo_23, etc.
    The value of a state variable on an INTERVAL is defined to be its value
    on the FIRST STATE. Thus, \"I=0\" means I has initial value zero.
   -Static variables are constant on any given interval. Conventionally,
    they are assigned names starting with a lower-case letter: i, x25, etc.
(Variable names may be of unlimited length.) Variables and expressions may be
of any of the following types:
   -integer: 0, 42, -97, etc.
   -lambda:  This is the type of predicates and functions.
   -list:    Lists may be of fixed or variable length. See `help list'.
   -string:  String constants are of the form \"abc\".
The function type(X) returns a string representing the type of expression X.
For example, type(9)=\"integer\".

See help `<type>' for more about a particular type.
See help `system' for information on system variables.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}


# systemcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc systemcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "SYSTEM VARIABLES\n" title
$TEMPURA(help) insert end \
"The following system variables are defined (default values in parentheses):
verbosity    (1)     0 - no display.
                     1 - display statistics at the end of a program only.
                     2 - display memory usage in addition to 1.
                     3 - display statistics after every state.
                     4 - display statistics after every pass.
print_states (true)  If true, all outputs are prefixed with state number.
print_level  (2)     A higher value gives more detail in error messages etc.
random_seed  (1)     The seed (integer) used by the random number generator.
Random_seed  (1)     The seed (integer) used by the Random number generator.
pass_limit   (-1)    A bound on the number of passes per state, -1 indicates 
		     no bound. Normally, there is no reason to use this.
path         (\"\")    The search path used by the load command.
                     If path=\" pgms \\tempura\" the command `load \"file\"' will
                     search for the files: \"file.t\", \"pgms\file.t\" and
                     \"\\tempura\file.t\" (in that order).
assign_ahead (true)  If true, next values are assigned from the current state. 
time_step (0)        Minimum number of seconds between states.
They may be set to new values by entering \"set <variable> = <value>.\".

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# stringcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc stringcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "STRINGS\n" title
$TEMPURA(help) insert end \
"String constants are enclosed in double quotes, e.g. \"this is a string\".
Most of the `C' escapes may be used. For example '\\n' introduces a newline
character, and '\\\"' introduces a double quote. The character '\\' itself must be
escaped as '\\\\'.

Two strings may be appended with the `+' operator: \"abc\"+\"def\"=\"abcdef\".

Strings may be subscripted in the same way as lists. For example, if
S=\"abcdef\", then S\[2\]=\"c\" and S\[1..4\]=\"bcd\".

The length of a string is denoted by |S|. For example: |\"abcd\"|=4.

The function `ascii' returns the ascii code for the first charater of a string.
For example ascii(\"A\")=65.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# stablecomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc stablecomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "STABLE\n" title
$TEMPURA(help) insert end \
"The operator `stable' corresponds to the notion of stability (constant value).
The term \"stable I\" means that the value of I remains constant throughout the
interval. Note that \"stable I\" is equivalent to \"I gets I\". Thus, I must be
defined on the interval.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# sometimescomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc sometimescomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "SOMETIMES\n" title
$TEMPURA(help) insert end \
"The operator `sometimes' is the Tempura form of the operator <> in temporal
logic. The term \"sometimes ...\" causes the interpreter to check that  \"...\" is
true at some time in a program. Thus,

          I=0 and I gets I+1 and halt(I=10) and sometimes \{I=5\}

will succeed, whereas

          I=0 and I gets I+1 and halt(I=10) and sometimes \{I=11\}

will fail.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# skipcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc skipcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "SKIP\n" title
$TEMPURA(help) insert end \
"The predicate `skip' specifies an interval of length one (containing two
states). Thus,
                      skip and \{I=0\} and next\{I=1\}

defines an interval containing two states. I has value 0 on the first and 1 on
the second.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# semicomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc semicomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "SEMICOLON\n" title
$TEMPURA(help) insert end \
"The semicolon operator stands for sequential composition. Intuitively, the term
\"... ; ...\" means \" ... followed by ...\". Thus, the term

       \{len(3) and I=0 and I gets I+1\} ; \{len(4) and I gets I+1\}

is equivalent to

                    \{len(7) and I=0 and I gets I+1\}

The formula before the semicolon must define an interval length. For example,
the term
           \{I=0 and I gets I+1\} ; \{len(4) and I gets I+1\}

is not executable, since it is satisfied by an infinite number of behaviours.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}


# projcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc projcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "PROJ\n" title
$TEMPURA(help) insert end \
"The operator `proj' defines temporal projection. By projecting one formula onto
another, we \"insert\" an interval satisfying the first formula between each pair
of states of the second. For example,

            len(2) proj \{len(5) and I=0 and I gets I+1\}

defines an interval of length 10 in which I is incremented on each alternate
state (because an interval of length 2 has been \"inserted\" between each pair of
states of the original formula). Note that the length of the resultant interval
must be an integral multiple of the length of the first formula.

Projection of \"skip\" onto any formula leaves it unchanged.

To execute a program containing projection the system variable \"assign_ahead\"
must be false.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# prefixcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc prefixcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "PREFIX\n" title
$TEMPURA(help) insert end \
"The `prefix' of a formula is true on any prefix of an interval which satisfies
the original formula. Thus, for example the formula

                          prefix \{len (10)\}

defines an interval length of at most 10. Therefore, the Tempura program

                   len(2) and prefix \{len(10)\}

defines an interval of length 2.

To execute a program containing `prefix' the system variable \"assign_ahead\"
must be false.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# operatorscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc operatorscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "OPERATORS\n" title
$TEMPURA(help) insert end \
"The following Tempura operators and predicates are built-in:
  true            truth constant              =               equality
  false           truth constant              gets            unit delay
  empty           zero interval length        is              always equals
  skip            unit interval length        <-              assignment
  len ..          any interval length         :=              unit assignment
  and             parallel composition        stable          constant value
  implies         conditional                 more            non empty interval
  if..then..else  conditional                 halt            terminate interval
  exists .. : ..  for local variables         init            initially
  forall .. : ..  indexed conjunction         fin             finally
  always          the \[\] operator             while..do..     repetition
  sometimes       the <> operator             repeat..until.. repetition
  ;               sequential composition      for..do..       repetition
  next            the O operator              proj            projection
  wnext           the weak O operator         prefix          prefix subinterval
  keep            except on the last state    where           conjunction
  chopstar        repetition

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# nextcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc nextcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "NEXT\n" title
$TEMPURA(help) insert end \
"The operator `next' is the Tempura form of the operator O in temporal logic.
The term \"next ...\" causes \"...\" to be executed on the next state. There
MUST be a next state (cf `wnext'). Thus,

                           next \{ I=1 \}

means that the variable I has the value 1 on the next state. It fails if the
interval is empty.

This operator may also be applied to an expression, yielding its value on the
next state. Thus, the term

                  always \{if more then \{(next I)=J\}\}

is executable. It is equivalent to \"I gets J\".

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# listcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc listcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "LISTS\n" title
$TEMPURA(help) insert end \
"A Tempura list may have either fixed (static), or variable (state-varying)
length. These are defined by means of the predicates `list' and `List'.

    list(L,n) defines L to be a list of fixed size n,
    List(L,n) defines L to be a list of variable size up to a maximum of n.

These predicates apply ON THE CURRENT STATE ONLY. There is an additional predicate 
`stable(struct(L))', which keeps the list structure of variable `L' stable. So, for
example, \"List(L,5) and stable(struct(L))\" defines L to always be a list of maximum
length 5. The expression \[1,2,3,4,5\] is a list constant, with elements 1,2,3...

To access an element of a list, the notation `L\[i\]' should be used. Indexing
begins at zero. Thus, for example, if L=\[1,2,3,4\] then L\[2\]=3.

A similar notation is used to access a sublist of a list. `L\[i..j\]' denotes
a sublist of L from i to j-1. For example, \"list(L,5) and L\[1..3\]=\[1,2\]\"
assigns the values 1 and 2 to the second and third elements of the list.
The expression |L| returns the (integer) size of the list L.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# lencomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc lencomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "LEN\n" title
$TEMPURA(help) insert end \
"The `len' construct can be used to define any interval length. The term \"len(n)\"
defines an interval of length n (containing n+1 states). Thus,

                          len(0) = empty
                          len(1) = skip

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}


# keepcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc keepcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "KEEP\n" title
$TEMPURA(help) insert end \
"The operator `keep' has the intuitive meaning: \"on every state except the
last\". This operator is defined as follows:

           keep \{...\}  =def  always \{if more then \{...\}\}

Thus, the term

                        keep \{next \{I=J\}\}

is equivalent to \"I gets J\".

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# iscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc iscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "IS\n" title
$TEMPURA(help) insert end \
"The operator `is' corresponds to zero delay. The term \"I is J\" means that
the values of I and J are always equal. The term \"I is J\" is equivalent to

                        always \{I=J\}

This defines a whole sequence of values for I and J.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# initcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc initcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "INIT\n" title
$TEMPURA(help) insert end \
"The term \"init ...\" means that \"...\" must be true initially. The `init'
operator not needed in Tempura programs, because it is redundant. It is
provided for compatibility with other interpreters.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# itecomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc itecomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "IF ... THEN ... ELSE ...\n" title
$TEMPURA(help) insert end \
"The notation \"if ... then ... else ...\" represents a binary choice. This
notation may be used for both statements and expressions. For example, the term
\"A gets B\" is equivalent to

                always \{if more then (next A)=B\}

The form \"if ... then ...\" is the same as \"if ... then ... else true\" 
and is the same as \" ... implies ...\".

The expression
                 A=0 and B=(if A=1 then 3 else 4)

assigns an initial value of 4 to B.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# haltcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc haltcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "HALT\n" title
$TEMPURA(help) insert end \
"The `halt' operator defines the termination condition for an interval. For
example, the formula:

                   I=0 and I gets I+1 and halt(I=5)

defines an interval on which I is incrememted state-by-state until it equals 5.
The interval length must therefore be 5. An equivalent formula is:

                   I=0 and I gets I+1 and len 5

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# getscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc getscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "GETS\n" title
$TEMPURA(help) insert end \
"The operator `gets' corresponds to unit delay. The term \"I gets J\" means that
the value of I on the next state is always equal to the value of J on the
current state. Note that \"I gets J\" is equivalent to

                        keep \{(next I)=J\}

This defines a whole sequence of values for I.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# forallcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc forallcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "FORALL\n" title
$TEMPURA(help) insert end \
"Universal quantification is denoted by the `forall' operator. Only the bounded form

                      forall i<n:\{ ... \}

is permitted in Tempura. Semantically, universal quantification corresponds to
\"indexed concurrency\". The term

     forall i<n:\{ p(i) \}    is equivalent to    p(0) and ... and p(n-1).

For example,

                      forall i<|L|:\{ L\[i\]=0 \}

sets all the elements of the list L to zero on the first state.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# whilecomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc whilecomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "WHILE, REPEAT, CHOPSTAR and FOR\n" title
$TEMPURA(help) insert end \
"The `while', `repeat' and `for' operators define sequential loops in the usual
way. The following forms may be used:

             while <condition> do \{ ... \}
             repeat \{ ... \} until <expression>
             chopstar \{ ... \}
             for <variable> < <integer expression> do \{ ... \}
             for <variable> in <list/string expression> do \{ ... \}
             for <integer expression> times do \{ ... \}

`chopstar \{ ... \}' is equal to `while true do \{ ... \}'.

For example, the formulae

             lis=\[0,1,2\] and for i<3 do \{skip and output(lis\[i\])\}
and
             lis=\[0,1,2\] and for e in lis do \{skip and output(e)\}

are equivalent. Note that the control variable of a `for' loop should be
static.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# fincomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc fincomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "FIN\n" title
$TEMPURA(help) insert end \
"The term \"fin ...\" means that \"...\" must be true on the last state of the
interval. Thus, the formula

                  len(5) and keep \{I=0\} and fin \{I=1\}

defines an interval of length 5 for which I is 1 on the last state, and
zero on every other state. Be aware that `fin' is NOT the same as `halt'.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# exprcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc exprcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "EXPRESSIONS\n" title
$TEMPURA(help) insert end \
"Expressions are composed of variables, constants and operators. The following
is a list of operators which may occur within expressions:

true             truth constant           +,-,*,div,mod,** arithmetic operators
false            truth constant           \"..\"             string constants
empty            zero interval length     ascii(..)        code for string char
and              logical conjunction      \[..\]             lists and subscripts
or               logical disjunction      |..|             list size
not              logical negation         f(..)            function call
if..then..else   conditional              lambda(..) : ..  lambda expression
exists .. : ..   existence                ref              address of
forall .. : ..   indexed conjunction      deref            contents of
next             on the next state        type             type of
=,~=,<,<=,>=,>   relational operators     more             non empty interval
random           random number>=0 (static within a state)
Random           Random number>=0 (can change within a state)

See help `variables' for a description of variables and their types.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# existscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc existscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "EXISTS\n" title
$TEMPURA(help) insert end \
"Existential quantification is denoted in Tempura by the `exists' operator.
Semantically, existential quantification corresponds to the introduction of
local variables. For example, in the term

        exists I,J:\{I=0 and J=1 and exists I:\{I=J and ...\} and ...\}

there are two instances of the variable I. The outer one has initial value 0,
the inner one has initial value 1.

The bounded existential quantification:

                       exists i<|L|:( L\[i\]=0 )

is equivalent to

                       not (forall i<|L|:not (L\[i\]=0))

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# equalcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc equalcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "EQUALITY\n" title
$TEMPURA(help) insert end \
"The operator `=' defines equality in the usual way. However, because the value
of a state variable is defined to be its value on the first state of an
interval, the term \"I=0\" only means that I has value zero ON THE FIRST STATE.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# emptycomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc emptycomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "EMPTY and MORE\n" title
$TEMPURA(help) insert end \
"The predicate `empty' specifies an interval of length zero (containing just one
state). Thus,
                           empty and I=0

defines an interval containing one state on which I has the value zero.

The predicate `more' is defined as the non zero interval, i.e., empty = not more.

One may also use `empty' or 'more' as an expression. For example, the term

                     always \{if more
                             then output(\"not the last state\")
                             else output(\"the last state\")\}

prints out whether or not each state is the final state of an interval.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# assigncomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc assigncomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "ASSIGNMENT\n" title
$TEMPURA(help) insert end \
"The operator `<-' corresponds to assignment. The term \"I <- J\" means that
the value of I on the last state is equal to the value of J on the first
state. Note that \"I <- J\" is equivalent to

                     exists x:\{ x=J and fin \{I=x\}\}

This defines a single value for I.

"

$TEMPURA(help) insert end "UNIT ASSIGNMENT\n" title
$TEMPURA(help) insert end \
"The operator `:=' corresponds to unit assignment. The term \"I := J\" means that
the value of I on the next state is equal to the value of J on the current
state. Note that \"I := J\" is equivalent to \"(next I) = J\".

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# andcomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc andcomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "AND\n" title
$TEMPURA(help) insert end \
"The logical conjunction operator `and' may be used to compose formulae in parallel. 
For example, the conjunction   

     len 5 and always \{I=0\} and always \{J=1\}

causes the terms \"len 5\", \"always \{I=0\}\", and \"always \{J=1\}\" to be executed concurrently. 
That is, it defines a new interval of length 5 on which I is always 0 and J is always 1.

Boolean expressions may also be combined with `and' in the usual way:

           A=true and B=false and C=(A and B)

sets C to false.

"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# alwayscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc alwayscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "ALWAYS\n" title

$TEMPURA(help) insert end \
"The operator `always' is the Tempura form of the operator \[\] in temporal logic.
The term \"always ...\" causes \"...\" to be executed on every state. Thus,

                           always \{ I=1 \}

means that the variable I always has the value 1. Note that a term such as

                           always \{ next \{ I=1 \}\}

cannot be successfully executed, since the `next' operator implies an interval
having more than one state, and this cannot be executed on the last state of an
interval. However, the term

                  always \{if more then \{next \{I=1\}\}\}

is executable. It is equivalent to \"I gets 1\".
 
"
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}

# commandscomm --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc commandscomm {} {
  variable TEMPURA 

$TEMPURA(help) delete 1.0 end

$TEMPURA(help) insert end "SYSTEM COMMANDS\n" title

$TEMPURA(help) insert end "The following system commands are available:\n" 
$TEMPURA(help) insert end " \n " 

$TEMPURA(help) insert end \
" load \"file\".              Execute the commands in \"file.t\" (note extension).
  define <f/p> = <body>.    Define a function/procedure. 
  run <program>.            Run a Tempura program.
  input <expression>.       Input the value of an expression.
  output <expression>.      Output the value of an expression.
  peek <expression>.        Output expression (or \? if undefined).
  format (<expn list>).     Formatted output.
  set <sysid> = <value>.    Set a system variable (see `help system').
  break.                    Call the interpreter recursively (from a program).
  showtrace.                Display the execution stack and environment.
  continue.                 Continue execution (following break).
  step.                     Advance execution one step (following break).
  jump.                     Step to next statement at current reduction depth.
  return.                   Exit from a recursive call of the interpreter.
  abort.                    Return to the outermost level of Tempura.
  exit.                     Exit from the Tempura system.
  
  "
$TEMPURA(help) insert end "Index" {demo demo-indexcomm}

}


$TEMPURA(help) tag configure title -foreground red -font $TEMPURA(HelvBig)

$TEMPURA(help) tag configure demospace -lmargin1 1c -lmargin2 1c
if {[winfo depth .] == 1} {
    $TEMPURA(help) tag configure demo -lmargin1 1c -lmargin2 1c \
	-underline 1
    $TEMPURA(help) tag configure visited -lmargin1 1c -lmargin2 1c \
	-underline 1

} else {
    $TEMPURA(help) tag configure demo -lmargin1 1c -lmargin2 1c \
	-foreground  blue -underline 1
    $TEMPURA(help) tag configure visited -lmargin1 1c -lmargin2 1c \
	-foreground #303080 -underline 1

}
$anatempura::TEMPURA(help) tag bind demo <ButtonRelease-1> {
    anatempura::invoke [$anatempura::TEMPURA(help) index {@%x,%y}]
}
set lastLine ""
$anatempura::TEMPURA(help) tag bind demo <Enter> {
    set lastLine [$anatempura::TEMPURA(help) index {@%x,%y linestart}]
    $anatempura::TEMPURA(help) config -cursor hand2
}
$anatempura::TEMPURA(help) tag bind demo <Leave> {
    $anatempura::TEMPURA(help) config -cursor xterm
}
$anatempura::TEMPURA(help) tag bind demo <Motion> {
    set newLine [$anatempura::TEMPURA(help) index {@%x,%y linestart}]
    if {[string compare $newLine $lastLine] != 0} {
	set lastLine $newLine

	set tags [$anatempura::TEMPURA(help) tag names {@%x,%y}]
	set i [lsearch -glob $tags demo-*]
	if {$i >= 0} {
	}
    }
}


# indexcomm --
#
#   ADD COMMENTS HERE
#   Create the text for the text widget.
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc indexcomm {} {
  variable TEMPURA
$TEMPURA(help) delete 1.0 end
$TEMPURA(help) insert end "Tempura Help Index\n" title

$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Commands" {demo demo-commandscomm}
$TEMPURA(help) insert end           "                       " {demospace}
$TEMPURA(help) insert end "Halt" {demo demo-haltcomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "Projection" {demo demo-projcomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Always" {demo demo-alwayscomm}
$TEMPURA(help) insert end         "                         " {demospace}
$TEMPURA(help) insert end "If then else" {demo demo-itecomm}
$TEMPURA(help) insert end               "                   " {demospace}
$TEMPURA(help) insert end "Semicolon" {demo demo-semicomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "And" {demo demo-andcomm}
$TEMPURA(help) insert end      "                            " {demospace}
$TEMPURA(help) insert end "Init" {demo demo-initcomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "Skip" {demo demo-skipcomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Assignment" {demo demo-assigncomm}
$TEMPURA(help) insert end             "                     " {demospace}
$TEMPURA(help) insert end "Is" {demo demo-iscomm}
$TEMPURA(help) insert end     "                             " {demospace}
$TEMPURA(help) insert end "Sometimes" {demo demo-sometimescomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Empty" {demo demo-emptycomm}
$TEMPURA(help) insert end "                          " {demospace}
$TEMPURA(help) insert end "Keep" {demo demo-keepcomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "Stable" {demo demo-stablecomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Exists" {demo demo-existscomm}
$TEMPURA(help) insert end         "                         " {demospace}
$TEMPURA(help) insert end "Len" {demo demo-lencomm}
$TEMPURA(help) insert end      "                            " {demospace}
$TEMPURA(help) insert end "String" {demo demo-stringcomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Expression" {demo demo-exprcomm}
$TEMPURA(help) insert end             "                     " {demospace}
$TEMPURA(help) insert end "List" {demo demo-listcomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "System" {demo demo-systemcomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "For, Repeat, While" {demo demo-whilecomm}
$TEMPURA(help) insert end                     "             " {demospace}
$TEMPURA(help) insert end "Next" {demo demo-nextcomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "Variables" {demo demo-variablescomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Forall" {demo demo-forallcomm}
$TEMPURA(help) insert end         "                         " {demospace}
$TEMPURA(help) insert end "Operators" {demo demo-operatorscomm}
$TEMPURA(help) insert end            "                      " {demospace}
$TEMPURA(help) insert end "Where" {demo demo-wherecomm}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end " \n " {demospace}
$TEMPURA(help) insert end "Gets" {demo demo-getscomm}
$TEMPURA(help) insert end       "                           " {demospace}
$TEMPURA(help) insert end "Prefix" {demo demo-prefixcomm}
$TEMPURA(help) insert end         "                         " {demospace}
$TEMPURA(help) insert end "Wnext" {demo demo-wnextcomm}
$TEMPURA(help) insert end " \n " {demospace}

}


$TEMPURA(help) configure -state normal
indexcomm
$TEMPURA(help) configure -state disabled
}




}; # end of namespace anatempura

namespace eval visual {;
#namespace export -clear *
#############################################################################
# Visual Tcl v1.10 Project
#
  global term_spawn_id

proc Window {args} {
#global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if {$exists} {wm withdraw $newname; return} }
        iconify { if {$exists} {wm iconify $newname; return} }
        destroy { if {$exists} {destroy $newname; return} }
    }
}

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
#    wm focusmodel $base passive
    wm geometry $base 122x26+0+0
    wm maxsize $base 1137 870
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "AnaTempura"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top18 {base} {

    global term_spawn_id     
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background LightGrey 
#    wm focusmodel $base passive
    wm geometry $base 680x440+1+380
    wm maxsize $base 1137 870
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "AnaTempura"
    frame $base.cpd20 \
        -background LightGrey -borderwidth 1 -height 30 -relief raised \
        -width 30 


    menubutton $base.cpd20.01 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background LightGrey \
        -foreground black \
        -menu .top18.cpd20.01.02 \
        -padx 4 -pady 3 -text File \
        -font $anatempura::TEMPURA(HelvBig) -width 8


    menu $base.cpd20.01.02 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 0 

    $base.cpd20.01.02 add command \
         -label New -font $anatempura::TEMPURA(HelvBig) \
         -command {anatempura::newfile }
    $base.cpd20.01.02 add command \
         -label Open -font $anatempura::TEMPURA(HelvBig) \
         -command {anatempura::openfile }
    $base.cpd20.01.02 add separator 
    $base.cpd20.01.02 add command \
         -label Reload -font $anatempura::TEMPURA(HelvBig) \
         -command {anatempura::reload }
#    $base.cpd20.01.02 add command \
#         -label Setdir -font $anatempura::TEMPURA(HelvBig) \
#         -command {anatempura::setdir }
    $base.cpd20.01.02 add command \
         -label "Save Output" -font $anatempura::TEMPURA(HelvBig) \
         -command {anatempura::savefile }
    $base.cpd20.01.02 add separator
    $base.cpd20.01.02 add command \
         -label "Clear Output" -font $anatempura::TEMPURA(HelvBig) \
         -command {tkterm::o_clearnc }
    $base.cpd20.01.02 add command \
         -label "Clear Buffer" -font $anatempura::TEMPURA(HelvBig) \
         -command {$tkterm::term delete 1.0 {end -1 lines} }
    $base.cpd20.01.02 add separator
    $base.cpd20.01.02 add command \
        -label Exit -font $anatempura::TEMPURA(HelvBig) \
        -command { exp_send -i $term_spawn_id -- "exit.\r"}
        
    menubutton $base.cpd20.03 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background LightGrey \
        -foreground black \
        -menu .top18.cpd20.03.04\
        -padx 4 -pady 3 -text Edit \
        -font $anatempura::TEMPURA(HelvBig) -width 8

    menu $base.cpd20.03.04 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 1 

    menubutton $base.cpd20.05 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background LightGrey \
        -foreground  black \
        -menu .top18.cpd20.05.06 \
        -padx 4 -pady 3 -text Check \
        -font $anatempura::TEMPURA(HelvBig) -width 8

    menu $base.cpd20.05.06 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 1 

   menubutton $base.cpd20.07 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background LightGrey \
        -foreground black \
        -menu .top18.cpd20.07.08 \
        -padx 4 -pady 3 -text Run \
        -font $anatempura::TEMPURA(HelvBig) -width 8

    menu $base.cpd20.07.08 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 1

    menubutton $base.cpd20.09 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background  LightGrey \
        -foreground black \
        -menu .top18.cpd20.09.10 \
        -padx 4 -pady 3 -text Help \
        -font $anatempura::TEMPURA(HelvBig) -width 8 

    menu $base.cpd20.09.10 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 0 

    $base.cpd20.09.10 add command \
         -label Tempura -font $anatempura::TEMPURA(HelvBig) \
         -command {anatempura::helptempura }
    $base.cpd20.09.10 add separator
    $base.cpd20.09.10 add command \
         -label About -font $anatempura::TEMPURA(HelvBig) \
         -command {visual::Window show .top21 }

    menubutton $base.cpd20.11 \
        -relief groove \
        -textvar anatempura::TEMPURA(file_lbl) \
        -anchor w \
        -state disabled \
        -background LightGrey \
        -disabledforeground black \
        -foreground black \
        -padx 4 -pady 3  \
        -font $anatempura::TEMPURA(HelvBig) -width 25

    
    menubutton $base.cpd20.12 \
        -relief flat \
        -anchor w \
        -activebackground LightGrey \
        -background  LightGrey \
        -foreground black \
        -menu .top18.cpd20.12.13 \
        -padx 4 -pady 3 -text Control \
        -font $anatempura::TEMPURA(HelvBig) -width 8

    menu $base.cpd20.12.13 -relief raised \
        -background LightGrey \
        -foreground black \
        -tearoff 1 

    $base.cpd20.12.13 add command \
         -label Step -font $anatempura::TEMPURA(HelvBig) \
         -command {tkterm::step }
    $base.cpd20.12.13 add command \
         -label Start -font $anatempura::TEMPURA(HelvBig) \
         -command {tkterm::run }
    $base.cpd20.12.13 add command \
         -label Stop -font $anatempura::TEMPURA(HelvBig) \
         -command {tkterm::stop }
#    $base.cpd20.12.13 add separator
#    $base.cpd20.12.13 add command \
#         -label Dismiss -font $anatempura::TEMPURA(HelvBig) \
#         -command {destroy .top23}
#    $base.cpd20.12.13 add command \
#         -label New -font $anatempura::TEMPURA(HelvBig) \
#         -command {visual::Window show .top23 }
    



    frame $base.cpd22 \
        -background LightGrey \
        -borderwidth 1 -height 400 -relief sunken \
        -width 169 

    scrollbar $base.cpd22.01 \
        -background LightGrey \
        -borderwidth 1 \
        -command {.top18.cpd22.03 xview} -orient horiz \
        -troughcolor LightGrey \
        -width 10 
    scrollbar $base.cpd22.02 \
        -background LightGrey -borderwidth 1 \
        -command [list $base.cpd22.03 yview] -orient vert \
        -troughcolor LightGrey \
        -width 10
    text $base.cpd22.03 \
        -background white \
        -cursor xterm -borderwidth 3 \
        -relief sunken -font $anatempura::TEMPURA(HelvBig) \
        -wrap none \
        -foreground black \
        -height $tkterm::rows \
        -insertbackground black \
        -selectbackground black \
        -selectforeground LightGrey \
        -width $tkterm::cols \
        -xscrollcommand {.top18.cpd22.01 set} \
        -yscrollcommand [list $base.cpd22.02 set]
    

    scrollbar $base.cpd22.04 \
        -background LightGrey -borderwidth 1 \
        -command {.top18.cpd22.06 xview} -orient horiz \
        -troughcolor LightGrey \
        -width 10 
    scrollbar $base.cpd22.05 \
        -background LightGrey -borderwidth 1 \
        -command [list $base.cpd22.06 yview] -orient vert \
        -troughcolor LightGrey \
        -width 10
    text $base.cpd22.06 \
        -background white \
        -cursor xterm -borderwidth 3 \
        -relief sunken -font $anatempura::TEMPURA(HelvBig) \
        -wrap none -state disabled \
        -foreground black \
        -height $tkterm::o_rows \
        -insertbackground black \
        -selectbackground black \
        -selectforeground LightGrey \
        -width $tkterm::o_cols \
        -xscrollcommand {.top18.cpd22.04 set} \
        -yscrollcommand [list $base.cpd22.05 set] 

     scrollbar $base.cpd22.07 \
        -background LightGrey -borderwidth 1 \
        -command {.top18.cpd22.09 xview} -orient horiz \
        -troughcolor LightGrey \
        -width 10 
    scrollbar $base.cpd22.08 \
        -background LightGrey -borderwidth 1 \
        -command [list $base.cpd22.09 yview] -orient vert \
        -troughcolor LightGrey \
        -width 10
    text $base.cpd22.09 \
        -background white \
        -cursor xterm -borderwidth 3 \
        -relief sunken -font $anatempura::TEMPURA(HelvBig) \
        -wrap none -state disabled \
        -foreground black \
        -height $tkterm::e_rows \
        -insertbackground black \
        -selectbackground black \
        -selectforeground LightGrey \
        -width $tkterm::e_cols \
        -xscrollcommand {.top18.cpd22.07 set} \
        -yscrollcommand [list $base.cpd22.08 set] 

 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.cpd20 \
        -in .top18 -anchor center -expand 0 -fill x -side top 
    pack $base.cpd20.01 \
        -in .top18.cpd20 -anchor center -expand 0 -fill none -side left 
    pack $base.cpd20.03 \
        -in .top18.cpd20 -anchor center -expand 0 -fill x -side left 
    pack $base.cpd20.05 \
        -in .top18.cpd20 -anchor center -expand 0 -fill x -side left
    pack $base.cpd20.07 \
        -in .top18.cpd20 -anchor center -expand 0 -fill x -side left
    pack $base.cpd20.12 \
        -in .top18.cpd20 -anchor center -expand 0 -fill x -side left
    pack $base.cpd20.11 \
        -in .top18.cpd20 -anchor center -expand 1 -fill both -side left
    pack $base.cpd20.09 \
        -in .top18.cpd20 -anchor center -expand 0 -fill none -side right 
     

    pack $base.cpd22 \
        -in .top18 -anchor center -expand 1 -fill both -side top 
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
    grid $base.cpd22.01 \
        -in .top18.cpd22 -column 0 -row 5 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd22.02 \
        -in .top18.cpd22 -column 1 -row 4 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd22.03 \
        -in .top18.cpd22 -column 0 -row 4 -columnspan 1 -rowspan 1 \
        -sticky nesw
    grid $base.cpd22.04 \
        -in .top18.cpd22 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd22.05 \
        -in .top18.cpd22 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd22.06 \
        -in .top18.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw
  #  grid $base.cpd22.07 \
  #      -in .top18.cpd22 -column 0 -row 3 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd22.08 \
        -in .top18.cpd22 -column 1 -row 2 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd22.09 \
        -in .top18.cpd22 -column 0 -row 2 -columnspan 1 -rowspan 1 \
        -sticky nesw
}


proc vTclWindow.top20 {base} {
 

    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background LightGrey
#    wm focusmodel $base passive
    wm geometry $base 680x360+1+1
    wm maxsize $base 1137 870
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Help Tempura"

    frame $base.cpd22 \
        -background LightGrey -borderwidth 1 -height 291 -relief sunken \
        -width 169 

    text $base.cpd22.03 \
        -background white \
        -cursor xterm -borderwidth 3\
        -relief sunken -font $anatempura::TEMPURA(HelvBig)\
        -wrap none \
        -foreground black -height 22 -insertbackground black \
        -selectbackground black -selectforeground LightGrey -width 80 
 
    button $base.b -background LightGrey -foreground black \
    -text "Dismiss" -font $anatempura::TEMPURA(HelvBig)\
    -command {destroy .top20} 
        
    ###################
    # SETTING GEOMETRY
    ###################
    
        
    pack $base.cpd22 \
        -in .top20 -anchor center -expand 1 -fill both -side top 
    pack $base.b \
        -in .top20 -anchor center -expand 1 -fill y -side top 
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
    grid $base.cpd22.03 \
        -in .top20.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
}

proc vTclWindow.top21 {base} {
    

    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background LightGrey
#    wm focusmodel $base passive
    wm geometry $base 680x360+1+1
    wm maxsize $base 1137 870
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "About AnaTempura"

    frame $base.cpd22 \
        -background LightGrey -borderwidth 1 -height 291 -relief sunken \
        -width 169
    text $base.cpd22.03 \
        -background white \
        -cursor xterm -borderwidth 3\
        -relief sunken -state disabled\
        -wrap none -font $anatempura::TEMPURA(HelvBig)\
        -foreground black -height 22 -insertbackground black \
        -selectbackground black -selectforeground LightGrey -width 80
    button $base.b -background LightGrey -foreground black \
    -text "Dismiss" -font $anatempura::TEMPURA(HelvBig)\
    -command {destroy .top21}

 
    pack $base.cpd22 \
        -in .top21 -anchor center -expand 1 -fill both -side top 
    pack $base.b \
        -in .top21 -anchor center -expand 1 -fill y -side top 
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
    grid $base.cpd22.03 \
        -in .top21.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw

  .top21.cpd22.03 configure -state normal
  .top21.cpd22.03 insert end \
"AnaTempura v$anatempura::TEMPURA(version) : GUI for Tempura.

Copyright (C) 1998-2007 Antonio Cau.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
  "
    .top21.cpd22.03 configure -state disabled   
 


}

proc vTclWindow.top23 {base} {
    

    if {$base == ""} {
        set base .top23
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background LightGrey
#    wm focusmodel $base passive
    wm geometry $base 680x345+1+1
    wm maxsize $base 1137 870
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Simulation"
    frame $base.cpd22 \
        -background LightGrey -borderwidth 1 -height 410 -relief sunken \
        -width 600
    scrollbar $base.cpd22.01 \
        -background LightGrey -borderwidth 1 \
        -command {.top23.cpd22.03 xview} -orient horiz -troughcolor LightGrey \
        -width 10 
    scrollbar $base.cpd22.02 \
        -background LightGrey -borderwidth 1 \
        -command [list $base.cpd22.03 yview] -orient vert -troughcolor LightGrey \
    -width 10
    canvas $base.cpd22.03 \
        -background white \
        -cursor xterm -borderwidth 3\
        -relief sunken \
        -height 290 -insertbackground black \
        -selectbackground black -selectforeground LightGrey -width 600 \
        -xscrollcommand {.top23.cpd22.01 set} \
        -yscrollcommand [list $base.cpd22.02 set] 

    
#    button $base.b -background LightGrey -foreground black \
#    -text "Dismiss" -font $anatempura::TEMPURA(HelvBig)\
#    -command {destroy .top23} -width 8  
#    button $base.c -background LightGrey -foreground black \
#    -text "Step" -font $anatempura::TEMPURA(HelvBig)\
#    -command {tkterm::step} -width 8
#    button $base.d -background LightGrey -foreground black \
#    -text "Start" -font $anatempura::TEMPURA(HelvBig)\
#    -command {tkterm::run} -width 8
#    button $base.e -background LightGrey -foreground black \
#    -text "Stop" -font $anatempura::TEMPURA(HelvBig)\
#    -command {tkterm::stop} -width 8
    ###################
    # SETTING GEOMETRY
    ###################
    
        
    pack $base.cpd22 \
        -in .top23 -anchor center -expand 1 -fill both -side top 
#    pack $base.b \
#        -in .top23 -anchor center -expand 1 -fill y -side left 
#    pack $base.c \
#        -in .top23 -anchor center -expand 1 -fill y -side left
#    pack $base.d \
#        -in .top23 -anchor center -expand 1 -fill y -side left 
#    pack $base.e \
#        -in .top23 -anchor center -expand 1 -fill y -side left
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
    grid $base.cpd22.01 \
        -in .top23.cpd22 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd22.02 \
        -in .top23.cpd22 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd22.03 \
        -in .top23.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
}




}; # end of namespace visual









namespace eval tkterm {;
#namespace export -clear *

variable term; 
variable rows           ;# number of rows
variable cols           ;# number of columns
variable cmd            ;
variable point          ;
variable event          ;
variable saveCmd        ;


variable o_term; 
variable o_rows           ;# number of rows
variable o_cols           ;# number of columns
variable stepper;
variable run;

variable e_term; 
variable e_rows           ;# number of rows
variable e_cols           ;# number of columns



# run --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc run {} {
  variable stepper;
  variable run;

  set run 1;
  set stepper $stepper;
}

# stop --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc stop {} {
  variable stepper;
  variable run;

  set run 0;
  set stepper $stepper;
}


# step --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc step {} {
  variable stepper;
  variable run;

 set stepper 1
 set run 0

}


# break --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc tbreak {} {
  variable  stepper;
  variable  run;

  update
    if {$run == 0} {
     tkwait variable tkterm::stepper
    }

}


proc insert {c} {
    variable cmd
    variable point

    set cmd [linsert $cmd $point $c]
    incr point
}

proc backspace {} {
    variable cmd
    variable point

    if {0 < $point} {
        incr point -1
        set cmd [lreplace $cmd $point $point]
    }

    return
}

proc right {} {
    variable cmd
    variable point

    if {$point < [llength $cmd]} {
        incr point 1
    }

    return
}

proc left {} {
    variable point

    if {0 < $point} {
        incr point -1
    }

    return
}


proc up {} {
    variable cmd
    variable point
    variable event
    variable saveCmd
    variable term

    # If we're leaving event 1 (the new command) save it.

    if {$event == 1} {
        set saveCmd [join $cmd ""]
    }

    # Erase this command and get the previous event.

    control-u
    if {[expr {1 - [history keep]}] < $event} {
        incr event -1
    }
    set cmd [history event $event]
    $term insert insert $cmd
    $term see insert
    set cmd [split $cmd {}]
    set point [llength $cmd]

#    return
}

proc enter {} {
#    puts ""
#    return -code break
}

proc control-u {} {
    variable cmd
    variable point
    variable term

    while {$point > 0} {
         $term mark set insert insert-1c
        incr point -1
    }
    $term delete insert end
    $term insert end "\n"
    $term see end
    set cmd {}

    return
}

proc down {} {
    variable cmd
    variable point
    variable event
    variable saveCmd
    variable term

    # Erase this command and get the next event.

    if {$event == 1} {
        return
    }
    control-u
    incr event
    if {$event == 1} {
        set cmd $saveCmd
    } else {
        set cmd [history event $event]
    }

    $term insert insert $cmd
    $term see insert
    set cmd [split $cmd {}]
    set point [llength $cmd]

}


# exit is called if the spawned process exits
proc o_ext {} {
	exit
}

proc o_clearnc {} {
	variable o_term 
        
        $o_term configure -state normal
	$o_term delete 1.0 {end -1 lines}
        $o_term configure -state disabled
	
        
}

proc o_insert {s} {
	variable o_term 

        $o_term configure -state normal
        $o_term insert end $s
        $o_term see end
        $o_term configure -state disabled
        update idletasks   
}


proc o_tinsert {s} {
	variable o_term 

        $o_term configure -state normal
        $o_term insert end $s tempu
        $o_term see end
        $o_term configure -state disabled
        update idletasks   
}

proc e_insert {s} {
	variable e_term 

        $e_term configure -state normal
        $e_term insert end $s
        $e_term see end
        $e_term configure -state disabled
        update idletasks   
}


proc e_tinsert {s} {
	variable e_term 

        $e_term configure -state normal
        $e_term insert end $s tempu
        $e_term see end
        $e_term configure -state disabled
        update idletasks   
}


}; # end of namespace tkterm




# Namespace tkproggy --
#
#   ADD COMMENTS HERE
#
namespace eval tkproggy {;
#namespace export -clear *

  global proggy_id term_spawn_id ext_id



# start --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc start {id nl} {
  global ext_id
  
  exp_send -i $ext_id($id) -- "$nl$anatempura::TEMPURA(prog_end)"
  update idletasks 
}

proc startveri {id nl} {
  global ext_id
  
  exp_send -i $ext_id($id) -- "$nl;$anatempura::TEMPURA(prog_end)"
  update idletasks 
}

proc startdot {id} {
  global ext_id
  exp_send -i $ext_id($id) -- ".$anatempura::TEMPURA(prog_end)"
  update idletasks 
}
proc startfinish {id} {
  global ext_id
  exp_send -i $ext_id($id) -- "\$finish;$anatempura::TEMPURA(prog_end)"
  update idletasks 
}
proc startstop {id time} {
  global ext_id
  exp_send -i $ext_id($id) -- "#$time \$stop;$anatempura::TEMPURA(prog_end)"
  update idletasks 
}
# tbreak --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc tbreak {nl} {
   global term_spawn_id

   set vname [lindex $nl 0]
   
   set totnl [lrange $nl 1 end-1]
   
  

   set tot ""
   foreach i $totnl {
    
    set tottemp [string trimleft $i]
    
    set totstring ",\"$tottemp\""
    
    set tot $tot$totstring
    
   }
   set tot "\[\"$vname\"$tot\].\r"
   
#   set dval  [string trimleft [lindex $nl 1]]
#   set tval  [string trimleft [lindex $nl 2]]
   
#   exp_send -i $term_spawn_id -- "\[\"$vname\",\"$dval\",\"$tval\"\].\r"
   exp_send -i $term_spawn_id -- $tot
   update idletasks
}

}; # end of nameespace tkproggy



proc init {argc argv} {
global env

set anatempura::TEMPURA(text)     {.top18.cpd22.03}
set anatempura::TEMPURA(output)   {.top18.cpd22.06}
set anatempura::TEMPURA(external) {.top18.cpd22.09}
set anatempura::TEMPURA(input)    {.top19.cpd19.02}
set anatempura::TEMPURA(help)     {.top20.cpd22.03}
set anatempura::TEMPURA(out)      {.top23.cpd22.03}
set anatempura::TEMPURA(step)             0
set anatempura::TEMPURA(version)         "2.00"
set anatempura::TEMPURA(tempura_version) "2.13"
set anatempura::TEMPURA(base_file)       ""
set anatempura::TEMPURA(tempura_file)    ""
set anatempura::TEMPURA(file_tcl)        ""

set anatempura::TEMPURA(tempura_path)    ""
set anatempura::TEMPURA(file_lbl) "  <untitled>"



if [string equal $::tcl_platform(platform) "windows"] { 
set anatempura::TEMPURA(newline)         ""
set anatempura::TEMPURA(tempura_editor)  "notepad"
set anatempura::TEMPURA(HelvBig)         "systemfixed"
set anatempura::TEMPURA(tempura_dir)     "Examples"
set anatempura::TEMPURA(java)            "c:/Program Files/Java/jdk1.6.0/bin/java.exe"
set anatempura::TEMPURA(javac)           "c:/Program Files/Java/jdk1.6.0/bin/javac.exe"
set anatempura::TEMPURA(gcc)             "c:/MinGW/bin/gcc.exe"
set anatempura::TEMPURA(veriwell)        ""
set anatempura::TEMPURA(tempura_exe)     "tempura.exe"
set anatempura::TEMPURA(rc_file)         "$env(HOME)/.anatempurarc"
set anatempura::TEMPURA(prog_end)        "\r"
set anatempura::TEMPURA(prog_exe)        ".exe"
} else {
set anatempura::TEMPURA(wave)            "gtkwave"
set anatempura::TEMPURA(rc_file)         "$env(HOME)/.anatempurarc"
set anatempura::TEMPURA(tempura_editor)  "vi"
set anatempura::TEMPURA(newline)         "\r"
set anatempura::TEMPURA(HelvBig)         "-*-screen-bold-r-*-*-12-*-*"
set anatempura::TEMPURA(tempura_dir)     "/usr/local/share/tempura/Examples"
set anatempura::TEMPURA(java)            "/bin/java"
set anatempura::TEMPURA(javac)           "/bin/javac"
set anatempura::TEMPURA(gcc)             "/opt/csw/gcc3/bin/gcc"
set anatempura::TEMPURA(veriwell)        "/usr/local/bin/veriwell"
set anatempura::TEMPURA(tempura_exe)     "tempura"
set anatempura::TEMPURA(prog_end)        "\n"
set anatempura::TEMPURA(prog_exe)        ""
}
set tkterm::rows   5		;# number of rows in term
set tkterm::o_rows 10		;# number of rows in o_term
set tkterm::e_rows 5		;# number of rows in e_term
set tkterm::cols   80		;# number of columns in term
set tkterm::o_cols 80		;# number of columns in o_term
set tkterm::e_cols 80		;# number of columns in e_term
set tkterm::stepper 0;
set tkterm::run     0;

set tkterm::term $anatempura::TEMPURA(text)	;# name of tkterm text widget 
set tkterm::o_term $anatempura::TEMPURA(output) ;# name of tkterm output widget
set tkterm::e_term $anatempura::TEMPURA(external) ;# name of tkterm external widget

set env(LINES) $tkterm::rows
set env(COLUMNS) $tkterm::cols

set tkterm::cmd {}
set tkterm::point 0
set tkterm::event 1

}

init $argc $argv 

set veri 0
#set cmd "";

log_user 0

# start tempura and text widget for its output
set stty_init "-tabs"
eval exp_spawn [file nativename $anatempura::TEMPURA(tempura_exe)]
set term_spawn_id $spawn_id
stty raw
if [string equal $::tcl_platform(platform) "unix"] {
stty rows $tkterm::rows columns $tkterm::cols < $spawn_out(slave,name)
}
set proggy_id {}


#tk_setPalette LightGrey
visual::Window show .
visual::Window show .top18
#visual::Window show .top23
anatempura::init
set send_human {.1 .3 1 .05 2}
set send_slow  {1 .001}

$tkterm::o_term tag configure tempu -foreground blue
$tkterm::e_term tag configure tempu -foreground blue
#exp_internal -f test 1
#strace 4



proc main {argc argv} {
global term_spawn_id proggy_id cmd veri nop_id ext_id

#expect -exact "Tempura: Interval Temporal Logic interpreter\r
#\r
#Copyright (C) 1987  Roger Hale\r
#\r
#This program is free software; you can redistribute it and/or modify\r
#it under the terms of the GNU General Public License as published by\r
#the Free Software Foundation; either version 2 of the License, or\r
#(at your option) any later version.\r
#\r
#This program is distributed in the hope that it will be useful,\r
#but WITHOUT ANY WARRANTY; without even the implied warranty of\r
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\r
#GNU General Public License for more details.\r
#\r
#You should have received a copy of the GNU General Public License\r
#along with this program; if not, write to the Free Software\r
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\r
#\r
#Current maintainers:\r
#  Antonio Cau,    cau@dmu.ac.uk\r
#  Ben Moszkowski, benm@dmu.ac.uk\r
#\r
#C-Tempura (Version $anatempura::TEMPURA(tempura_version))\r
#\r
#Tempura 1% "

#tkterm::o_insert "C-Tempura (Version $anatempura::TEMPURA(tempura_version)): Interval Temporal Logic interpreter\n\n"
#tkterm::o_insert "Copyright (C) 1987  Roger Hale\n\n"
#tkterm::o_insert "This program is free software; you can redistribute it and/or modify\n"
#tkterm::o_insert "it under the terms of the GNU General Public License as published by\n"
#tkterm::o_insert "the Free Software Foundation; either version 2 of the License, or\n"
#tkterm::o_insert "(at your option) any later version.\n\n"
#tkterm::o_insert "This program is distributed in the hope that it will be useful,\n"
#tkterm::o_insert "but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
#tkterm::o_insert "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
#tkterm::o_insert "GNU General Public License for more details.\n\n"
#tkterm::o_insert "You should have received a copy of the GNU General Public License\n"
#tkterm::o_insert "along with this program; if not, write to the Free Software\n"
#tkterm::o_insert "Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA\n\n"
#tkterm::o_insert "Current maintainers:    Antonio Cau,    cau@dmu.ac.uk\n"
#tkterm::o_insert "                        Ben Moszkowski, benm@dmu.ac.uk\n\n"
#tkterm::o_tinsert "Tempura 1% " 

set nop_id $term_spawn_id

bind $tkterm::term <Any-Enter> {
	focus %W
}

bind $tkterm::term <KeyPress> {
    if {"%A" != "{}"} {

        tkterm::insert %A
    }
}

bind $tkterm::term <Control-c>	{
    if {"%A" != "{}"} {
                exp_send -i $term_spawn_id -- %A
    }
}

bind $tkterm::term <Control-u>	{
                tkterm::control-u
}

bind $tkterm::term <Return> {
                tkterm::enter 
                set tkterm::cmd [join $tkterm::cmd ""]
                exp_send -i $term_spawn_id -- "$tkterm::cmd\r"
                history add $tkterm::cmd
                set tkterm::cmd {}
                set tkterm::point 0
}


bind $tkterm::term <Meta-p> {
      tkterm::up
}

bind $tkterm::term <BackSpace>  {
                tkterm::backspace
}

bind $tkterm::term <Meta-n>  {
                tkterm::down
} 

bind $tkterm::term <Left>  {
                tkterm::left
} 

bind $tkterm::term <Right>  {
                tkterm::right
}

#bind $tkterm::term <Button-1>  {
#                tk_popup .top18.cpd20.01.02 %X %Y
#}

bind $tkterm::term <Button-2>  {
                tk_popup .top18.cpd20.12.13 %X %Y
}

bind $tkterm::term <Button-3>  {
                tk_popup .top18.cpd20.07.08 %X %Y
}


#bind $tkterm::o_term <Button-1>  {
#                tk_popup .top18.cpd20.01.02 %X %Y
#}

bind $tkterm::o_term <Button-2>  {
                tk_popup .top18.cpd20.12.13 %X %Y
}

bind $tkterm::o_term <Button-3>  {
                tk_popup .top18.cpd20.07.08 %X %Y
}

#bind $anatempura::TEMPURA(out) <Button-1>  {
#                tk_popup .top18.cpd20.01.02 %X %Y
#}

#bind $anatempura::TEMPURA(out) <Button-2>  {
#                tk_popup .top18.cpd20.12.13 %X %Y
#}

#bind $anatempura::TEMPURA(out) <Button-3>  {
#                tk_popup .top18.cpd20.07.08 %X %Y
#}


#trap {send_user "seggy"} SIGSEGV
#trap {send_user "bussy"} SIGBUS


set timeout -1
match_max -i $term_spawn_id 4000
expect -i $term_spawn_id  -re "^Tempura \[0-9\]*%+ " {
   # prompt
   #$tkterm::term insert end [string trimleft $expect_out(0,string) "Tempura "]\n
   #$tkterm::term see end
   tkterm::o_tinsert "$expect_out(0,string)"
   update idletasks
   exp_continue             
   } -i $term_spawn_id  -re "^\[\x5b]\[^\x2e\]+\[\x5d]\[\x2e]$anatempura::TEMPURA(newline)\n" {
   #         
   update idletasks
   exp_continue
   } -i $term_spawn_id -indices -re "^(State\[^:]+: )?!TCL: (\[a-z_A-Z\]+) (\[\-0-9a-z_A-Z:\]+):$anatempura::TEMPURA(newline)\n" { 
   #
   if { [file exists $anatempura::TEMPURA(file_tcl)]} {
     if {$expect_out(2,string) == "init"} {
     source $anatempura::TEMPURA(file_tcl)
     visual::Window show .top23
     set out::canv $anatempura::TEMPURA(out)
     set tkterm::stepper 0;
     set tkterm::run     0;
     out::init [split $expect_out(3,string) ":"]
     } else {
      out::$expect_out(2,string) [split $expect_out(3,string) ":"] 
     }
    }
   update idletasks
   exp_continue      
   }  -i $term_spawn_id  -indices -re "^(State\[^:]+: )?!TCL: break :$anatempura::TEMPURA(newline)\n" { 
   # breakpoint for tempura program
   tkterm::tbreak
   update idletasks
   exp_continue       
   }  -i $term_spawn_id  -indices -re "^(State\[^:]+: )?!E: prog(\[0-9\]) (\[\-0-9_a-zA-Z:\]+):$anatempura::TEMPURA(newline)\n" {
   #
   tkproggy::start $expect_out(2,string) [split $expect_out(3,string) ":"]
   update idletasks
   exp_continue       
   } -i $term_spawn_id  -indices -re "^(State\[^:]+: )?!E: veri(\[0-9\]) (\[\-0-9_a-zA-Z<=#\x20\]+):$anatempura::TEMPURA(newline)\n" {
   #
   set tstop [string range $expect_out(3,string) 0 3]
   set ttime [string range $expect_out(3,string) 4 end]
   if {$expect_out(3,string) == "dot"} {
     tkproggy::startdot $expect_out(2,string)
    } elseif  {$expect_out(3,string) == "finish"} {
      tkproggy::startfinish $expect_out(2,string)
    } elseif  {$tstop == "stop"} {
      tkproggy::startstop $expect_out(2,string) $ttime
    } else { tkproggy::startveri $expect_out(2,string) $expect_out(3,string) }
   update idletasks
   exp_continue       
   } -i $term_spawn_id "^$anatempura::TEMPURA(newline)\n" {
   #
   tkterm::o_insert "\n"
   update idletasks
   exp_continue             
   } -i $term_spawn_id  -re "^((State\[^:]+: )|(\[ ]*))% Xin=\\?$anatempura::TEMPURA(newline)\n" {
   #
   update idletasks
   exp_continue
   }  -i $term_spawn_id  -re "^((State\[^:]+: )|(\[ ]*))% (\[\-a-z_A-Z0-9\]|\[\x5b]|\[\x5d])+=\\?" {
   #
   tkterm::o_tinsert "$expect_out(0,string)"
   update idletasks
   exp_continue
   } -i $term_spawn_id -indices -re "^(\[^\x01-\x1f]+)$anatempura::TEMPURA(newline)\n" {
   # 
   tkterm::o_insert "$expect_out(1,string)\n"
   update idletasks
   exp_continue             
   } -i $term_spawn_id eof {
   #
   tkterm::o_ext
   } -i proggy_id "^\x07" {
   # 
   update idletasks
   exp_continue
   } -i proggy_id "^$anatempura::TEMPURA(newline)\n" {
   # 
   tkterm::e_insert "\n"
   #$tkterm::term see end
   update idletasks
   exp_continue             
   }  -i proggy_id -indices -re "^(\[^!\x01-\x1f]+)$anatempura::TEMPURA(newline)\n" {
   # 
   tkterm::e_insert "$expect_out(1,string)\n"
   #$tkterm::term see end
   update idletasks
   exp_continue             
   }  -i proggy_id -indices -re "^!PROG: assert (\[\-0-9_a-zA-Z:\x20\]+)!$anatempura::TEMPURA(newline)\n" { 
   #  
   tkproggy::tbreak [split $expect_out(1,string) ":"]
   update idletasks
   exp_continue        
   }  -i proggy_id -re "^!" {
   # 
   tkterm::e_insert $expect_out(0,string)
   #$tkterm::e_term see end
   update idletasks
   exp_continue             
   } -i proggy_id  eof  {
   # 
   #update idletasks
   set er [exp_wait -i $expect_out(spawn_id)]
   #if {$veri==0} { 
   #  update idletasks
   #} 
   #lreplace $proggy_id end end
   set index [lsearch $proggy_id $expect_out(spawn_id)]
   #set proggy_id {}
   set proggy_id [lreplace $proggy_id $index $index]
   tkterm::e_insert "Done.\n"
   #$tkterm::e_term see end
   set nop_id $term_spawn_id
   update idletasks
   exp_continue
   } 

}


main $argc $argv
