/* parser.h:  parser definitions
 * Copyright (C) 1987  Roger Hale
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: parser.h,v 2.11 2007/05/03 09:48:45 acau Exp $
 */

# define END 0
# define NIL 1
# define BOOL 2
# define INT 3
# define LAMBDA 4
# define STRING 5
# define LIST 6
# define STATE 7
# define STATIC 8
# define EMPTY 9
# define SKIP 10
# define AND 11
# define iAND 12
# define OR 13
# define NOT 14
# define IF 15
# define CALL 16
# define iCALL 17
# define EXISTS 18
# define iEXISTS 19
# define PROCESS 20
# define iPROCESS 21
# define PREFIX 22
# define iPREFIX 23
# define FORALL 24
# define THE 25
# define ALWAYS 26
# define SOMETIME 27
# define HALT 28
# define INIT 29
# define FIN 30
# define KEEP 31
# define NEXT 32
# define WNEXT 33
# define LEN 34
# define iLEN 35
# define LT 36
# define LE 37
# define EQ 38
# define GE 39
# define GT 40
# define NEQ 41
# define GETS 42
# define STB 43
# define WHERE 44
# define IS 45
# define ASSN 46
# define UASSN 47
# define SEMI 48
# define iSEMI 49
# define WHILE 50
# define REPEAT 51
# define FOR 52
# define iFOR 53
# define FORTIMES 54
# define iFORTIMES 55
# define FORIN 56
# define iFORIN 57
# define PROJ 58
# define iPROJ 59
# define INPUT 60
# define OUTPUT 61
# define PLUS 62
# define MINUS 63
# define MULT 64
# define DIV 65
# define MOD 66
# define POWER 67
# define UPLUS 68
# define UMINUS 69
# define MAKELIST 70
# define TYPE 71
# define STRUCT 72
# define SIZE 73
# define SUB 74
# define SUBLIST 75
# define FIXLIST 76
# define VARLIST 77
# define REFER 78
# define DEREF 79
# define LOC 80
# define RUN 81
# define EXIT 82
# define LOAD 83
# define DEFINE 84
# define SET 85
# define SHOWTRACE 86
# define SHOWMEM 87
# define ABORT 88
# define BREAK 89
# define RETURN 90
# define CONTINUE 91
# define LEAP 92
# define STEP 93
# define PEEK 94
# define FORMAT 95
# define ASCII 96
# define HELP 97
# define SYSTEM 98
# define iSYSTEM 99
# define PASSLIMIT 100
# define VERBOSITY 101
# define PRINTLEVEL 102
# define DEBUGLEVEL 103
# define STATEPRINT 104
# define REDUNDANCY 105
# define CALLBYNAME 106
# define ASSIGNAHEAD 107
# define PATH 108
# define HELPDIR 109
# define TIMESTEP 110
# define RANDOM 111
# define RANDSEED 112
# define RRANDOM 113
# define RRANDSEED 114
# define MAXRANDLEN 115
# define IMPLIES 116
# define MORE 117
# define CHOPSTAR 118
# define iIF 119
# define UNDEFINED 120

# define SHOWSTATE 121

# define COMMA 122

# define TRUE 123
# define FALSE 124
# define NAME 125
# define THEN 126
# define ELSE 127
# define IN 128
# define TIMES 129
# define ENV 130
# define BND 131
# define TO 132
# define DO 133
# define LPAREN 134
# define RPAREN 135
# define LBRACE 136
# define RBRACE 137
# define LBRACK 138
# define RBRACK 139
# define BAR 140
# define UNTIL 141
# define MEMBLOCK 142


#define MAXREDUCETOKEN COMMA
#define MAXTOKEN MEMBLOCK

#define MQS MAXTOKEN+1
#define STL MQS+1
#define N1 STL+1
#define IDN N1+1
