/* system.h:  system definitions
 * Copyright (C) 1987  Roger Hale
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: system.h,v 2.11 2007/05/03 09:48:45 acau Exp $
 */
#include <config.h>
#include <stdio.h>
#include <ctype.h>
#include <setjmp.h>
#include <signal.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "parser.h"
#include "tempura.h"
#include "globals.h"


#ifdef _AIX
#   define WAIT_STATUS_TYPE pid_t
#else
#ifndef NO_UNION_WAIT
#   define WAIT_STATUS_TYPE union wait
#else
#   define WAIT_STATUS_TYPE int
#endif
#endif

#define free_mem(A) if (A != NULL) free (A)

#define resetin(F) if (feof(F)) {(F)->_cnt=0;(F)->_flag^=_IOEOF;}
/*#define resetin(F)*/

#define MAXSYSVAR 9
#define HASHTABLESIZE 100

/* For the VAX, SUN, etc: */
#define MAXSYMBOLTABLESIZE 1000
#define MAXHEAPSIZE 10000
#define GLOBALMEMSIZE 2000
#define MAXENVSTACKSIZE 400
#define MAXREDUCESTACKSIZE 1000
#define MAXTOKENSIZE 256
#define MAXFILENAMESIZE 256
#define MAXINTSIZE 20
#define FILENAMESEP '/'
#define FX ".t"
#define HELPSUMMARY "summary"

/* For the PC:
#define MAXSYMBOLTABLESIZE 300
#define MAXHEAPSIZE 3200
#define GLOBALMEMSIZE 200
#define MAXENVSTACKSIZE 100
#define MAXREDUCESTACKSIZE 100
#define MAXTOKENSIZE 257
#define MAXFILENAMESIZE 40
#define MAXINTSIZE 20
#define FILENAMESEP '\\'
#define FX ".t"
#define HELPSUMMARY "summary"
#define CNTRL_C 0x23
#define INTERRUPTSTACK 128
*/
